GNU bug report logs - #66394
29.1; Make register-read-with-preview more useful

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Thierry Volpiatto <thievol@HIDDEN>; dated Sat, 7 Oct 2023 19:07:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 2 Dec 2023 10:54:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 02 05:54:32 2023
Received: from localhost ([127.0.0.1]:56760 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r9Ndn-00066d-LW
	for submit <at> debbugs.gnu.org; Sat, 02 Dec 2023 05:54:32 -0500
Received: from mail.eshelyaron.com ([107.175.124.16]:37154 helo=eshelyaron.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1r9Ndm-00066V-2e
 for 66394 <at> debbugs.gnu.org; Sat, 02 Dec 2023 05:54:31 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=eshelyaron.com;
 s=mail; t=1701514460;
 bh=GkOh/TnRRrMDy2H0Z/Fge14wGOTnOQ+mA35KC5Qn+oc=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=Tn8PTlHhnoNa4yMVJKnfR6Dt7F6CvZEtkq9xR7raRchw+SgiVQHx3NGpDcgE1XZgV
 BF5CyrTMt1zknBI9TSxY0a2ohH1Ayh4DTrYZwia6Bzxgf+bdweOiM662CjJsmKE2IE
 hxUrkW2GBJ19Ey3K1VdY04/E/G4RMprgulLocHf4VkKgAi84iuRvi3+cWzIVx9sDc8
 DECX6j0SqztEFIkFwjb8SXXffK2EF+7GRNLJh8QV41GzHQrNib1AnPcxwttkXjMYXV
 GRQWO9Zbi5pCca9Gy29/aXGcmKmcsRxE6SJUqitkqhjxng0BAQH9NbkYugymb0bWpq
 nJRPWlJxDJKDw==
From: Eshel Yaron <me@HIDDEN>
To: Bastien Guerry <bzg@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87plzo3n5o.fsf@HIDDEN> (Bastien Guerry's message of "Sat, 02 Dec
 2023 11:37:55 +0100")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN> <87v89hufbw.fsf@HIDDEN>
 <87zfytdj86.fsf@HIDDEN> <87plzo3n5o.fsf@HIDDEN>
Date: Sat, 02 Dec 2023 11:54:17 +0100
Message-ID: <m1y1ec27ty.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 66394
Cc: jonas@HIDDEN, Michael Heerdegen <michael_heerdegen@HIDDEN>,
 stefankangas@HIDDEN, Thierry Volpiatto <thievol@HIDDEN>,
 66394 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Bastien Guerry <bzg@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>>> - C-x r s would display the preview and copy the region to the "b"
>>>   register as soon as the "b" key is hit (using read-key).
>>
>> I suggest you use M-n RET instead if you want to be sure you don't
>> overwrite a register.
>
> What I am suggesting is to store the register _as soon as_ the user
> hits the "b" key.
>
> Since the recent changes, I need to hit one additional keystroke for
> zero benefit, which is a net less when you use registers a lot.
>
> I use "a", "b", "c" registers for quick copy and paste and can easily
> remember them; when I need more, I use register-list.el.
>
>> It is what it is doing actually with minibuffer.  Hitting "a" highlight
>> register "a" and send a message "overwriting register", then you can hit
>> RET if you want to overwrite.
>
> This might be useful in some cases. I don't suggest to change this. I
> suggest to allow the previous behavior for empty registers.
>
>> I think using read-key+minibuffer would be very complicated and would
>> need much more code, this for a small benefit: Saving one key (RET).
>
> I would say this is not a small benefit.

FWIW, I second Bastien's request to restore the existing behavior as the
default, or at least provide it as an option.  I think Michael requested
that as well in the beginning of this thread.

This patch brings some nice benefits, but it also presents a regression
in terms of UX, perhaps we could avoid that or make it opt-in?  It would
also be great if there were a NEWS entry that clearly describes the user
visible changes.


Thanks,

Eshel




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 2 Dec 2023 10:38:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 02 05:38:51 2023
Received: from localhost ([127.0.0.1]:56702 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r9NOc-00033c-Vd
	for submit <at> debbugs.gnu.org; Sat, 02 Dec 2023 05:38:51 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:41480)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bzg@HIDDEN>) id 1r9NOZ-00033M-Ql
 for 66394 <at> debbugs.gnu.org; Sat, 02 Dec 2023 05:38:49 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <bzg@HIDDEN>)
 id 1r9NOI-00042F-K8; Sat, 02 Dec 2023 05:38:30 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:Date:References:In-Reply-To:Subject:To:
 From; bh=LtB/pbJCpVo2tN2Fkwq8OrTnf8jRvMqE2Ell+oVwum0=; b=cUqHSA0gjxSecczz1MJa
 IE0WLNNC2dsW90tcls6BJBq7I4mIruZ+rN9kSbtBKWqRjRRujbSqU3BNCkz95dIMQR114UuoO8G1P
 5aMPPT0nsbEb8BklQlXuSczCbU8Wsy2adSTLTJi2tzbCX9SPGjj4Ub43r4/ue3HGqHy9nAijKZpke
 aXxN6C6HYAxxppGToa9wUi3urlTq/dC//Whwp5AEdCM3tAqcuTmyF5sSVRvNWVRpFiLs3aiK7O1Bm
 ClHXr9XY5Mt/NPn2favzzQWIffHbt4ypcddA3+uewQAZPYZYqsxxO1MB16IpMvNrF4HWDFaW+XDzP
 X8bQfB67b7Zw6w==;
From: Bastien Guerry <bzg@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87zfytdj86.fsf@HIDDEN> (Thierry Volpiatto's message of "Sat, 
 02 Dec 2023 09:52:41 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN> <87v89hufbw.fsf@HIDDEN>
 <87zfytdj86.fsf@HIDDEN>
Date: Sat, 02 Dec 2023 11:37:55 +0100
Message-ID: <87plzo3n5o.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, jonas@HIDDEN,
 66394 <at> debbugs.gnu.org, stefankangas@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Thierry,

thanks for your anwer.

Thierry Volpiatto <thievol@HIDDEN> writes:

>> - C-x r s would display the preview and copy the region to the "b"
>>   register as soon as the "b" key is hit (using read-key).
>
> I suggest you use M-n RET instead if you want to be sure you don't
> overwrite a register.

What I am suggesting is to store the register _as soon as_ the user
hits the "b" key.

Since the recent changes, I need to hit one additional keystroke for
zero benefit, which is a net less when you use registers a lot.

I use "a", "b", "c" registers for quick copy and paste and can easily
remember them; when I need more, I use register-list.el.

> It is what it is doing actually with minibuffer.  Hitting "a" highlight
> register "a" and send a message "overwriting register", then you can hit
> RET if you want to overwrite.

This might be useful in some cases. I don't suggest to change this. I
suggest to allow the previous behavior for empty registers.

> I think using read-key+minibuffer would be very complicated and would
> need much more code, this for a small benefit: Saving one key (RET).

I would say this is not a small benefit.

> Also I think hitting RET in any case is better as it does a kind of
> "confirm I want to do this".

IMHO confirmation is good for cases where mistakes can have bad
consequences.  I don't see them when using an empty register.

> Also using read-key leads to bug like we had previously as we must mimic
> a keymap which is often wrong.

I know there are always trade-offs. I just wanted to report the slight
"eww" moment I had wrt this UX change, which I still think is wrong.

If we set this issue aside, I wonder if read-key could be augmented so
that certain keystrokes let the user enter in "editing mode" (a bit
like when users hit C-s then C-e to edit the search string.) I can see
several situations where a read-key prompt would benefit from allowing
to switch to a minibuffer prompt with all the flexibility it provides:

- Allowing for confirmation when overwriting a register is one;

- Allowing to hit two keystrokes to facilitate navigation for C-h:
  e.g. `C-h k l' would list keybindings; `C-h k d` would describe a
  keybinding, etc.

This touches explorations that perhaps Jonas made while designing
transient, so I'm adding him to this conversation.
  
-- 
 Bastien Guerry




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 2 Dec 2023 09:53:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 02 04:53:09 2023
Received: from localhost ([127.0.0.1]:56653 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r9MgP-00056U-5x
	for submit <at> debbugs.gnu.org; Sat, 02 Dec 2023 04:53:09 -0500
Received: from mout02.posteo.de ([185.67.36.66]:41047)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r9MgK-00055y-CV
 for 66394 <at> debbugs.gnu.org; Sat, 02 Dec 2023 04:53:08 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id B3C6F240104
 for <66394 <at> debbugs.gnu.org>; Sat,  2 Dec 2023 10:52:48 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1701510768; bh=aEqEJkzyVstcGkGJ8JF7ZiNSqNsZIArBMA6YMTfacg0=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=nBAoo4rZ6/jmuRXHMr69dNSBbqTzLeZyMz3alU7JHggYoXgt9ObbyezLnJ4mAfhk7
 zsqSLBa7U6XlrWk4xoLyA1DmT/6Kkyvo5bAXThRVHKOxuRgSDpIVtRg/CgIz0Ir4G7
 jk2kkFNs2yweljru66BxplgDWqK779sQEKbfMxmCNh7EdeRbTgmic/J+iAhDpf5XsU
 CSqAWGC6DiuoyXQKeMnXrGNvrxAPtWvkmDYjUjrGDvUKqjDoH704OKpswmkqUfe95D
 lvYDVfmJsqG4iYKOzAFh8ogd6gDgxYmOCtdhP2eHYB2/0dBPoJ8PFlCiAmi9Hc6uEa
 yQ6he+vomc9WQ==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4Sj4ws3Hl2z6ty6;
 Sat,  2 Dec 2023 10:52:44 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Bastien <bzg@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87v89hufbw.fsf@HIDDEN> (Bastien's message of "Sat, 02 Dec 2023
 10:24:51 +0100 (15 minutes, 42 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN> <87v89hufbw.fsf@HIDDEN>
Date: Sat, 02 Dec 2023 09:52:41 +0000
Message-ID: <87zfytdj86.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, 66394 <at> debbugs.gnu.org,
 stefankangas@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Bastien <bzg@HIDDEN> writes:

> I use registers ~100 times a day, so enhancements here are very
> welcome, thanks!
>
> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> A minibuffer is used now instead of read-key.
>
> I wonder about this, though. It badly hinders my usual flow, where I
> do remember what registers I use and like to store new ones quickly.
>
> When a register is empty, I believe it's more efficient to just read
> the key and store the content in the register directly.
>
> E.g. if the "a" contains "A string" and "b" is an empty register:
>
> - C-x r s would display the preview and copy the region to the "b"
>   register as soon as the "b" key is hit (using read-key).

I suggest you use M-n RET instead if you want to be sure you don't
overwrite a register.
Also don't forget you can now use C-n/p or <up>/<down> to navigate in previ=
ew.

> - C-x r s would display the preview and if the user hits "a", it will
>   warn about overwriting the existing register and RET can confirm.

It is what it is doing actually with minibuffer.  Hitting "a" highlight
register "a" and send a message "overwriting register", then you can hit
RET if you want to overwrite.

> This supposes using read-key by default and switch to using a
> minibuffer when the user hits keys for existing registers.
>
> What do you think?

I think using read-key+minibuffer would be very complicated and would
need much more code, this for a small benefit: Saving one key (RET).
Also I think hitting RET in any case is better as it does a kind of
"confirm I want to do this".
Also using read-key leads to bug like we had previously as we must mimic
a keymap which is often wrong.

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVq/mkTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkww1C/4/OV42MVSNxUOABRKViWUOXWu3rmcE
OZ4Jy9RmzR5LjOmCuam5ANMO9GAuBb0gzkZTBKbLQ+Ckm8gG3fdIf8E5W4xVFwK4
/difhvIsq1iQb3ZUikxypZw57iKTFAPAVRMQkmwE7sgM+1Ja5bnKaoX4b/1wcpMD
c4H7aHFx6R6ri8gpR6tLmuhSMBVGT2lb3VYyR1umiXCINTsDy7gvdr1Byje7zWxA
iVYc69MdUjwp04E2lKhVjOKol/7Pc9l8bTUmklDpA8YqGxQh9mXL8H3zFbMTcFt5
qHsyoZ5oPFfHaMzyE50zum/lNL5dlUk6XuQWNTcIvwMyFOoGvhJeRTcbjkOhFW23
eWHgznwyA6xtq9DCewFk6A3pwL3AhfewAuFrWih+HN0GCHRx6D4YtMQbrHn+BaAE
Br7YnkggWf8lGY/xsIvFDx2FOJUdpI8divkxSOxRantDPaYYI/16mm2b04Vb0DJl
YEYdM6yKk+w2TPduKIgRcooZJhIbua5h5S4=
=wchH
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 2 Dec 2023 09:26:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 02 04:26:02 2023
Received: from localhost ([127.0.0.1]:56634 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r9MG9-0001hq-KV
	for submit <at> debbugs.gnu.org; Sat, 02 Dec 2023 04:26:01 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:59798)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bzg@HIDDEN>) id 1r9MG5-0001hb-8l
 for 66394 <at> debbugs.gnu.org; Sat, 02 Dec 2023 04:26:00 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <bzg@HIDDEN>)
 id 1r9MFn-0000GX-Lx; Sat, 02 Dec 2023 04:25:41 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:Date:References:In-Reply-To:Subject:To:
 From; bh=X6+vlKP1YwmP3S6hoJTsx0KiiMNdVDquIs6iUd/wB0k=; b=SalyPy4Vqpu/HxWs5yuc
 ebN1Bq16HXoSJQFGiuWC0XmJAdZq4D1ycNHY+mE8XZw2iz0tABTQVvyLw5CMez0QROcbj+clhMhD2
 3PG+1JgJ1rwKqIWu5iK32b1rNtqvf1VkEF4rpo+6TGYo6Y6LBuXoORhheEeU+kBfDI1n+yLRBLMXh
 +F04AOJ2eqxxdIQbfjTi1u3EzFOMcc3sZ7GMkJx40EmBhvUg1nwCxlydsxVW7hg2nNcbJOvCqjMn+
 uDJjS2HZfCT4at0F9BJo+M8qYaQK1y0T1BLgD5LLIQ1ZLIszzrMp7x94KxxLPCk1yUSsc3vtL7Zpv
 41a/tdfIn66xZQ==;
From: Bastien <bzg@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <877cmdx8ud.fsf@HIDDEN> (Thierry Volpiatto's message of "Mon, 
 20 Nov 2023 06:00:26 +0000")
Organization: GNU
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN>
Date: Sat, 02 Dec 2023 10:24:51 +0100
Message-ID: <87v89hufbw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, 66394 <at> debbugs.gnu.org,
 stefankangas@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

I use registers ~100 times a day, so enhancements here are very
welcome, thanks!

Thierry Volpiatto <thievol@HIDDEN> writes:

> A minibuffer is used now instead of read-key.

I wonder about this, though. It badly hinders my usual flow, where I
do remember what registers I use and like to store new ones quickly.

When a register is empty, I believe it's more efficient to just read
the key and store the content in the register directly.

E.g. if the "a" contains "A string" and "b" is an empty register:

- C-x r s would display the preview and copy the region to the "b"
  register as soon as the "b" key is hit (using read-key).

- C-x r s would display the preview and if the user hits "a", it will
  warn about overwriting the existing register and RET can confirm.

This supposes using read-key by default and switch to using a
minibuffer when the user hits keys for existing registers.

What do you think?

-- 
 Bastien




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 2 Dec 2023 08:08:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 02 03:08:57 2023
Received: from localhost ([127.0.0.1]:56615 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r9L3Z-00087q-G6
	for submit <at> debbugs.gnu.org; Sat, 02 Dec 2023 03:08:57 -0500
Received: from mout02.posteo.de ([185.67.36.66]:59963)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r9L3V-00087Y-9p
 for 66394 <at> debbugs.gnu.org; Sat, 02 Dec 2023 03:08:56 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 0DBA3240104
 for <66394 <at> debbugs.gnu.org>; Sat,  2 Dec 2023 09:08:37 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1701504518; bh=pvN336nznVVmjo4bUiA7UXTSwwECUW3GTyJPZNp0TBA=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=IejP/B18TADMAcCLzGFh6PCagCsUcNSSKh6LkbW7iagV7QIRDFPCGir3EW6MzkU8E
 CB7SLbGxdJdn+nMvZd+8VfCqm3a14z1OD3OJkqN7LPVmsxuv0wVvvfLrjL500zgMrm
 5TAfLP+xPW7rO4mM5vmfHlvemsizWacm37BM2O+8uMr0G3hgNymGq6HNurlzgTujkS
 vxpIL9NRse+hvw5ZeFAaZhNMtlZS8Eaum7ts1Kb4gkDLlJndoe3cRIXldiHc4fsgSx
 g/pUZvK6qCQ94aNz5AO211OFWTVd5Qwnt8J7Jeu4NPoTyPfEnIGnZilsmjOVChBBoY
 6rWSE2VF9NzwQ==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4Sj2cg5ZLhz6tvd;
 Sat,  2 Dec 2023 09:08:35 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <83plzp82mb.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 02 Dec
 2023 09:50:20 +0200 (17 minutes, 56 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
 <83bkbc7j1o.fsf@HIDDEN> <8734wov2wv.fsf@HIDDEN>
 <83v89j6arv.fsf@HIDDEN> <87cyvpf8y6.fsf@HIDDEN>
 <83plzp82mb.fsf@HIDDEN>
Date: Sat, 02 Dec 2023 08:08:33 +0000
Message-ID: <875y1hf2m6.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Thierry Volpiatto <thievol@HIDDEN>
>> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
>> Date: Sat, 02 Dec 2023 05:51:45 +0000
>>=20
>> Eli Zaretskii <eliz@HIDDEN> writes:
>>=20
>> > Anyway, I trust you to do what is needed here, I just want the test
>> > suite to keep running successfully, and I don't have time to work on
>> > this myself.  TIA.
>>=20
>> Here again the patchs (0002 with a little modification).
>> Let me know if I can commit them.
>
> Please install on the master branch, and thanks.

Done, thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVq5gETHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvky7rDACiHcvqWR8+Rc99wtGVkDwOdYx2xX6y
72Xdh0P3voRIkqmjb3WkOs3FMDiwTF+Xc57sZAcurZ+a9o0D6GduK0WmwkvrT4kD
XGuDUhZMcc3NtpXQ62RIjG3PMACgJ7bmw7bwNYX5DjRFnqYDRbINs9P4qH0cwk/2
MkK+Ok/gQESotkUOFpo6KhKPRXp+DRWwR012FUYfoAtnHX0pJ01ieTXZNZqk6Yr3
9ruU3TEM5uKd1ZGSPDtYEEwCphsdSIBcCBOOGhP5osOHsBF7ExXIeNG8Ev2Ka1Wi
Bx0HqmC3XHvPzadBn2niHwchude8vBkKEw6Nl+O0LiRSBX0h0oe6r/bSYofkKqdT
0slMhwcFnsr845TKZpWJwFpqTdGaWiu5O9Xd8UJHGbdEopIibhimRYFZok8Lrm5z
xglPoKCXpFPfPyRn/O+mu7BMKbtR+VTkSkhSDNNkFjh8UuxEN7r23l2/hSB2OSPX
a9/kpLJ3bGm7QDDjFtmi5oXnRFqS8MW7H0c=
=0QOJ
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 2 Dec 2023 07:50:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 02 02:50:42 2023
Received: from localhost ([127.0.0.1]:56599 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r9Klu-0007gp-27
	for submit <at> debbugs.gnu.org; Sat, 02 Dec 2023 02:50:42 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:53210)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1r9Klr-0007gc-V9
 for 66394 <at> debbugs.gnu.org; Sat, 02 Dec 2023 02:50:41 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1r9Kla-00077W-3u; Sat, 02 Dec 2023 02:50:22 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=l8ljnxb3HnTVYMcB8dQyuI9jw56NkJzkKJDJbASQdPs=; b=LwZW+bBOpdZJ
 1dImPe8IwxO4xPJjDTUJhvI5WTyHBDbFO+KoJIOQ4J6GIeoN2CaT3k9hpX/8Asi80HFSFWy5728OV
 81g5dlNr1HG3lmrhM2qA1CuDZxOwqyePLQRRQCl32fmisEXykNQ8fSP94oq6IFAj/Q13v8Cq2Jp6j
 unlnWI9s48YVmoNA1k3M8GhZ3+l2hVpPVcEYteIt9gYEJM1Ie54qfskGMm1o0nZyGop41NwyyknBx
 if4n/n1p5mw8TZnmINxMsLutnqVOnKqG3vCHsDx2u7SE7Eph9rb/UcwsawuYNA0Gv2S0cicUJzPWn
 o3mZBPpoqttQgX9jXbFO+w==;
Date: Sat, 02 Dec 2023 09:50:20 +0200
Message-Id: <83plzp82mb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <87cyvpf8y6.fsf@HIDDEN> (message from Thierry Volpiatto on
 Sat, 02 Dec 2023 05:51:45 +0000)
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
 <83bkbc7j1o.fsf@HIDDEN> <8734wov2wv.fsf@HIDDEN>
 <83v89j6arv.fsf@HIDDEN> <87cyvpf8y6.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Thierry Volpiatto <thievol@HIDDEN>
> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
> Date: Sat, 02 Dec 2023 05:51:45 +0000
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Anyway, I trust you to do what is needed here, I just want the test
> > suite to keep running successfully, and I don't have time to work on
> > this myself.  TIA.
> 
> Here again the patchs (0002 with a little modification).
> Let me know if I can commit them.

Please install on the master branch, and thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 2 Dec 2023 05:52:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 02 00:52:13 2023
Received: from localhost ([127.0.0.1]:56517 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r9IvE-0004VB-JM
	for submit <at> debbugs.gnu.org; Sat, 02 Dec 2023 00:52:13 -0500
Received: from mout01.posteo.de ([185.67.36.65]:57273)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r9Iv9-0004Ub-8b
 for 66394 <at> debbugs.gnu.org; Sat, 02 Dec 2023 00:52:11 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id 2CE3E240027
 for <66394 <at> debbugs.gnu.org>; Sat,  2 Dec 2023 06:51:52 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1701496312; bh=Dgu3l8Oy4iQKqUIzwG7pUGwlmAoekqZog1e5BohZAm8=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=csLF9uOt3FHlAPXIm4m6W77rFxUdbtjur1KocTNp2PsK+ikfZ695kfiYt4YatkCTz
 ue/ndukTMNafPBdZkT1BmxkCzcMUQTsknlw9RUmMYUAiNUEIBPnYbonPA+TwVptzER
 8TtzdUi6VaL7KQsJk+ytQnlIF5sg+8AyRNdRJ67DxKESnfPbgQDrtOuiDO6OV3rpdS
 CCIKDLQnHelCa58d193UsbsRqAcmR/Ubi/V1N6wlFkRoEzFui1M63Jd30zP90+cYAd
 Y0OECIpKPfBkJ7AmqVakNQjraSbEm22PA1HUtiPg1qvQNIPoZMcyKaGY6ziJf+7JcT
 3s5B55LchapyA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4ShzZr4BVMz6twf;
 Sat,  2 Dec 2023 06:51:48 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <83v89j6arv.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 30 Nov
 2023 08:00:20 +0200 (1 day, 23 hours, 41 minutes ago)")
References: <87il7ib6cu.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
 <83bkbc7j1o.fsf@HIDDEN> <8734wov2wv.fsf@HIDDEN>
 <83v89j6arv.fsf@HIDDEN>
Date: Sat, 02 Dec 2023 05:51:45 +0000
Message-ID: <87cyvpf8y6.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="==-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--==-=-=
Content-Type: multipart/mixed; boundary="=-=-="

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Eli Zaretskii <eliz@HIDDEN> writes:

> Anyway, I trust you to do what is needed here, I just want the test
> suite to keep running successfully, and I don't have time to work on
> this myself.  TIA.

Here again the patchs (0002 with a little modification).
Let me know if I can commit them.

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0001-Make-register-preview-delay-obsolete.patch
Content-Transfer-Encoding: quoted-printable

From=203df81fb5dc5809cab7843e5358c17d0039b55eb1 Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 08:03:45 +0100
Subject: [PATCH 1/4] Make register-preview-delay obsolete

* etc/NEWS: Update.
* lisp/register.el (register-preview-delay): Make it obsolete.
=2D--
 etc/NEWS         | 5 +++++
 lisp/register.el | 2 +-
 2 files changed, 6 insertions(+), 1 deletion(-)

diff --git a/etc/NEWS b/etc/NEWS
index 6661ac70e1b..bab3529339f 100644
=2D-- a/etc/NEWS
+++ b/etc/NEWS
@@ -1138,6 +1138,11 @@ showcases all their customization options.
 
 * Incompatible Lisp Changes in Emacs 30.1
=20
+---
+** 'register-preview-delay' is no longer used.
+Register preview is no more delayed.  If you want to disable it use
+'register-use-preview' instead with a boolean value.
+
 +++
 ** 'M-TAB' now invokes 'completion-at-point' also in Text mode.
 Text mode no longer binds 'M-TAB' to 'ispell-complete-word', and
diff --git a/lisp/register.el b/lisp/register.el
index 61bef503f91..88d0e8e1d10 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -93,7 +93,6 @@ of the marked text."
   :type '(choice (const :tag "None" nil)
 		 (character :tag "Use register" :value ?+)))
=20
=2D;; FIXME: This is no more needed, remove it.
 (defcustom register-preview-delay 1
   "If non-nil, time to wait in seconds before popping up register preview =
window.
 If nil, do not show register previews, unless `help-char' (or a member of
@@ -101,6 +100,7 @@ If nil, do not show register previews, unless `help-cha=
r' (or a member of
   :version "24.4"
   :type '(choice number (const :tag "No preview unless requested" nil))
   :group 'register)
+(make-obsolete-variable 'register-preview-delay "No longer used." "30.1")
=20
 (defcustom register-preview-default-keys (mapcar #'string (number-sequence=
 ?a ?z))
   "Default keys for setting a new register."
=2D-=20
2.34.1


--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0002-Fix-register-preview-default.patch
Content-Transfer-Encoding: quoted-printable

From=200fa70dad21d3475d3a5dae54a09d8a9e60b668ae Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 10:38:52 +0100
Subject: [PATCH 2/4] Fix register-preview-default

We need to print the string representation (one char) of an eventual
key description e.g. "^X" instead of "C-x".
However the key description is still displayed in a display property.

* lisp/register.el (register-preview-default): Use `string' to print regist=
er.
=2D--
 lisp/register.el | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/lisp/register.el b/lisp/register.el
index 88d0e8e1d10..46ec38821e5 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -131,7 +131,8 @@ See the documentation of the variable `register-alist' =
for possible VALUEs."
 (defun register-preview-default (r)
   "Function that is the default value of the variable `register-preview-fu=
nction'."
   (format "%s: %s\n"
=2D	  (single-key-description (car r))
+	  (propertize (string (car r))
+                      'display (single-key-description (car r)))
 	  (register-describe-oneline (car r))))
=20
 (defvar register-preview-function #'register-preview-default
=2D-=20
2.34.1


--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment; filename=0003-Update-register-manual.patch
Content-Transfer-Encoding: quoted-printable

From=20408126b6d56a0cc36f621348212e16d0715fd671 Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 10:53:46 +0100
Subject: [PATCH 3/4] Update register manual

doc/emacs/regs.texi: Do it.
=2D--
 doc/emacs/regs.texi | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

diff --git a/doc/emacs/regs.texi b/doc/emacs/regs.texi
index e52f68dd18e..5e5b7ae2b16 100644
=2D-- a/doc/emacs/regs.texi
+++ b/doc/emacs/regs.texi
@@ -16,9 +16,8 @@ jump back to that position once or many times.
 we will denote by @var{r}; @var{r} can be a letter (such as @samp{a})
 or a number (such as @samp{1}); case matters, so register @samp{a} is
 not the same as register @samp{A}.  You can also set a register in
=2Dnon-alphanumeric characters, for instance @samp{*} or @samp{C-d}.
=2DNote, it's not possible to set a register in @samp{C-g} or @samp{ESC},
=2Dbecause these keys are reserved for quitting (@pxref{Quitting}).
+non-alphanumeric characters, for instance @samp{C-d} by using for
+example @key{C-q} @samp{C-d}.
=20
 @findex view-register
   A register can store a position, a piece of text, a rectangle, a
=2D-=20
2.34.1


--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0004-Delete-register-tests.el-now-no-more-needed.patch
Content-Transfer-Encoding: quoted-printable

From=20cd6e66f955d20d31686a617ed8a5cd043585c71f Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 11:04:47 +0100
Subject: [PATCH 4/4] Delete register-tests.el now no more needed

* register-tests.el: Deleted file.
=2D--
 test/lisp/register-tests.el | 43 -------------------------------------
 1 file changed, 43 deletions(-)
 delete mode 100644 test/lisp/register-tests.el

diff --git a/test/lisp/register-tests.el b/test/lisp/register-tests.el
deleted file mode 100644
index 6283d1c31e0..00000000000
=2D-- a/test/lisp/register-tests.el
+++ /dev/null
@@ -1,43 +0,0 @@
=2D;;; register-tests.el --- tests for register.el  -*- lexical-binding: t-=
*-
=2D
=2D;; Copyright (C) 2017-2023 Free Software Foundation, Inc.
=2D
=2D;; Author: Tino Calancha <tino.calancha@HIDDEN>
=2D;; Keywords:
=2D
=2D;; This file is part of GNU Emacs.
=2D
=2D;; GNU Emacs is free software: you can redistribute it and/or modify
=2D;; it under the terms of the GNU General Public License as published by
=2D;; the Free Software Foundation, either version 3 of the License, or
=2D;; (at your option) any later version.
=2D
=2D;; GNU Emacs is distributed in the hope that it will be useful,
=2D;; but WITHOUT ANY WARRANTY; without even the implied warranty of
=2D;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
=2D;; GNU General Public License for more details.
=2D
=2D;; You should have received a copy of the GNU General Public License
=2D;; along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.
=2D
=2D;;; Commentary:
=2D
=2D
=2D;;; Code:
=2D(require 'ert)
=2D(require 'cl-lib)
=2D
=2D(ert-deftest register-test-bug27634 ()
=2D  "Test for https://debbugs.gnu.org/27634 ."
=2D  (dolist (event (list ?\C-g 'escape ?\C-\[))
=2D    (cl-letf (((symbol-function 'read-key) #'ignore)
=2D              (last-input-event event)
=2D              (register-alist nil))
=2D      (should (equal 'quit
=2D                     (condition-case err
=2D                         (call-interactively 'point-to-register)
=2D                       (quit (car err)))))
=2D      (should-not register-alist))))
=2D
=2D(provide 'register-tests)
=2D;;; register-tests.el ends here
=2D-=20
2.34.1


--=-=-=--

--==-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVqxfETHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk86tC/sEH+j9/019WSX601UxQ4z8RCtSiWyn
WCqTqvfTEzv/VesjkOAeR/9SwSy9Has3FrSHlhtaHa3QcqMqhX7o4zFpap1VHU3x
5jyXLT57ZbPLTmqpp3VuzXT2j8X6m7XsMIVJGE2+23b1RZ6m9J1EQcUQrfvgh2Kw
jqkJ2J65S5dbZ3aEYdi/lVXEyiuLvGMhFXVJkf8+X4uDqdQsU34mITeXsGZ+Xj8L
/eBiTFl8xNafxdfIt8ax8dwHLzFiu6C7LYCTN4fhxW3mU6G9rkurMDHRBvvlH9Ya
4hWy83EwEkTBL4VynZDXXPNRu8+tAV0UZfwsgd0hdS7DIzkUFEKK2UAAHli6niTy
Gwpiv66ZxaJ71IZuQ8O6KKhjQYSxcMdlU9OGfKInkXmD3DzuJ+v0i0rHO+Y8ltyb
dtcPjAxGEEbplvzOJSTRjzA8LsXPZH6p3pAuKNVO8jvBLx+uNXPedgPE4mGrHeod
nhCvfvfHm9bpoy5VpQ3LX788Uv0WGAp8BYQ=
=p4JO
-----END PGP SIGNATURE-----
--==-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 30 Nov 2023 10:22:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 30 05:22:05 2023
Received: from localhost ([127.0.0.1]:52349 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r8eBH-0003Pb-Vq
	for submit <at> debbugs.gnu.org; Thu, 30 Nov 2023 05:22:05 -0500
Received: from mout01.posteo.de ([185.67.36.65]:37507)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r8eBC-0003P0-Hj
 for 66394 <at> debbugs.gnu.org; Thu, 30 Nov 2023 05:22:02 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id D52DB240028
 for <66394 <at> debbugs.gnu.org>; Thu, 30 Nov 2023 11:21:44 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1701339704; bh=UyVED6QNug79f3UmM3vIy+7J8Y5wcpESk6lBTuEpGfU=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=H8S5g3l7yXGwABCYh9cEfCMHpldXjTHrrcET/JOzaRtsvapu2S2mrj/U/e1CWxKrQ
 5B/JCeWxSFHaNDgdqslpItmP0CJUD4z01LprbQ6d5f1dUDn/0YCQxCI64tcYDxvAwW
 9zu1/yqiva7JAbWXhfj5LQ5tcj0cAoboRYzdQFn4b7kZ7JvjeJ0mVLjHaDMaVN+xYD
 0fap2mmATOWpgpHggpv1dCh7gG35BVn8wExVU6uOtCgnrGxuQ9GUyyVEH+CfRQm0XK
 vD+djOZtInDQKWa4h1sPSizP5JK+vZxpJxaiRKBEQqDZLdMHFf076XjaUCbh61DRMz
 NxLd47xHUaPdg==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SgsgB51Ghz6tvk;
 Thu, 30 Nov 2023 11:21:42 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <83v89j6arv.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 30 Nov
 2023 08:00:20 +0200 (3 hours, 56 minutes, 56 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
 <83bkbc7j1o.fsf@HIDDEN> <8734wov2wv.fsf@HIDDEN>
 <83v89j6arv.fsf@HIDDEN>
Date: Thu, 30 Nov 2023 10:21:39 +0000
Message-ID: <87sf4nv8wc.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="==-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--==-=-=
Content-Type: multipart/mixed; boundary="=-=-="

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Thierry Volpiatto <thievol@HIDDEN>
>> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
>> Date: Wed, 29 Nov 2023 18:18:40 +0000
>>=20
>> Eli Zaretskii <eliz@HIDDEN> writes:
>>=20
>> > The response "a" to the "Point to register:" question is something I
>> > needed to type;
>>=20
>> Of course we are using now read-from-minibuffer and the test is related
>> to read-key not quitting with C-g
>>=20
>> > previously the test never asked any questions (and it shouldn't,
>> > AFAIU).
>>=20
>> Yes, it shouldn't, but now we are using a real minibuffer, is this test
>> really needed?
>> It is like if you had to make tests in all functions using
>> read-from-minibuffer to check if it quit properly with C-g (it does of c=
ourse).
>
> Can we have a similar issue with read-from-minibuffer?  Not with C-g,
> but with some other invalid input, like some function key or non-ASCII
> character or invalid character codepoint?

No, because unlike read-key, read-from-minibuffer doesn't read these
keys and exit immediately.  For example we can now set a register to C-g
by using "C-q C-g" but hitting directly C-g will quit minibuffer (as
expected), BTW I have updated the manual, see the attached patchs.  I
have also fixed register-preview-default accordingly so that it print
the register as a string but not a key representation e.g. "^X" instead
of "C-x" (if one find this ugly we could use "C-x" as a display property
of "^X").

> If this cannot happen, then perhaps the whole test file should be
> removed?

I think it can be removed, yes (done in patch below).

> Anyway, I trust you to do what is needed here, I just want the test
> suite to keep running successfully, and I don't have time to work on
> this myself.  TIA.

Ok, can you review (and merge if ok) following patchs.

>> ALSO: I intentionally leave register-preview-delay defcustom with a FIXME
>> comment, do you want to remove it? It is not used anymore now AFAIK.
>
> This should be declared obsolete, with an explanation that it is no
> longer used, and a note about that should be added to NEWS, in the
> incompatible changes section.  Then we can remove the FIXME.

done.

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0001-Make-register-preview-delay-obsolete.patch
Content-Transfer-Encoding: quoted-printable

From=203df81fb5dc5809cab7843e5358c17d0039b55eb1 Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 08:03:45 +0100
Subject: [PATCH 1/4] Make register-preview-delay obsolete

* etc/NEWS: Update.
* lisp/register.el (register-preview-delay): Make it obsolete.
=2D--
 etc/NEWS         | 5 +++++
 lisp/register.el | 2 +-
 2 files changed, 6 insertions(+), 1 deletion(-)

diff --git a/etc/NEWS b/etc/NEWS
index 6661ac70e1b..bab3529339f 100644
=2D-- a/etc/NEWS
+++ b/etc/NEWS
@@ -1138,6 +1138,11 @@ showcases all their customization options.
 
 * Incompatible Lisp Changes in Emacs 30.1
=20
+---
+** 'register-preview-delay' is no longer used.
+Register preview is no more delayed.  If you want to disable it use
+'register-use-preview' instead with a boolean value.
+
 +++
 ** 'M-TAB' now invokes 'completion-at-point' also in Text mode.
 Text mode no longer binds 'M-TAB' to 'ispell-complete-word', and
diff --git a/lisp/register.el b/lisp/register.el
index 61bef503f91..88d0e8e1d10 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -93,7 +93,6 @@ of the marked text."
   :type '(choice (const :tag "None" nil)
 		 (character :tag "Use register" :value ?+)))
=20
=2D;; FIXME: This is no more needed, remove it.
 (defcustom register-preview-delay 1
   "If non-nil, time to wait in seconds before popping up register preview =
window.
 If nil, do not show register previews, unless `help-char' (or a member of
@@ -101,6 +100,7 @@ If nil, do not show register previews, unless `help-cha=
r' (or a member of
   :version "24.4"
   :type '(choice number (const :tag "No preview unless requested" nil))
   :group 'register)
+(make-obsolete-variable 'register-preview-delay "No longer used." "30.1")
=20
 (defcustom register-preview-default-keys (mapcar #'string (number-sequence=
 ?a ?z))
   "Default keys for setting a new register."
=2D-=20
2.34.1


--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0002-Fix-register-preview-default.patch
Content-Transfer-Encoding: quoted-printable

From=20bcf7bd8feb05914e6000b572c3e75664a9090c1a Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 10:38:52 +0100
Subject: [PATCH 2/4] Fix register-preview-default

We need to print the string representation (one char) of an eventual
key description e.g. "^X" instead of "C-x".

* lisp/register.el (register-preview-default): Use `string' to print regist=
er.
=2D--
 lisp/register.el | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/lisp/register.el b/lisp/register.el
index 88d0e8e1d10..9b457e716f2 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -131,7 +131,7 @@ See the documentation of the variable `register-alist' =
for possible VALUEs."
 (defun register-preview-default (r)
   "Function that is the default value of the variable `register-preview-fu=
nction'."
   (format "%s: %s\n"
=2D	  (single-key-description (car r))
+	  (string (car r))
 	  (register-describe-oneline (car r))))
=20
 (defvar register-preview-function #'register-preview-default
=2D-=20
2.34.1


--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment; filename=0003-Update-register-manual.patch
Content-Transfer-Encoding: quoted-printable

From=2093c07593bac8d7f0428a92502ee5de8def128c5c Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 10:53:46 +0100
Subject: [PATCH 3/4] Update register manual

doc/emacs/regs.texi: Do it.
=2D--
 doc/emacs/regs.texi | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

diff --git a/doc/emacs/regs.texi b/doc/emacs/regs.texi
index e52f68dd18e..5e5b7ae2b16 100644
=2D-- a/doc/emacs/regs.texi
+++ b/doc/emacs/regs.texi
@@ -16,9 +16,8 @@ jump back to that position once or many times.
 we will denote by @var{r}; @var{r} can be a letter (such as @samp{a})
 or a number (such as @samp{1}); case matters, so register @samp{a} is
 not the same as register @samp{A}.  You can also set a register in
=2Dnon-alphanumeric characters, for instance @samp{*} or @samp{C-d}.
=2DNote, it's not possible to set a register in @samp{C-g} or @samp{ESC},
=2Dbecause these keys are reserved for quitting (@pxref{Quitting}).
+non-alphanumeric characters, for instance @samp{C-d} by using for
+example @key{C-q} @samp{C-d}.
=20
 @findex view-register
   A register can store a position, a piece of text, a rectangle, a
=2D-=20
2.34.1


--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0004-Delete-register-tests.el-now-no-more-needed.patch
Content-Transfer-Encoding: quoted-printable

From=20d60e3b4969a420fe9ba66b5732f57243385e5e88 Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Thu, 30 Nov 2023 11:04:47 +0100
Subject: [PATCH 4/4] Delete register-tests.el now no more needed

* register-tests.el: Deleted file.
=2D--
 test/lisp/register-tests.el | 43 -------------------------------------
 1 file changed, 43 deletions(-)
 delete mode 100644 test/lisp/register-tests.el

diff --git a/test/lisp/register-tests.el b/test/lisp/register-tests.el
deleted file mode 100644
index 6283d1c31e0..00000000000
=2D-- a/test/lisp/register-tests.el
+++ /dev/null
@@ -1,43 +0,0 @@
=2D;;; register-tests.el --- tests for register.el  -*- lexical-binding: t-=
*-
=2D
=2D;; Copyright (C) 2017-2023 Free Software Foundation, Inc.
=2D
=2D;; Author: Tino Calancha <tino.calancha@HIDDEN>
=2D;; Keywords:
=2D
=2D;; This file is part of GNU Emacs.
=2D
=2D;; GNU Emacs is free software: you can redistribute it and/or modify
=2D;; it under the terms of the GNU General Public License as published by
=2D;; the Free Software Foundation, either version 3 of the License, or
=2D;; (at your option) any later version.
=2D
=2D;; GNU Emacs is distributed in the hope that it will be useful,
=2D;; but WITHOUT ANY WARRANTY; without even the implied warranty of
=2D;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
=2D;; GNU General Public License for more details.
=2D
=2D;; You should have received a copy of the GNU General Public License
=2D;; along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.
=2D
=2D;;; Commentary:
=2D
=2D
=2D;;; Code:
=2D(require 'ert)
=2D(require 'cl-lib)
=2D
=2D(ert-deftest register-test-bug27634 ()
=2D  "Test for https://debbugs.gnu.org/27634 ."
=2D  (dolist (event (list ?\C-g 'escape ?\C-\[))
=2D    (cl-letf (((symbol-function 'read-key) #'ignore)
=2D              (last-input-event event)
=2D              (register-alist nil))
=2D      (should (equal 'quit
=2D                     (condition-case err
=2D                         (call-interactively 'point-to-register)
=2D                       (quit (car err)))))
=2D      (should-not register-alist))))
=2D
=2D(provide 'register-tests)
=2D;;; register-tests.el ends here
=2D-=20
2.34.1


--=-=-=--

--==-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVoYjQTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkzXyC/kBEQlBq0ikuda24dpYAm3QNF018i4K
DGKIAcwH7QGcJOyF4LrUH7wV2/qex9CaBjgKfwCKSzLebJ5rrlxeIZe2yPdGNafJ
/R3KTVDsADLWuQbeVITKKReOxr8mGhRl+4wckch4BJFt25y9cfit2o8MxpLlAY1P
Hhz6j06q/L9sDFgms77hiLNmMIghIWgVSxjvQ3UvxWRpgcR/h+gJcb+P10PaVncz
efq3WO+cn2oYNM2QDeQFfxh8BSmnXnGip2/68AJ42TIJigpyXRJF87CFAimU90cP
cO6OXtUvBucT+kMBpdJncEbi7b8w4g/XYSDWTed5I/okGTrIecYPN+MET2E+cBgA
rNr7gPJ+BZ2YFh0/krtIAZ2ixbkqWK9sb/46Tul0HXfP6iXL1aH4gcAvgEJa16/N
FOiI8gyEZjVXUcXle27LJ7ZrGj/OJnqcUIbAeEAMjTcwXdzq8N854z4crCvIbfaA
kVZARCGPdhJIZ+dr7NQHymRiz/IV59wQMLM=
=iUe8
-----END PGP SIGNATURE-----
--==-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 30 Nov 2023 06:00:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 30 01:00:54 2023
Received: from localhost ([127.0.0.1]:51997 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r8a6Y-00042J-6Y
	for submit <at> debbugs.gnu.org; Thu, 30 Nov 2023 01:00:54 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:40700)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1r8a6W-00041w-Bb
 for 66394 <at> debbugs.gnu.org; Thu, 30 Nov 2023 01:00:53 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1r8a6I-0004X6-Cx; Thu, 30 Nov 2023 01:00:38 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=sdImzQRiyZK8fUQ1Il4dFvQF/ILFQXpf9iNd6Vm4a7o=; b=QJVw0s1JG9Ka
 jXsu+F0sO4JbpddfekBKt8Gl94aYrjlHUk3M2XXvD/XYXDTW3ocjWguVLlsy5GFvEFOuhjUTI2Hrz
 nPZr4OsKcAs20Q2B35LCUj5MBlrZXlIM5Il0sjSu/geKeredmzXoQjfUS+oMhfm4dwqOYFdHeiNT0
 yxyG6rzFUSdc8qwQs4UiiQScwUK99wxbHvIZj48LKwENE8eb9YQMqtW7bkiCJX6CBEC0SzIrLhwZz
 CtJFRelNtZRb65Or8Tuuh+VreWwCzn6onoVT5wG1C2eK6JS4FiTnn9laubQZ4f17uYKz3b2TniYuq
 kYAyWTeyLMDMjrsygrUl7g==;
Date: Thu, 30 Nov 2023 08:00:20 +0200
Message-Id: <83v89j6arv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <8734wov2wv.fsf@HIDDEN> (message from Thierry Volpiatto on
 Wed, 29 Nov 2023 18:18:40 +0000)
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <8734y5vnj7.fsf@HIDDEN>
 <87bkcslr18.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
 <83bkbc7j1o.fsf@HIDDEN> <8734wov2wv.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Thierry Volpiatto <thievol@HIDDEN>
> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
> Date: Wed, 29 Nov 2023 18:18:40 +0000
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > The response "a" to the "Point to register:" question is something I
> > needed to type;
> 
> Of course we are using now read-from-minibuffer and the test is related
> to read-key not quitting with C-g
> 
> > previously the test never asked any questions (and it shouldn't,
> > AFAIU).
> 
> Yes, it shouldn't, but now we are using a real minibuffer, is this test
> really needed?
> It is like if you had to make tests in all functions using
> read-from-minibuffer to check if it quit properly with C-g (it does of course).

Can we have a similar issue with read-from-minibuffer?  Not with C-g,
but with some other invalid input, like some function key or non-ASCII
character or invalid character codepoint?  If this cannot happen, then
perhaps the whole test file should be removed?

Anyway, I trust you to do what is needed here, I just want the test
suite to keep running successfully, and I don't have time to work on
this myself.  TIA.

> ALSO: I intentionally leave register-preview-delay defcustom with a FIXME
> comment, do you want to remove it? It is not used anymore now AFAIK.

This should be declared obsolete, with an explanation that it is no
longer used, and a note about that should be added to NEWS, in the
incompatible changes section.  Then we can remove the FIXME.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 29 Nov 2023 18:19:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 29 13:19:09 2023
Received: from localhost ([127.0.0.1]:51095 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r8P9Q-0003UT-TR
	for submit <at> debbugs.gnu.org; Wed, 29 Nov 2023 13:19:09 -0500
Received: from mout02.posteo.de ([185.67.36.66]:56285)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r8P9O-0003Tz-DB
 for 66394 <at> debbugs.gnu.org; Wed, 29 Nov 2023 13:19:07 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 24A04240103
 for <66394 <at> debbugs.gnu.org>; Wed, 29 Nov 2023 19:18:53 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1701281933; bh=sb9lm94GFg5U6Jr66H2LHfhpV/Ayr9fT8dzL7dtSIOw=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=XyHDcj+UJi4E5PK3Rv2ass0OpqcHsvi6c6eDFHZIlBfzuymwGVLL3UbMmx5eYYKWi
 aQy5MnHbLBQ0lFMY79nU36Vu6gRi6UrYH4lLKdN05z0UTWu4ER4rdYC7egJCg5D/gH
 0RPg5ka6kZpTMvQXb90yH0Qre4H1QMaxxItOCpR9UD/BYeprbCySjUd9x5KaWhEx23
 67sM0IhrpmmsXPbnt96ngIEt7fMCHPNdHWUzWzW6iOXHTcgLWN0ZvhdGOGRYZOthfe
 /2WP1m9B/aARnF4StbkCoy27oBo49F1FlSfMfIJXRfwNQtII8+BKQ8iG/OLn9mHK7b
 KJFmdKniB0hfg==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SgSJ56CH9z6tsj;
 Wed, 29 Nov 2023 19:18:45 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <83bkbc7j1o.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 29 Nov
 2023 16:04:03 +0200 (4 hours, 1 minute, 26 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <8734y5vnj7.fsf@HIDDEN>
 <87bkcslr18.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
 <83bkbc7j1o.fsf@HIDDEN>
Date: Wed, 29 Nov 2023 18:18:40 +0000
Message-ID: <8734wov2wv.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Thierry Volpiatto <thievol@HIDDEN>
>> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
>> Date: Sat, 25 Nov 2023 21:14:31 +0000
>>=20
>> Here a patch with the change suggested by Stefan applied, slighly
>> modified though because it fails if I put the call to
>> cl--generic-prefill-dispatchers at the recommended place.
>>=20
>> I recompiled Emacs with this patch with no errors.
>
> Thanks, installed on master.

Thanks.

> The response "a" to the "Point to register:" question is something I
> needed to type;

Of course we are using now read-from-minibuffer and the test is related
to read-key not quitting with C-g

> previously the test never asked any questions (and it shouldn't,
> AFAIU).

Yes, it shouldn't, but now we are using a real minibuffer, is this test
really needed?
It is like if you had to make tests in all functions using
read-from-minibuffer to check if it quit properly with C-g (it does of cour=
se).

> Could you please see if the test suite needs some adaptations to these
> changes?

If you really need this test, it needs a complete rewrite.

ALSO: I intentionally leave register-preview-delay defcustom with a FIXME
comment, do you want to remove it? It is not used anymore now AFAIK.

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVngIATHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk/pwC/9TNXjnt45y2PkCZMvmj5zIFTYflGrZ
xMiOdlCak2jDxMkERRwzAOByNwAu0bsD/3cLJpgOJsAKOg/nqmvWhWIyA4363wbq
Wrax5Pyhk2UfsCFGh5Ti5nEhyfUj7sEPrPNu5Aw7uMFsZxeHie7oD6/ATT/WR7ir
s5jHhfiVANrIrQAMJ7K7bEACOrjQ//liQXOfMORAuINGP7+f+IfqQ9pYyrZho/A9
HcWn7a3cPkIBPJ+VxXxcQ9llczfJDWNU+cbZala9CHO2TAzFHlMM55OsHIFHArM1
uwagwqwQ5vz1Ku/Q3kynZJdCyx2m0AgJWWTF+vzVMEDnzFjI4phGwJPE7WBBDuT0
OJQ/Wc25zqIBKa3bk7aXONqVfqbxA/pJhy8udD4tBjIspJv2Okpchpz4f2j7sSJK
6vbUcAJ00iV0uj4sMURr3l2mR4D+WTN2sHbWtgdMDXpjEduCiC7f3BRzx3kJxHXV
X16FCWvH5Y/35m0WwY+RMF2ZtZAGyEZ11cY=
=sxPD
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 29 Nov 2023 14:04:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 29 09:04:32 2023
Received: from localhost ([127.0.0.1]:49184 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r8LB2-0001x5-1W
	for submit <at> debbugs.gnu.org; Wed, 29 Nov 2023 09:04:32 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:45054)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1r8LAz-0001wr-R1
 for 66394 <at> debbugs.gnu.org; Wed, 29 Nov 2023 09:04:30 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1r8LAl-0004xC-IK; Wed, 29 Nov 2023 09:04:16 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=3J1hmpHd5QrhsU4i/vFN5W3geexSfylUTWLdzRzbtm0=; b=iPEcyBriXFCSa2hdCKIg
 3EibI+dtLkHUBPQghgeqSDOactcDwJdb+mogIyQaZwcbUINKF+iS4A91dCdLe2Z+pCpWbFBxw8ox5
 TYsSeAoqA8J86wKg5CfZaMGEk1et6acx3C4MhVOAlVe5kg6aTWDSn9AcBG0pg3I+n+CGJ8ivzfjTa
 JXhvqidaBkItUH/2tR1qM7h2oZbPZJf9ffiDnU8p2q96DkWHVC8XanjXG+GNdLRuTxqkjxVbQ3QrP
 lm74MhxM03FQ4pf7QMlCj89mFPqLcj12g/5R6hI0qBQal6bfENhB9pDl47ikfGlUnG7j+D9eon0H7
 9CCc4mzrs4Jz6w==;
Date: Wed, 29 Nov 2023 16:04:03 +0200
Message-Id: <83bkbc7j1o.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <87zfz1cz7s.fsf@HIDDEN> (message from Thierry Volpiatto on
 Sat, 25 Nov 2023 21:14:31 +0000)
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <875y3386ep.fsf@HIDDEN>
 <87a5sddh14.fsf@HIDDEN> <8734y5vnj7.fsf@HIDDEN>
 <87bkcslr18.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Thierry Volpiatto <thievol@HIDDEN>
> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
> Date: Sat, 25 Nov 2023 21:14:31 +0000
> 
> Here a patch with the change suggested by Stefan applied, slighly
> modified though because it fails if I put the call to
> cl--generic-prefill-dispatchers at the recommended place.
> 
> I recompiled Emacs with this patch with no errors.

Thanks, installed on master.

After this, a test in register-tests.el fails:

  Running 1 tests (2023-11-29 09:01:59-0500, selector ‘(not (or (tag :unstable) (tag :nativecomp)))’)
  Point to register: a
  Test register-test-bug27634 backtrace:
    signal(ert-test-failed (((should (equal 'quit (condition-case err (c
    ert-fail(((should (equal 'quit (condition-case err (call-interactive
    (if (unwind-protect (setq value-2 (apply fn-0 args-1)) (setq form-de
    (let (form-description-4) (if (unwind-protect (setq value-2 (apply f
    (let ((value-2 'ert-form-evaluation-aborted-3)) (let (form-descripti
    (let* ((fn-0 #'equal) (args-1 (condition-case err (let ((signal-hook
    (progn (fset 'read-key #'ignore) (let* ((fn-0 #'equal) (args-1 (cond
    (unwind-protect (progn (fset 'read-key #'ignore) (let* ((fn-0 #'equa
    (let* ((vnew event) (old (symbol-function 'read-key)) (register-alis
    (let ((event (car tail))) (let* ((vnew event) (old (symbol-function
    (while tail (let ((event (car tail))) (let* ((vnew event) (old (symb
    (let ((tail (list 7 'escape 27))) (while tail (let ((event (car tail
    (closure (t) nil (let ((tail (list 7 'escape 27))) (while tail (let
    ert--run-test-internal(#s(ert--test-execution-info :test #s(ert-test
    ert-run-test(#s(ert-test :name register-test-bug27634 :documentation
    ert-run-or-rerun-test(#s(ert--stats :selector ... :tests ... :test-m
    ert-run-tests((not (or (tag :unstable) (tag :nativecomp))) #f(compil
    ert-run-tests-batch((not (or (tag :unstable) (tag :nativecomp))))
    ert-run-tests-batch-and-exit((not (or (tag :unstable) (tag :nativeco
    eval((ert-run-tests-batch-and-exit '(not (or (tag :unstable) (tag :n
    command-line-1(("-L" ":." "-l" "ert" "-l" "lisp/register-tests.el" "
    command-line()
    normal-top-level()
  Test register-test-bug27634 condition:
      (ert-test-failed
       ((should (equal 'quit (condition-case err ... ...))) :form
	(equal quit #<marker in no buffer>) :value nil :explanation
	(different-types quit #<marker in no buffer>)))
     FAILED  1/1  register-test-bug27634 (1.758961 sec) at lisp/register-tests.el:30

The response "a" to the "Point to register:" question is something I
needed to type; previously the test never asked any questions (and it
shouldn't, AFAIU).

Could you please see if the test suite needs some adaptations to these
changes?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 26 Nov 2023 16:46:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 26 11:46:29 2023
Received: from localhost ([127.0.0.1]:42621 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r7IH6-0004cO-Rs
	for submit <at> debbugs.gnu.org; Sun, 26 Nov 2023 11:46:29 -0500
Received: from mout02.posteo.de ([185.67.36.66]:56511)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r7IH4-0004c3-4O
 for 66394 <at> debbugs.gnu.org; Sun, 26 Nov 2023 11:46:27 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id AF5EB240101
 for <66394 <at> debbugs.gnu.org>; Sun, 26 Nov 2023 17:46:14 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1701017174; bh=KZzmFK1P6jnMX1i2cVSmFtyS1zIAGBtLgkqv0sXzuK0=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=QfoG3/6TI2tNElqzX8kRW3tNt47mFjjRQjITgrctWHndGL/6apGJXsdA/OEMwzENp
 bVEdzAQ1act4WQmGfywtQMwX1pu9XKuWf5mYZgPSXc6Rht4lIH+4P0hKPna3qgvarA
 1fq32b9Qx4TPYzk5x+dI2bRK1+N4KL/aCUHg0/HQnqTRm68imQfo+lBnQq8tc6lf96
 1XHwHoZJ1O1Rsge1whXa6d5wu9irI4QIic/8H+Z5W+e1TS8+gOMA9eQ2pTApjd3PzA
 oWKCpBe+j81wVdEdZD4Ne+dm4s2A9W8eU0cK+gJR/RXi9bGeYDtSOfPKHh5+TWjv+c
 KY7azQSxpxKcA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SdZNh6Zflz6tvm;
 Sun, 26 Nov 2023 17:46:12 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <837cm4bxzy.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 26 Nov
 2023 12:38:25 +0200 (6 hours, 3 minutes, 53 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <8734y5vnj7.fsf@HIDDEN>
 <87bkcslr18.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
 <837cm4bxzy.fsf@HIDDEN>
Date: Sun, 26 Nov 2023 16:46:06 +0000
Message-ID: <87sf4so435.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Thierry Volpiatto <thievol@HIDDEN>
>> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
>> Date: Sat, 25 Nov 2023 21:14:31 +0000
>>=20
>> Here a patch with the change suggested by Stefan applied, slighly
>> modified though because it fails if I put the call to
>> cl--generic-prefill-dispatchers at the recommended place.
>>=20
>> I recompiled Emacs with this patch with no errors.
>
> Thanks.
>
> Stefan, any further comments, or should I install this as submitted?

Do you want the ability to jump to more than one line at the time before
merging, (e.g. C-u 3 C-n and C-u 3 C-p) or is it ok like this for you?

diff --git a/lisp/register.el b/lisp/register.el
index 61bef503f91..bca967a4efe 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -207,7 +207,7 @@ Do nothing when defining or executing kmacros."
                          (overlay-start (car ovs))
                          (point-min)))
           (setq pos (point))
=2D          (and ovs (forward-line arg))
+          (forward-line (if ovs arg (1- arg)))
           (when (and (funcall fn)
                      (or (> arg 0) (eql pos (point))))
             (goto-char (funcall posfn)))
@@ -218,15 +218,15 @@ Do nothing when defining or executing kmacros."
             (delete-minibuffer-contents)
             (insert str)))))))
=20
=2D(defun register-preview-next ()
+(defun register-preview-next (&optional arg)
   "Goto next line in register preview buffer."
=2D  (interactive)
=2D  (register-preview-forward-line 1))
+  (interactive "p")
+  (register-preview-forward-line arg))
=20
=2D(defun register-preview-previous ()
+(defun register-preview-previous (&optional arg)
   "Goto previous line in register preview buffer."
=2D  (interactive)
=2D  (register-preview-forward-line -1))
+  (interactive "p")
+  (register-preview-forward-line (- arg)))
=20
 (defun register-type (register)
   "Return REGISTER type.
=20
=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVjdk8THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkzAhC/9wa8vIr+9Xy0yZBEsGiHc1l43gwBYt
6eQs3HtKlQc9/wpu3RdVnE7wMuTko/Y/dKDG8mi7PncTmPWpIQuq+89FXfWMOceJ
4NgYCNBBkWoKg5xzMCEis9W0I9ogQpIKEj3TLdwwjBWPMyS+etjCIc7dNPdgmorM
HJfKrl4pokY4RseSJSAo+Iijjx1wlAGLeb1Cwpn0D5Hmr2YgfpltrFCjB0sIRX1y
Pp1puPMUj4Ik8Yys0rVUNjaDC1k3jRAmIPjpdyzd3ZLy9lEfniuaAFjipfBI+J2X
WcZiQ3wdJPmWrvqJ4L1G9lIPyhd+DwYPM72XYez9b1C7pmbDBZFeMkK+flPf6nKP
y1NbcU6aChYuI9diSFDFa0DjL1Go2XGj/JYIeJF3NQhBFeKPhjKrC6bgbso3zEz2
oY+Bhc6HaPlNT6drNiFPckAhKABAAPfN72HLbC0cvXzj6S3S8ryT2K+asmBViOGu
UW0tWorHBjMjOblFoTHRPV/DVQd8MvtI7G0=
=9J8d
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 26 Nov 2023 10:38:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 26 05:38:56 2023
Received: from localhost ([127.0.0.1]:40758 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r7CXQ-0007BR-AG
	for submit <at> debbugs.gnu.org; Sun, 26 Nov 2023 05:38:56 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:60766)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1r7CXO-0007BB-FR
 for 66394 <at> debbugs.gnu.org; Sun, 26 Nov 2023 05:38:55 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1r7CXD-00061b-Hj; Sun, 26 Nov 2023 05:38:43 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=Wy98NnK6DPPnXSR+RZbz/0ptLFhOARB3IKb5Vmppnew=; b=Mm2OBJ2E+2LB
 xyREPahuUSnMtinTo9eCFl3hEAtXrOlcSec0na0rv2PbqT/Kt+EdfxADk6B+ZPKhFclilHKpXFPtM
 7vkd3iDrFnq2J8/Zp0UCZXSyX1/cK6lZe5KjAT8kP/ydoXzcjMwkSk7/M4zlgEBeyAEar7ak2Fge5
 LSlB9jWfejnvR0Y7YQZOSRiea/GZFiUmIcK9Ist1asitKSNIvLF6+ec/YAlY72Rd18X7vJh8bM6DL
 EEgo0YVUsFkpl8I0UXduyiZPeO6xw5u3Y3C2ruvWWhXMoIlZ6RBmTIl0vPrE4K5vj1Gr8LgZAnb7h
 9Eyy9Gf35HbWzVcZ0Kru8Q==;
Date: Sun, 26 Nov 2023 12:38:25 +0200
Message-Id: <837cm4bxzy.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <87zfz1cz7s.fsf@HIDDEN> (message from Thierry Volpiatto on
 Sat, 25 Nov 2023 21:14:31 +0000)
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <875y3386ep.fsf@HIDDEN>
 <87a5sddh14.fsf@HIDDEN> <8734y5vnj7.fsf@HIDDEN>
 <87bkcslr18.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN> <87zfz1cz7s.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Thierry Volpiatto <thievol@HIDDEN>
> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
> Date: Sat, 25 Nov 2023 21:14:31 +0000
> 
> Here a patch with the change suggested by Stefan applied, slighly
> modified though because it fails if I put the call to
> cl--generic-prefill-dispatchers at the recommended place.
> 
> I recompiled Emacs with this patch with no errors.

Thanks.

Stefan, any further comments, or should I install this as submitted?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Nov 2023 21:38:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 25 16:38:54 2023
Received: from localhost ([127.0.0.1]:40399 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r70MY-0004im-4a
	for submit <at> debbugs.gnu.org; Sat, 25 Nov 2023 16:38:54 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:20594)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1r70MW-0004iU-1T
 for 66394 <at> debbugs.gnu.org; Sat, 25 Nov 2023 16:38:52 -0500
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id D3E258044C;
 Sat, 25 Nov 2023 16:38:40 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1700948315;
 bh=98aB3axXC25kohRW+FpBDECEO48xUMYS/CUT9mH1UYU=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=db3FvrfqmLgSIYp/eIdk7GfmVbV/0DTH+XEP6SBACK08r62eG/Ne0qKdgjlWZ2sjq
 JfnhYX6C85BEoUXvJshJeU6rnlvHWG3v+8mfLBBXXXlUJG/0zhmf7/hTrro6jWKR45
 q3PUgNSR2J78IF1KWT/OEN1CnYXXYJfevdMmFvK/iTNzS4m9VkCQqIVZWJoZbJl1sZ
 aE0Wlip8qxGoyEufAiUD1WZ9II4QSTLLnyjpMWukVw3mHcbe+3uGEHZb2gGYPGzdKg
 Le5gbFFyPRfihBgLr6+LRiMo3432OGjdoLNnPLptLTkEeChYWy/pHeyduBnumPKjQm
 6z+ZAaIAJdRcg==
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id DF8C280506;
 Sat, 25 Nov 2023 16:38:35 -0500 (EST)
Received: from pastel (unknown [45.72.227.120])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id A7C671202E6;
 Sat, 25 Nov 2023 16:38:35 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <83il5pbnmh.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 25 Nov
 2023 22:10:14 +0200")
Message-ID: <jwvy1ely0sf.fsf-monnier+emacs@HIDDEN>
References: <87il7ib6cu.fsf@HIDDEN> <875y3386ep.fsf@HIDDEN>
 <87a5sddh14.fsf@HIDDEN> <8734y5vnj7.fsf@HIDDEN>
 <87bkcslr18.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN>
Date: Sat, 25 Nov 2023 16:38:34 -0500
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.026 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
 DKIM_VALID_EF -0.1 Message has a valid DKIM or DK signature from envelope-from
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: Thierry Volpiatto <thievol@HIDDEN>, michael_heerdegen@HIDDEN,
 stefankangas@HIDDEN, 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> >   In toplevel form:
>> >   register.el:33:37: Warning: `eql' called with 1 argument, but requires 2
>> >   register.el:33:45: Warning: reference to free variable `integer'
>> I have not these warnings.
> Strange.  Maybe Stefan can explain how could that happen.

It's because of:

    (cl--generic-prefill-dispatchers 0 (eql 'x) integer)

This needs to be in `cl-generic.el` because that's where the
`cl--generic-prefill-dispatchers` macro is defined.  Thierry had it in
`register.el` which worked OK when `register.el` gets compiled with the
bootstrap Emacs where `cl-generic` has not yet been compiled but it
fails when compiled with an Emacs where `cl-generic` has been compiled
because in that case the macro is not defined so the compiler compiles
the above line as a function call, resulting in the above two warnings.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Nov 2023 21:14:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 25 16:14:56 2023
Received: from localhost ([127.0.0.1]:40366 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r6zzL-000426-GY
	for submit <at> debbugs.gnu.org; Sat, 25 Nov 2023 16:14:56 -0500
Received: from mout02.posteo.de ([185.67.36.66]:59421)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r6zzH-00041p-Ph
 for 66394 <at> debbugs.gnu.org; Sat, 25 Nov 2023 16:14:53 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 6924F240103
 for <66394 <at> debbugs.gnu.org>; Sat, 25 Nov 2023 22:14:40 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1700946880; bh=yOPaBOtIqBzsKQEEcPiPlel2QZUQH+9ZO7CZKo5DZ5c=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=DUdoPfzRMSsXw7q08pnlZlMRednN2xZmTLR20JSC0P+bokmirKM/Jrbwi3KTyxa8k
 23+FNxtqxw71GwPOHWffFqKHDnhrWDoC96QR+4PBAMfwNWMWqx7NCfeL7IR6tL/KyY
 J8l4U80/HhrlVhCZaDzSKSEAyHoMkkaJ6dvtkCYpx8KpY6rXOFivb03Cn6Zb4tRgdj
 6oDXoAHajIifP8qoUyaOfUBh0axj+ma7EH+abHRkSY63N6vdZx/d9Uh6QbpZHms9pO
 YQRwxQkgC6Czln0rCa8PCCxlVLQ303QMYkCG497h3sQPv91WyEnSLR271JRjxGrowU
 xQvKPIIie9n5Q==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4Sd4Nt1VBPz6tsB;
 Sat, 25 Nov 2023 22:14:37 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <83il5pbnmh.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 25 Nov
 2023 22:10:14 +0200 (53 minutes, 35 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <875y3386ep.fsf@HIDDEN>
 <87a5sddh14.fsf@HIDDEN> <8734y5vnj7.fsf@HIDDEN>
 <87bkcslr18.fsf@HIDDEN> <87y1fwtyrl.fsf@HIDDEN>
 <87y1fut1wp.fsf@HIDDEN> <87ttqgpjiz.fsf@HIDDEN>
 <87wmvbibpr.fsf@HIDDEN> <877cnb2n63.fsf@HIDDEN>
 <8734xyc8z0.fsf@HIDDEN> <87zg05rewi.fsf@HIDDEN>
 <87ttqcg8gw.fsf@HIDDEN> <87h6mcr8ol.fsf@HIDDEN>
 <87r0l73029.fsf@HIDDEN> <877cmdx8ud.fsf@HIDDEN>
 <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> <87sf50s1gh.fsf@HIDDEN>
 <83o7ficesp.fsf@HIDDEN> <878r6leh9d.fsf@HIDDEN>
 <83il5pbnmh.fsf@HIDDEN>
Date: Sat, 25 Nov 2023 21:14:31 +0000
Message-ID: <87zfz1cz7s.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="==-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--==-=-=
Content-Type: multipart/mixed; boundary="=-=-="

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Eli Zaretskii <eliz@HIDDEN> writes:

> How would "make clean" help?  I did remove register.elc, it didn't
> help.

Not only register is involved here but indirectly cl-generic.

> OK, so I guess I shouldn't have tried to install it.

Here a patch with the change suggested by Stefan applied, slighly
modified though because it fails if I put the call to
cl--generic-prefill-dispatchers at the recommended place.

I recompiled Emacs with this patch with no errors.
=20
=2D-=20
Thierry

--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0001-Improve-register-preview-Fix-bug-66394.patch
Content-Transfer-Encoding: quoted-printable

From=20ccecd34b8307c7168e89289f933e63590ce6fc9c Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Sun, 19 Nov 2023 20:42:56 +0100
Subject: [PATCH] Improve register-preview (Fix bug#66394)

A minibuffer is used now instead of read-key.
Registers in preview buffer are now filtered according to type of
registers the current command requires.
Navigation with C-n/p or up/down is now provided and update
minibuffer.
Current register is highlighted in preview buffer.

* cl-generic.el: Add a call to `cl--generic-prefill-dispatchers` to
  fix build error.

* register.el:

* (register-preview-default-keys): new user var.
* (register-use-preview): Same.
* (register-preview-info): New structure to store various info for
  preview.
* (register-command-info): New generic.
* (register-preview-forward-line): New, provide navigation in preview
  buffer.
* (register-preview-next, register-preview-previous): New, navigation.
* (register-type): New, returns register type.
* (register--type): Generic fn, new, returns register type according
  to value.
* (register-of-type-alist): New, filter register-alist according to
  type.
* (register-preview): Signature changed, use TYPES now.
* (register-preview-get-defaults): New generic, compute defauts
  according to action.
* (register-read-with-preview): Now use read-from-minibuffer and
  minibuffer-setup-hook.
=2D--
 lisp/emacs-lisp/cl-generic.el |   1 +
 lisp/register.el              | 295 +++++++++++++++++++++++++++++-----
 2 files changed, 259 insertions(+), 37 deletions(-)

diff --git a/lisp/emacs-lisp/cl-generic.el b/lisp/emacs-lisp/cl-generic.el
index 56eb83e6f75..0ef0d1e192a 100644
=2D-- a/lisp/emacs-lisp/cl-generic.el
+++ b/lisp/emacs-lisp/cl-generic.el
@@ -1379,6 +1379,7 @@ See the full list and their hierarchy in `cl--typeof-=
types'."
 (cl--generic-prefill-dispatchers 0 integer)
 (cl--generic-prefill-dispatchers 1 integer)
 (cl--generic-prefill-dispatchers 0 cl--generic-generalizer integer)
+(cl--generic-prefill-dispatchers 0 (eql 'x) integer)
=20
 ;;; Dispatch on major mode.
=20
diff --git a/lisp/register.el b/lisp/register.el
index ca6de450993..61bef503f91 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -35,6 +35,8 @@
=20
 ;; FIXME: Clean up namespace usage!
=20
+(declare-function frameset-register-p "frameset")
+
 (cl-defstruct
   (registerv (:constructor nil)
 	     (:constructor registerv--make (&optional data print-func
@@ -91,6 +93,7 @@ of the marked text."
   :type '(choice (const :tag "None" nil)
 		 (character :tag "Use register" :value ?+)))
=20
+;; FIXME: This is no more needed, remove it.
 (defcustom register-preview-delay 1
   "If non-nil, time to wait in seconds before popping up register preview =
window.
 If nil, do not show register previews, unless `help-char' (or a member of
@@ -99,6 +102,14 @@ If nil, do not show register previews, unless `help-cha=
r' (or a member of
   :type '(choice number (const :tag "No preview unless requested" nil))
   :group 'register)
=20
+(defcustom register-preview-default-keys (mapcar #'string (number-sequence=
 ?a ?z))
+  "Default keys for setting a new register."
+  :type '(repeat string))
+
+(defcustom register-use-preview t
+  "Always show register preview when non nil."
+  :type 'boolean)
+
 (defun get-register (register)
   "Return contents of Emacs register named REGISTER, or nil if none."
   (alist-get register register-alist))
@@ -128,53 +139,263 @@ See the documentation of the variable `register-alis=
t' for possible VALUEs."
 Called with one argument, a cons (NAME . CONTENTS) as found in `register-a=
list'.
 The function should return a string, the description of the argument.")
=20
=2D(defun register-preview (buffer &optional show-empty)
+(cl-defstruct register-preview-info
+  "Store data for a specific register command.
+TYPES are the types of register supported.
+MSG is the minibuffer message to send when a register is selected.
+ACT is the type of action the command is doing on register.
+SMATCH accept a boolean value to say if command accept non matching regist=
er."
+  types msg act smatch)
+
+(cl-defgeneric register-command-info (command)
+  "Returns a `register-preview-info' object storing data for COMMAND."
+  (ignore command))
+(cl-defmethod register-command-info ((_command (eql insert-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Insert register `%s'"
+   :act 'insert
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql jump-to-register)))
+  (make-register-preview-info
+   :types  '(window frame marker kmacro
+             file buffer file-query)
+   :msg "Jump to register `%s'"
+   :act 'jump
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql view-register)))
+  (make-register-preview-info
+   :types '(all)
+   :msg "View register `%s'"
+   :act 'view
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql append-to-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Append to register `%s'"
+   :act 'modify
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql prepend-to-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Prepend to register `%s'"
+   :act 'modify
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql increment-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Increment register `%s'"
+   :act 'modify
+   :smatch t))
+
+(defun register-preview-forward-line (arg)
+  "Move to next or previous line in register preview buffer.
+If ARG is positive goto next line, if negative to previous.
+Do nothing when defining or executing kmacros."
+  ;; Ensure user enter manually key in minibuffer when recording a macro.
+  (unless (or defining-kbd-macro executing-kbd-macro
+              (not (get-buffer-window "*Register Preview*" 'visible)))
+    (let ((fn (if (> arg 0) #'eobp #'bobp))
+          (posfn (if (> arg 0)
+                     #'point-min
+                     (lambda () (1- (point-max)))))
+          str)
+      (with-current-buffer "*Register Preview*"
+        (let ((ovs (overlays-in (point-min) (point-max)))
+              pos)
+          (goto-char (if ovs
+                         (overlay-start (car ovs))
+                         (point-min)))
+          (setq pos (point))
+          (and ovs (forward-line arg))
+          (when (and (funcall fn)
+                     (or (> arg 0) (eql pos (point))))
+            (goto-char (funcall posfn)))
+          (setq str (buffer-substring-no-properties
+                     (pos-bol) (1+ (pos-bol))))
+          (remove-overlays)
+          (with-selected-window (minibuffer-window)
+            (delete-minibuffer-contents)
+            (insert str)))))))
+
+(defun register-preview-next ()
+  "Goto next line in register preview buffer."
+  (interactive)
+  (register-preview-forward-line 1))
+
+(defun register-preview-previous ()
+  "Goto previous line in register preview buffer."
+  (interactive)
+  (register-preview-forward-line -1))
+
+(defun register-type (register)
+  "Return REGISTER type.
+Current register types actually returned are one of:
+- string
+- number
+- marker
+- buffer
+- file
+- file-query
+- window
+- frame
+- kmacro
+
+One can add new types to a specific command by defining a new `cl-defmetho=
d'
+matching this command. Predicate for type in new `cl-defmethod' should
+satisfy `cl-typep' otherwise the new type should be defined with
+`cl-deftype'."
+  ;; Call register--type against the register value.
+  (register--type (if (consp (cdr register))
+                     (cadr register)
+                   (cdr register))))
+
+(cl-defgeneric register--type (regval)
+  "Returns type of register value REGVAL."
+  (ignore regval))
+
+(cl-defmethod register--type ((_regval string)) 'string)
+(cl-defmethod register--type ((_regval number)) 'number)
+(cl-defmethod register--type ((_regval marker)) 'marker)
+(cl-defmethod register--type ((_regval (eql 'buffer))) 'buffer)
+(cl-defmethod register--type ((_regval (eql 'file))) 'file)
+(cl-defmethod register--type ((_regval (eql 'file-query))) 'file-query)
+(cl-defmethod register--type ((_regval window-configuration)) 'window)
+(cl-deftype frame-register () '(satisfies frameset-register-p))
+(cl-defmethod register--type :extra "frame-register" (_regval) 'frame)
+(cl-deftype kmacro-register () '(satisfies kmacro-register-p))
+(cl-defmethod register--type :extra "kmacro-register" (_regval) 'kmacro)
+
+(defun register-of-type-alist (types)
+  "Filter `register-alist' according to TYPES."
+  (if (memq 'all types)
+      register-alist
+    (cl-loop for register in register-alist
+             when (memq (register-type register) types)
+             collect register)))
+
+(defun register-preview (buffer &optional show-empty types)
   "Pop up a window showing the registers preview in BUFFER.
 If SHOW-EMPTY is non-nil, show the window even if no registers.
+Argument TYPES (a list) specify the types of register to show, when nil sh=
ow all
+registers, see `register-type' for suitable types.
 Format of each entry is controlled by the variable `register-preview-funct=
ion'."
=2D  (when (or show-empty (consp register-alist))
=2D    (with-current-buffer-window
=2D     buffer
=2D     (cons 'display-buffer-below-selected
=2D	   '((window-height . fit-window-to-buffer)
=2D	     (preserve-size . (nil . t))))
=2D     nil
=2D     (with-current-buffer standard-output
=2D       (setq cursor-in-non-selected-windows nil)
=2D       (mapc (lambda (elem)
=2D               (when (get-register (car elem))
=2D                 (insert (funcall register-preview-function elem))))
=2D             register-alist)))))
+  (let ((registers (register-of-type-alist (or types '(all)))))
+    (when (or show-empty (consp registers))
+      (with-current-buffer-window
+        buffer
+        (cons 'display-buffer-below-selected
+	      '((window-height . fit-window-to-buffer)
+	        (preserve-size . (nil . t))))
+        nil
+        (with-current-buffer standard-output
+          (setq cursor-in-non-selected-windows nil)
+          (mapc (lambda (elem)
+                  (when (get-register (car elem))
+                    (insert (funcall register-preview-function elem))))
+                registers))))))
+
+(cl-defgeneric register-preview-get-defaults (action)
+  "Returns default registers according to ACTION."
+  (ignore action))
+(cl-defmethod register-preview-get-defaults ((_action (eql set)))
+  (cl-loop for s in register-preview-default-keys
+           unless (assoc (string-to-char s) register-alist)
+           collect s))
=20
 (defun register-read-with-preview (prompt)
   "Read and return a register name, possibly showing existing registers.
=2DPrompt with the string PROMPT.  If `register-alist' and
=2D`register-preview-delay' are both non-nil, display a window
=2Dlisting existing registers after `register-preview-delay' seconds.
+Prompt with the string PROMPT.
 If `help-char' (or a member of `help-event-list') is pressed,
 display such a window regardless."
   (let* ((buffer "*Register Preview*")
=2D	 (timer (when (numberp register-preview-delay)
=2D		  (run-with-timer register-preview-delay nil
=2D				  (lambda ()
=2D				    (unless (get-buffer-window buffer)
=2D				      (register-preview buffer))))))
=2D	 (help-chars (cl-loop for c in (cons help-char help-event-list)
=2D			      when (not (get-register c))
=2D			      collect c)))
+         (pat "")
+         (map (let ((m (make-sparse-keymap)))
+                (set-keymap-parent m minibuffer-local-map)
+                m))
+         (data (register-command-info this-command))
+         types msg result timer act win strs smatch)
+    (if data
+        (setq types  (register-preview-info-types data)
+              msg    (register-preview-info-msg   data)
+              act    (register-preview-info-act   data)
+              smatch (register-preview-info-smatch data))
+      (setq types '(all)
+            msg   "Overwrite register `%s'"
+            act   'set))
+    (setq strs (mapcar (lambda (x)
+                         (string (car x)))
+                       (register-of-type-alist types)))
+    (when (and (memq act '(insert jump view)) (null strs))
+      (error "No register suitable for `%s'" act))
+    (dolist (k (cons help-char help-event-list))
+      (define-key map
+          (vector k) (lambda ()
+                       (interactive)
+                       (unless (get-buffer-window buffer)
+                         (with-selected-window (minibuffer-selected-window)
+                           (register-preview buffer 'show-empty types))))))
+    (define-key map (kbd "<down>") 'register-preview-next)
+    (define-key map (kbd "<up>")   'register-preview-previous)
+    (define-key map (kbd "C-n")    'register-preview-next)
+    (define-key map (kbd "C-p")    'register-preview-previous)
+    (unless (or executing-kbd-macro (null register-use-preview))
+      (register-preview buffer nil types))
     (unwind-protect
=2D	(progn
=2D	  (while (memq (read-key (propertize prompt 'face 'minibuffer-prompt))
=2D		       help-chars)
=2D	    (unless (get-buffer-window buffer)
=2D	      (register-preview buffer 'show-empty)))
=2D          (when (or (eq ?\C-g last-input-event)
=2D                    (eq 'escape last-input-event)
=2D                    (eq ?\C-\[ last-input-event))
=2D            (keyboard-quit))
=2D	  (if (characterp last-input-event) last-input-event
=2D	    (error "Non-character input-event")))
=2D      (and (timerp timer) (cancel-timer timer))
+         (progn
+           (minibuffer-with-setup-hook
+               (lambda ()
+                 (setq timer
+                       (run-with-idle-timer
+                        0.01 'repeat
+                        (lambda ()
+                          (with-selected-window (minibuffer-window)
+                            (let ((input (minibuffer-contents)))
+                              (when (> (length input) 1)
+                                (let ((new (substring input 1))
+                                      (old (substring input 0 1)))
+                                  (setq input (if (or (null smatch)
+                                                      (member new strs))
+                                                  new old))
+                                  (delete-minibuffer-contents)
+                                  (insert input)))
+                              (when (and smatch (not (string=3D input ""))
+                                         (not (member input strs)))
+                                (setq input "")
+                                (delete-minibuffer-contents)
+                                (minibuffer-message "Not matching"))
+                              (when (not (string=3D input pat))
+                                (setq pat input))))
+                          (if (setq win (get-buffer-window buffer))
+                              (with-selected-window win
+                                (let ((ov (make-overlay (point-min) (point=
-min))))
+                                  (goto-char (point-min))
+                                  (remove-overlays)
+                                  (unless (string=3D pat "")
+                                    (if (re-search-forward (concat "^" pat=
) nil t)
+                                        (progn (move-overlay
+                                                ov
+                                                (match-beginning 0) (pos-e=
ol))
+                                               (overlay-put ov 'face 'matc=
h)
+                                               (when msg
+                                                 (with-selected-window (mi=
nibuffer-window)
+                                                   (minibuffer-message msg=
 pat))))
+                                      (with-selected-window (minibuffer-wi=
ndow)
+                                        (minibuffer-message
+                                         "Register `%s' is empty" pat))))))
+                            (unless (string=3D pat "")
+                              (if (member pat strs)
+                                  (with-selected-window (minibuffer-window)
+                                    (minibuffer-message msg pat))
+                                (with-selected-window (minibuffer-window)
+                                  (minibuffer-message
+                                   "Register `%s' is empty" pat)))))))))
+             (setq result (read-from-minibuffer
+                           prompt nil map nil nil (register-preview-get-de=
faults act))))
+           (cl-assert (and result (not (string=3D result "")))
+                      nil "No register specified")
+           (string-to-char result))
+      (when timer (cancel-timer timer))
       (let ((w (get-buffer-window buffer)))
         (and (window-live-p w) (delete-window w)))
       (and (get-buffer buffer) (kill-buffer buffer)))))
=2D-=20
2.34.1


--=-=-=--

--==-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmViY7cTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkyYKC/9RXiecwTB6vgNE/dlSve2M8NZyTsQ+
QspssF+GAtIZng1uqBtrTkEOP866cFE3OFUvn/FOd6b3J7+/eVRBPmH2+zVu8uNO
c0uEwzP1eho/THvIL5UEnmdrOdcxi48oeTb4ACtIgmPjwtlFQMMPpBwNR6rLkB4Y
fddk2vbZd6N1R16+nEmKM4B+9CsQf2HgRo5OTbPEKo5iQsss0zzubbauQKCdI+tB
7gQ/eAmUf1LZMuO9hvFUkFwXw75gRvcOpzE5aX3j4fMDNI/iRs6/NaG0+dNzmzJY
gzhodHdkc/G+tvxCvHNjwTYuaOMLITVwWl+m4G4Yp/D614yvcvbWMAw60Wp9seM1
qbOb1ELbaBo4+O7E/NnjiDtLMpGDi7GoOlxbzwPfbyd+1VVKfXEPzcMZiBPYCn9M
LgZaS47Mw+OE0LDRx8zjrsX8t5AcmpjjmbKrPVBRN1XkszQbfcYSuZoZt2K02Ryf
r1r6QuDrzkwvu3bN5V7MN9DlPERyPUnSMDA=
=lTkc
-----END PGP SIGNATURE-----
--==-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Nov 2023 20:10:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 25 15:10:43 2023
Received: from localhost ([127.0.0.1]:40353 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r6yzD-0002HG-B6
	for submit <at> debbugs.gnu.org; Sat, 25 Nov 2023 15:10:43 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:45398)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1r6yzA-0002H0-4t
 for 66394 <at> debbugs.gnu.org; Sat, 25 Nov 2023 15:10:41 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1r6yyz-0006sN-6h; Sat, 25 Nov 2023 15:10:29 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=y2nXnjDx93GIrczvUMjAdtaRBxMsBcJxqNgPQh5YcuA=; b=DdTTFtg75dsq
 SN6Fan/W4t+qvpIdO325NUNlG3SGMG623PtgM8ksXwVdDmDl6IZbcmN57EmYUCPfEpIM1yPrL+B8B
 4OqjPcAFSPt/y0DP1wz/Rb8WH2V88yy+n1VKimIE49V+sioGDs2us4q149gAxAJ5MydNDWGGmfxHQ
 JhK5XD3O1OKmXSFm6gjXXUgm2dYGaEEOLmQF+KaUvqPILKxUkj097rXD/l+xVEZZbJvVhTWt/DZSO
 U32Sy3d2m76VFcgIXYf+PvAxcZ6/G0dCersmwo2IzJUgXCc3e49FBTgvMmt1SabN5kJ7eopUBYdY3
 orxCw3meCWULPAMwQ5+R3g==;
Date: Sat, 25 Nov 2023 22:10:14 +0200
Message-Id: <83il5pbnmh.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <878r6leh9d.fsf@HIDDEN> (message from Thierry Volpiatto on
 Sat, 25 Nov 2023 19:59:26 +0000)
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN> <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN>
 <87sf50s1gh.fsf@HIDDEN> <83o7ficesp.fsf@HIDDEN>
 <878r6leh9d.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Thierry Volpiatto <thievol@HIDDEN>
> Cc: monnier@HIDDEN,  michael_heerdegen@HIDDEN,
>   stefankangas@HIDDEN,  66394 <at> debbugs.gnu.org
> Date: Sat, 25 Nov 2023 19:59:26 +0000
> 
> >     ELC      ../lisp/register.elc
> >
> >   In toplevel form:
> >   register.el:33:37: Warning: `eql' called with 1 argument, but requires 2
> >   register.el:33:45: Warning: reference to free variable `integer'
> 
> I have not these warnings.

Strange.  Maybe Stefan can explain how could that happen.

> > This then fails the build, since 'register' is preloaded.
> 
> Here it is building fine, this from the last Emacs master from tonight.

I'm also applying to master, obviously.

> > Thierry, can you please fix the code, so that I could install it?  Or
> > what am I missing?
> 
> Don't know, did you "make clean" first?

How would "make clean" help?  I did remove register.elc, it didn't
help.

> NOTE: I leaved the patch like this but it needs the change suggested by
> Stefan before merging (or with an extra commit) see above.

OK, so I guess I shouldn't have tried to install it.

> > P.S. Also, the log message is not according to our conventions.
> 
> I don't remember now what are your conventions for commits, perhaps you
> can correct it if needed?

Of course, I can correct it.  I just thought that if you are going to
submit a fixed patch, perhaps you could fix the log message as well,
to spare me some manual work.  Never mind now, since I'm not going to
install it yet.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Nov 2023 19:59:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 25 14:59:49 2023
Received: from localhost ([127.0.0.1]:40343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r6yoe-000203-JF
	for submit <at> debbugs.gnu.org; Sat, 25 Nov 2023 14:59:49 -0500
Received: from mout01.posteo.de ([185.67.36.65]:33477)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r6yoc-0001zp-H8
 for 66394 <at> debbugs.gnu.org; Sat, 25 Nov 2023 14:59:47 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id 1BECF240028
 for <66394 <at> debbugs.gnu.org>; Sat, 25 Nov 2023 20:59:35 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1700942375; bh=PAX69Stun0Qk7J2MxN+jcjbA+QHsm4pXliFLGP2FyW4=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=pGMPcVL03rs6nwOj7hHIu5mwezjLtMC3bsaULeQBfEVHPZyUB4a0NzfK35Rx2UMkz
 jGHQa62huyT5h5M0CnAblXHRJbYcXBGuBOegvmqo/J1ZgaXL7eXWIiOWxTpPaANQaq
 tkTUZMNm0htbZa5Ld1z6gz8XA41uc7i3MLDnnG5lkB1VhRwmbTnw4syzIIsCUH2mdr
 SbFQa0t3EI6C/urV8V+e9tDCir55PFxgczBCiMDlgxYF1Y/YfxFgPmWIcy7cMUI/Xd
 Zo6iIMukSmqIvdPvFPEaInMsWPiNHo43cA9Jvdy2uHi8wQ2Kxmv6qguL5nK7KBsfln
 jEoEE0WTlesxw==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4Sd2kF0wLzz6txs;
 Sat, 25 Nov 2023 20:59:32 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <83o7ficesp.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 25 Nov
 2023 12:23:18 +0200 (9 hours, 22 minutes, 8 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN> <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN>
 <87sf50s1gh.fsf@HIDDEN> <83o7ficesp.fsf@HIDDEN>
Date: Sat, 25 Nov 2023 19:59:26 +0000
Message-ID: <878r6leh9d.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Hello Eli,

Eli Zaretskii <eliz@HIDDEN> writes:

>> Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, stefankangas@HIDDEN,
>>  66394 <at> debbugs.gnu.org
>> From: Thierry Volpiatto <thievol@HIDDEN>
>> Date: Mon, 20 Nov 2023 18:51:10 +0000
>>=20
>> Stefan Monnier <monnier@HIDDEN> writes:
>>=20
>> >> Ccing also Stefan monnier because for some reasons the patch when
>> >> applied doesn't compile (when compiling Emacs) unless we add on
>> >> top:
>> >>
>> >>     (cl--generic-prefill-dispatchers 0 (eql 'x) integer)
>> >>
>> >> following the advice of the compiler,
>> >
>> > Indeed, this is needed because `register.el` is preloaded and method
>> > dispatcher are generated&compiled "on the fly" but we don't want to
>> > preload the compiler, so we want to pre-compile the dispatchers used
>> > by the preloaded code.
>> >
>> >> but I am not sure it is the way to do.
>> >
>> > `cl--generic-prefill-dispatchers` is not guaranteed to be defined when
>> > we load `register.el` (it's only defined if we loaded the non-compiled
>> > version of `cl-generic.el`) so the above call should be in
>> > `cl-generic.el` rather than in `register.el`.
>> >
>> > I'd put it next to the following block:
>> >
>> >     (cl--generic-prefill-dispatchers 0 (eql nil))
>> >     (cl--generic-prefill-dispatchers window-system (eql nil))
>> >     (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--g=
et-selection)
>> >                                      (eql nil))
>> >     (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--s=
et-selection)
>> >                                      (eql nil))
>> >
>> > which is already about dispatchers needed to support other files.
>>=20
>> I will for now leave the call to `cl--generic-prefill-dispatchers` in
>> the patch as a reminder that it should be added instead in cl-defgeneric
>> once merging.
>
> I tried to install the patch, but it fails to compile:
>
>     ELC      ../lisp/register.elc
>
>   In toplevel form:
>   register.el:33:37: Warning: `eql' called with 1 argument, but requires 2
>   register.el:33:45: Warning: reference to free variable `integer'

I have not these warnings.

> This then fails the build, since 'register' is preloaded.

Here it is building fine, this from the last Emacs master from tonight.

> Thierry, can you please fix the code, so that I could install it?  Or
> what am I missing?

Don't know, did you "make clean" first?

NOTE: I leaved the patch like this but it needs the change suggested by
Stefan before merging (or with an extra commit) see above.

> P.S. Also, the log message is not according to our conventions.

I don't remember now what are your conventions for commits, perhaps you
can correct it if needed?

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmViUh4THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk45ADACbC4OwxOe7cxEFqm8o6S0x0yeqbNKd
8DUqJHtYQx26JYQyfShmQK6CkIjT1acAaw2zDd1ijlwIA79tpG4nnMAiHX1Zr19K
DnHNqZ/kUN5kcePiNXoNbgDNln1sMorXbXJsCC1ZOpUyQZZ5U8APwjVSsdx6mFGD
HVgQTtNyJTI98Nfo8GPA1KnlTpp8JM3NNpo5uw2Qkybzm/p7qSVNfVk7m7od00on
sVSrLcV2tuJFhST4L/cO7ugtC9w2djvCyvUj9DGo5pNa12JHFW5F1DfPXejgen3B
Gp0Xg0cpam5SyatxcoD/EQnmJLmFXtpvnc2zpNX4FlLo8ozM6Nrmbj0IyOAx9dhT
GMg7ddc4WPR4INx6nMJVpzUMPISFHnVwKiRbQIgExwEMCGYTRr9Xk+dY8dGfAczT
zlxNzvWp0d60b8CEegRhFJH/sUhaZuoFVEwL7g3IlKM61GUskc9pmPP7jCVXunIm
QbMUAWUFhHfo31wi2vqWLxFwkmHQ3eveL3s=
=eRqX
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Nov 2023 10:23:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 25 05:23:46 2023
Received: from localhost ([127.0.0.1]:37911 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r6pp2-0005MI-1S
	for submit <at> debbugs.gnu.org; Sat, 25 Nov 2023 05:23:46 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:34628)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1r6poz-0005M4-VX
 for 66394 <at> debbugs.gnu.org; Sat, 25 Nov 2023 05:23:34 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1r6pon-0000E3-Ua; Sat, 25 Nov 2023 05:23:21 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=JwXxKoSwKGV49qe4ud7h8215rpr9r9qlaTHfggyX8AA=; b=I0bW3RF+kUnr
 ozw/rXmwNMwqVqUsJwD5iIOgcYSvxHQUQoshBgJFyiQupVylr9HtChrU19G3bBA3drjIvB/dfcFer
 HkCBzbxuLsT4Fc+CTEW6ub/pwz2DSlbv6ZAL/sYhBWNemvHIrYu3TpJV8WQj4mA/7FVeZdPw9IzVX
 9+7ne33dPj5dSV782CDXiUy85zpKfb+jwD+NDWp2O9HJccVCuW64dcKwpfPAmqPDE+tlBY39vtQBf
 ZihamfwIBBzWs8MYHZ31r6ZrDhAa24dXcl39qfJ742tjyZ+MEyBJGmodKgyRf7Y+9BMQWW+EMzU3M
 YZDiXQG/dyoXa3QsiaRqAg==;
Date: Sat, 25 Nov 2023 12:23:18 +0200
Message-Id: <83o7ficesp.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <87sf50s1gh.fsf@HIDDEN> (message from Thierry Volpiatto on
 Mon, 20 Nov 2023 18:51:10 +0000)
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN> <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN>
 <87sf50s1gh.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: michael_heerdegen@HIDDEN, 66394 <at> debbugs.gnu.org, monnier@HIDDEN,
 stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, stefankangas@HIDDEN,
>  66394 <at> debbugs.gnu.org
> From: Thierry Volpiatto <thievol@HIDDEN>
> Date: Mon, 20 Nov 2023 18:51:10 +0000
> 
> Stefan Monnier <monnier@HIDDEN> writes:
> 
> >> Ccing also Stefan monnier because for some reasons the patch when
> >> applied doesn't compile (when compiling Emacs) unless we add on
> >> top:
> >>
> >>     (cl--generic-prefill-dispatchers 0 (eql 'x) integer)
> >>
> >> following the advice of the compiler,
> >
> > Indeed, this is needed because `register.el` is preloaded and method
> > dispatcher are generated&compiled "on the fly" but we don't want to
> > preload the compiler, so we want to pre-compile the dispatchers used
> > by the preloaded code.
> >
> >> but I am not sure it is the way to do.
> >
> > `cl--generic-prefill-dispatchers` is not guaranteed to be defined when
> > we load `register.el` (it's only defined if we loaded the non-compiled
> > version of `cl-generic.el`) so the above call should be in
> > `cl-generic.el` rather than in `register.el`.
> >
> > I'd put it next to the following block:
> >
> >     (cl--generic-prefill-dispatchers 0 (eql nil))
> >     (cl--generic-prefill-dispatchers window-system (eql nil))
> >     (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--get-selection)
> >                                      (eql nil))
> >     (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--set-selection)
> >                                      (eql nil))
> >
> > which is already about dispatchers needed to support other files.
> 
> I will for now leave the call to `cl--generic-prefill-dispatchers` in
> the patch as a reminder that it should be added instead in cl-defgeneric
> once merging.

I tried to install the patch, but it fails to compile:

    ELC      ../lisp/register.elc

  In toplevel form:
  register.el:33:37: Warning: `eql' called with 1 argument, but requires 2
  register.el:33:45: Warning: reference to free variable `integer'

This then fails the build, since 'register' is preloaded.

Thierry, can you please fix the code, so that I could install it?  Or
what am I missing?

P.S. Also, the log message is not according to our conventions.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 20 Nov 2023 18:51:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 20 13:51:33 2023
Received: from localhost ([127.0.0.1]:54552 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r59Mr-0002vy-Ch
	for submit <at> debbugs.gnu.org; Mon, 20 Nov 2023 13:51:33 -0500
Received: from mout01.posteo.de ([185.67.36.65]:45209)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r59Mp-0002vX-BB
 for 66394 <at> debbugs.gnu.org; Mon, 20 Nov 2023 13:51:32 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id B5EBD240027
 for <66394 <at> debbugs.gnu.org>; Mon, 20 Nov 2023 19:51:22 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1700506282; bh=mluEKp0IyfrvZZ1+4OYVhC/NAbKPe0bPI5q0Bbu8wGA=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=UPUK2CTIaHgM3qOL/Ka78G6q8JrgvpSVxou5g8BhmAlucwoTTaMXbUv2pX9pCzcM2
 cc5vZ0jaN2BNThkXDunwzXUTKqDhTkq7meybm7ITgurhb06iLi7kA1F7hh3Fbsf/A4
 1bzdHdcSO262LbWvP3IEB0RTQfPkmYlAXEB5kI3ua+YPaZ/y/QOkSqJ5Z4FDkJ4hnW
 FsRnlyvsyZtrvoCx6X0MG6Al1Wd9sWB2KKywGsza6YvpZplnE6ASxUTIQ0Rx47V6vK
 elbmj0mWfGAajj/MDer+gaZP6zRc4OrNqxYcaaJYihLwhbN6Wj20+AFQYtlyI/Mw+H
 YQdgH0ryRwXHg==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SYxRq2wYwz6twH;
 Mon, 20 Nov 2023 19:51:19 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
 of "Mon, 20 Nov 2023 12:33:57 -0500 (1 hour, 11 minutes,
 21 seconds ago)")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN> <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN>
Date: Mon, 20 Nov 2023 18:51:10 +0000
Message-ID: <87sf50s1gh.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, stefankangas@HIDDEN,
 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Hello Stefan,

Stefan Monnier <monnier@HIDDEN> writes:

>> Ccing also Stefan monnier because for some reasons the patch when
>> applied doesn't compile (when compiling Emacs) unless we add on
>> top:
>>
>>     (cl--generic-prefill-dispatchers 0 (eql 'x) integer)
>>
>> following the advice of the compiler,
>
> Indeed, this is needed because `register.el` is preloaded and method
> dispatcher are generated&compiled "on the fly" but we don't want to
> preload the compiler, so we want to pre-compile the dispatchers used
> by the preloaded code.
>
>> but I am not sure it is the way to do.
>
> `cl--generic-prefill-dispatchers` is not guaranteed to be defined when
> we load `register.el` (it's only defined if we loaded the non-compiled
> version of `cl-generic.el`) so the above call should be in
> `cl-generic.el` rather than in `register.el`.
>
> I'd put it next to the following block:
>
>     (cl--generic-prefill-dispatchers 0 (eql nil))
>     (cl--generic-prefill-dispatchers window-system (eql nil))
>     (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--get-=
selection)
>                                      (eql nil))
>     (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--set-=
selection)
>                                      (eql nil))
>
> which is already about dispatchers needed to support other files.

I will for now leave the call to `cl--generic-prefill-dispatchers` in
the patch as a reminder that it should be added instead in cl-defgeneric
once merging.

Thanks for your explanation.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVbqp4THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk/CzDACNmJnp2vjZHivfKf7dIjo6SUtSGWZq
Vgmwuc5Gb0qqidY4G5YJXwk+UsREzdF9DFhbTzU+0yEcykTyOtCTTbPwxUfsF/hS
HF1e4j0A1/dKhv40hrHTYBZSh0OaAhIspekcDP9xdx3aLx3lqzeiCrXBS8zAxtCs
SZUEu0htk2eonBwdSc9hCwPEAkmnd/pHuGr+9gk+pcft/4k7gus+NaSSQKG7XV2U
DTuii6awpm7/6B/feUR67LVUgYeijbEwwsZ8VxLk7f4NClhpay5RZqXVac111ceU
5P/BUxDq96LsCDt98Rr+Gd/yQ866015Bgg7K9WOaU1evM/IHSx0ZXZH4m60Qyuu0
cx+ivp7/Sr5nbiugLZw0ul/kl47EwOiAsKhzfcptWflvvnnkazgW1zXTzROTinfW
CdO0yyPqUKocDRu/N5MvK1bWyZupHVVsOhjn+vVNRYivgXdQfyabKHAmyzC0TUMY
z4TUoHfGDP3tjY3kTaKylaaE43Wk/khp48k=
=30Hl
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 20 Nov 2023 17:36:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 20 12:36:46 2023
Received: from localhost ([127.0.0.1]:54442 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r58CU-0000ho-Az
	for submit <at> debbugs.gnu.org; Mon, 20 Nov 2023 12:36:46 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:18801)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1r58CQ-0000hY-R7
 for 66394 <at> debbugs.gnu.org; Mon, 20 Nov 2023 12:36:44 -0500
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id B60E0442854;
 Mon, 20 Nov 2023 12:36:34 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1700501793;
 bh=qHeK5eP5bn3o/6GKjMuYpBC9C/PT31VnhyR5wYBFNI4=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=gtX+xEObATn6Z1nL5IAlOkXhKADv7wy3QOAEfcDg3cbHURJXZqMNTWaV9WDDp/uzp
 hrMIGOqzP8B2QxABEUcHrg4wppoS6xpbXI6P0tOYZdIkWJiXcMhE6Pq91zQsKD2XaH
 qJJOskH7srghpgFxp2I29eP7j6QwkLsbZb+oU2tzqkvbsEfJ59CJVjaq0c60sJ5pbc
 6fttW6GgDLYx3hi9b0Tl1gmWSn1dQEjT2SyCbhZSzbpCcBTzSHdU4pJsn64ui4fVkt
 RBBYu880hiWWlull7K48owpf88Bm58j+GkY9u2PWJQgOPQZi57H3SRXLJgfs+1W1NX
 8y6Yf0PVTqKqg==
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 226FB442852;
 Mon, 20 Nov 2023 12:36:33 -0500 (EST)
Received: from lechazo (lechon.iro.umontreal.ca [132.204.27.242])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 0B128120387;
 Mon, 20 Nov 2023 12:36:33 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <877cmdx8ud.fsf@HIDDEN> (Thierry Volpiatto's message of "Mon, 
 20 Nov 2023 06:00:26 +0000")
Message-ID: <jwvjzqcxrnq.fsf-monnier+emacs@HIDDEN>
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
 <877cmdx8ud.fsf@HIDDEN>
Date: Mon, 20 Nov 2023 12:33:57 -0500
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.115 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
 DKIM_VALID_EF -0.1 Message has a valid DKIM or DK signature from envelope-from
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, stefankangas@HIDDEN,
 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Ccing also Stefan monnier because for some reasons the patch when
> applied doesn't compile (when compiling Emacs) unless we add on
> top:
>
>     (cl--generic-prefill-dispatchers 0 (eql 'x) integer)
>
> following the advice of the compiler,

Indeed, this is needed because `register.el` is preloaded and method
dispatcher are generated&compiled "on the fly" but we don't want to
preload the compiler, so we want to pre-compile the dispatchers used
by the preloaded code.

> but I am not sure it is the way to do.

`cl--generic-prefill-dispatchers` is not guaranteed to be defined when
we load `register.el` (it's only defined if we loaded the non-compiled
version of `cl-generic.el`) so the above call should be in
`cl-generic.el` rather than in `register.el`.

I'd put it next to the following block:

    (cl--generic-prefill-dispatchers 0 (eql nil))
    (cl--generic-prefill-dispatchers window-system (eql nil))
    (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--get-selection)
                                     (eql nil))
    (cl--generic-prefill-dispatchers (terminal-parameter nil 'xterm--set-selection)
                                     (eql nil))

which is already about dispatchers needed to support other files.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 20 Nov 2023 06:00:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 20 01:00:53 2023
Received: from localhost ([127.0.0.1]:52393 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r4xL2-0006lQ-Nb
	for submit <at> debbugs.gnu.org; Mon, 20 Nov 2023 01:00:53 -0500
Received: from mout01.posteo.de ([185.67.36.65]:37477)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r4xKx-0006l8-7c
 for 66394 <at> debbugs.gnu.org; Mon, 20 Nov 2023 01:00:51 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id 61B6F240027
 for <66394 <at> debbugs.gnu.org>; Mon, 20 Nov 2023 07:00:38 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1700460038; bh=aHA4aV0NNXeHz+aJhEM9SVCVz9p6l464DBekTcZ4gek=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=bVKw+EiB4t2NUDLEvskTWyh2evHsQ3kmVV/+UHOEYAc3Je39B66ULVLTZIK3SP6jb
 0hralYiDv9W++1SPsSrBSE61xr2OSx3aLDy5wRhKzFvNiEkku6+cjyVMc7M+zCw/ZB
 qsEI8vzY/1HsESk2L/pVLWegeEs2WcXaWwKH6yTcjs/LR+jyATEwvnWGiEAX4EUNgc
 eQNTNrTK4N7FdubVnYFxV+wTK2RMEvCeLGppEjOSc31eiKxelPFILa0A23Vaffw14U
 q+zOyLeJL0C613YQzrB5+cVdQxyDw4Zat6JSg5lZrVRQutRjsfkMiuzqJXJbbGvEPJ
 GWU8Upa7mswbw==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SYcLV6CR0z6tw6;
 Mon, 20 Nov 2023 07:00:34 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87r0l73029.fsf@HIDDEN> (Michael Heerdegen's message of "Fri, 03
 Nov 2023 05:58:22 +0100")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
Date: Mon, 20 Nov 2023 06:00:26 +0000
Message-ID: <877cmdx8ud.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="==-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: stefankangas@HIDDEN, monnier@HIDDEN, 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--==-=-=
Content-Type: multipart/mixed; boundary="=-=-="

--=-=-=
Content-Type: text/plain


Here the full patch attached, the previous was not applying properly.

Ccing also Stefan monnier because for some reasons the patch when
applied doesn't compile (when compiling Emacs) unless we add on
top:

    (cl--generic-prefill-dispatchers 0 (eql 'x) integer)

following the advice of the compiler, but I am not sure it is the way to
do.

Compiling register.el manually without this works correctly.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: attachment;
 filename=0001-Improve-register-preview-Fix-bug-66394.patch
Content-Transfer-Encoding: quoted-printable
Content-Description: register-preview

From=20c794d62a45b4c83131e506699f465e54b7dae7b5 Mon Sep 17 00:00:00 2001
From: Thierry Volpiatto <thievol@HIDDEN>
Date: Sun, 19 Nov 2023 20:42:56 +0100
Subject: [PATCH] Improve register-preview (Fix bug#66394)

A minibuffer is used now instead of read-key.
Registers in preview buffer are now filtered according to type of
registers the current command requires.
Navigation with C-n/p or up/down is now provided and update
minibuffer.
Current register is highlighted in preview buffer.

* register.el:

* (register-preview-default-keys): new user var.
* (register-use-preview): Same.
* (register-preview-info): New structure to store various info for
  preview.
* (register-command-info): New generic.
* (register-preview-forward-line): New, provide navigation in preview
  buffer.
* (register-preview-next, register-preview-previous): New, navigation.
* (register-type): New, returns register type.
* (register--type): Generic fn, new, returns register type according
  to value.
* (register-of-type-alist): New, filter register-alist according to
  type.
* (register-preview): Signature changed, use TYPES now.
* (register-preview-get-defaults): New generic, compute defauts
  according to action.
* (register-read-with-preview): Now use read-from-minibuffer and
  minibuffer-setup-hook.
=2D--
 lisp/register.el | 296 +++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 259 insertions(+), 37 deletions(-)

diff --git a/lisp/register.el b/lisp/register.el
index ca6de450993..47f0dfa389c 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -30,11 +30,14 @@
 ;; documented in the Emacs user's manual: (info "(emacs) Registers").
=20
 (eval-when-compile (require 'cl-lib))
+(cl--generic-prefill-dispatchers 0 (eql 'x) integer)
=20
 ;;; Code:
=20
 ;; FIXME: Clean up namespace usage!
=20
+(declare-function frameset-register-p "frameset")
+
 (cl-defstruct
   (registerv (:constructor nil)
 	     (:constructor registerv--make (&optional data print-func
@@ -91,6 +94,7 @@ of the marked text."
   :type '(choice (const :tag "None" nil)
 		 (character :tag "Use register" :value ?+)))
=20
+;; FIXME: This is no more needed, remove it.
 (defcustom register-preview-delay 1
   "If non-nil, time to wait in seconds before popping up register preview =
window.
 If nil, do not show register previews, unless `help-char' (or a member of
@@ -99,6 +103,14 @@ If nil, do not show register previews, unless `help-cha=
r' (or a member of
   :type '(choice number (const :tag "No preview unless requested" nil))
   :group 'register)
=20
+(defcustom register-preview-default-keys (mapcar #'string (number-sequence=
 ?a ?z))
+  "Default keys for setting a new register."
+  :type '(repeat string))
+
+(defcustom register-use-preview t
+  "Always show register preview when non nil."
+  :type 'boolean)
+
 (defun get-register (register)
   "Return contents of Emacs register named REGISTER, or nil if none."
   (alist-get register register-alist))
@@ -128,53 +140,263 @@ See the documentation of the variable `register-alis=
t' for possible VALUEs."
 Called with one argument, a cons (NAME . CONTENTS) as found in `register-a=
list'.
 The function should return a string, the description of the argument.")
=20
=2D(defun register-preview (buffer &optional show-empty)
+(cl-defstruct register-preview-info
+  "Store data for a specific register command.
+TYPES are the types of register supported.
+MSG is the minibuffer message to send when a register is selected.
+ACT is the type of action the command is doing on register.
+SMATCH accept a boolean value to say if command accept non matching regist=
er."
+  types msg act smatch)
+
+(cl-defgeneric register-command-info (command)
+  "Returns a `register-preview-info' object storing data for COMMAND."
+  (ignore command))
+(cl-defmethod register-command-info ((_command (eql insert-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Insert register `%s'"
+   :act 'insert
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql jump-to-register)))
+  (make-register-preview-info
+   :types  '(window frame marker kmacro
+             file buffer file-query)
+   :msg "Jump to register `%s'"
+   :act 'jump
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql view-register)))
+  (make-register-preview-info
+   :types '(all)
+   :msg "View register `%s'"
+   :act 'view
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql append-to-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Append to register `%s'"
+   :act 'modify
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql prepend-to-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Prepend to register `%s'"
+   :act 'modify
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql increment-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Increment register `%s'"
+   :act 'modify
+   :smatch t))
+
+(defun register-preview-forward-line (arg)
+  "Move to next or previous line in register preview buffer.
+If ARG is positive goto next line, if negative to previous.
+Do nothing when defining or executing kmacros."
+  ;; Ensure user enter manually key in minibuffer when recording a macro.
+  (unless (or defining-kbd-macro executing-kbd-macro
+              (not (get-buffer-window "*Register Preview*" 'visible)))
+    (let ((fn (if (> arg 0) #'eobp #'bobp))
+          (posfn (if (> arg 0)
+                     #'point-min
+                     (lambda () (1- (point-max)))))
+          str)
+      (with-current-buffer "*Register Preview*"
+        (let ((ovs (overlays-in (point-min) (point-max)))
+              pos)
+          (goto-char (if ovs
+                         (overlay-start (car ovs))
+                         (point-min)))
+          (setq pos (point))
+          (and ovs (forward-line arg))
+          (when (and (funcall fn)
+                     (or (> arg 0) (eql pos (point))))
+            (goto-char (funcall posfn)))
+          (setq str (buffer-substring-no-properties
+                     (pos-bol) (1+ (pos-bol))))
+          (remove-overlays)
+          (with-selected-window (minibuffer-window)
+            (delete-minibuffer-contents)
+            (insert str)))))))
+
+(defun register-preview-next ()
+  "Goto next line in register preview buffer."
+  (interactive)
+  (register-preview-forward-line 1))
+
+(defun register-preview-previous ()
+  "Goto previous line in register preview buffer."
+  (interactive)
+  (register-preview-forward-line -1))
+
+(defun register-type (register)
+  "Return REGISTER type.
+Current register types actually returned are one of:
+- string
+- number
+- marker
+- buffer
+- file
+- file-query
+- window
+- frame
+- kmacro
+
+One can add new types to a specific command by defining a new `cl-defmetho=
d'
+matching this command. Predicate for type in new `cl-defmethod' should
+satisfy `cl-typep' otherwise the new type should be defined with
+`cl-deftype'."
+  ;; Call register--type against the register value.
+  (register--type (if (consp (cdr register))
+                     (cadr register)
+                   (cdr register))))
+
+(cl-defgeneric register--type (regval)
+  "Returns type of register value REGVAL."
+  (ignore regval))
+
+(cl-defmethod register--type ((_regval string)) 'string)
+(cl-defmethod register--type ((_regval number)) 'number)
+(cl-defmethod register--type ((_regval marker)) 'marker)
+(cl-defmethod register--type ((_regval (eql 'buffer))) 'buffer)
+(cl-defmethod register--type ((_regval (eql 'file))) 'file)
+(cl-defmethod register--type ((_regval (eql 'file-query))) 'file-query)
+(cl-defmethod register--type ((_regval window-configuration)) 'window)
+(cl-deftype frame-register () '(satisfies frameset-register-p))
+(cl-defmethod register--type :extra "frame-register" (_regval) 'frame)
+(cl-deftype kmacro-register () '(satisfies kmacro-register-p))
+(cl-defmethod register--type :extra "kmacro-register" (_regval) 'kmacro)
+
+(defun register-of-type-alist (types)
+  "Filter `register-alist' according to TYPES."
+  (if (memq 'all types)
+      register-alist
+    (cl-loop for register in register-alist
+             when (memq (register-type register) types)
+             collect register)))
+
+(defun register-preview (buffer &optional show-empty types)
   "Pop up a window showing the registers preview in BUFFER.
 If SHOW-EMPTY is non-nil, show the window even if no registers.
+Argument TYPES (a list) specify the types of register to show, when nil sh=
ow all
+registers, see `register-type' for suitable types.
 Format of each entry is controlled by the variable `register-preview-funct=
ion'."
=2D  (when (or show-empty (consp register-alist))
=2D    (with-current-buffer-window
=2D     buffer
=2D     (cons 'display-buffer-below-selected
=2D	   '((window-height . fit-window-to-buffer)
=2D	     (preserve-size . (nil . t))))
=2D     nil
=2D     (with-current-buffer standard-output
=2D       (setq cursor-in-non-selected-windows nil)
=2D       (mapc (lambda (elem)
=2D               (when (get-register (car elem))
=2D                 (insert (funcall register-preview-function elem))))
=2D             register-alist)))))
+  (let ((registers (register-of-type-alist (or types '(all)))))
+    (when (or show-empty (consp registers))
+      (with-current-buffer-window
+        buffer
+        (cons 'display-buffer-below-selected
+	      '((window-height . fit-window-to-buffer)
+	        (preserve-size . (nil . t))))
+        nil
+        (with-current-buffer standard-output
+          (setq cursor-in-non-selected-windows nil)
+          (mapc (lambda (elem)
+                  (when (get-register (car elem))
+                    (insert (funcall register-preview-function elem))))
+                registers))))))
+
+(cl-defgeneric register-preview-get-defaults (action)
+  "Returns default registers according to ACTION."
+  (ignore action))
+(cl-defmethod register-preview-get-defaults ((_action (eql set)))
+  (cl-loop for s in register-preview-default-keys
+           unless (assoc (string-to-char s) register-alist)
+           collect s))
=20
 (defun register-read-with-preview (prompt)
   "Read and return a register name, possibly showing existing registers.
=2DPrompt with the string PROMPT.  If `register-alist' and
=2D`register-preview-delay' are both non-nil, display a window
=2Dlisting existing registers after `register-preview-delay' seconds.
+Prompt with the string PROMPT.
 If `help-char' (or a member of `help-event-list') is pressed,
 display such a window regardless."
   (let* ((buffer "*Register Preview*")
=2D	 (timer (when (numberp register-preview-delay)
=2D		  (run-with-timer register-preview-delay nil
=2D				  (lambda ()
=2D				    (unless (get-buffer-window buffer)
=2D				      (register-preview buffer))))))
=2D	 (help-chars (cl-loop for c in (cons help-char help-event-list)
=2D			      when (not (get-register c))
=2D			      collect c)))
+         (pat "")
+         (map (let ((m (make-sparse-keymap)))
+                (set-keymap-parent m minibuffer-local-map)
+                m))
+         (data (register-command-info this-command))
+         types msg result timer act win strs smatch)
+    (if data
+        (setq types  (register-preview-info-types data)
+              msg    (register-preview-info-msg   data)
+              act    (register-preview-info-act   data)
+              smatch (register-preview-info-smatch data))
+      (setq types '(all)
+            msg   "Overwrite register `%s'"
+            act   'set))
+    (setq strs (mapcar (lambda (x)
+                         (string (car x)))
+                       (register-of-type-alist types)))
+    (when (and (memq act '(insert jump view)) (null strs))
+      (error "No register suitable for `%s'" act))
+    (dolist (k (cons help-char help-event-list))
+      (define-key map
+          (vector k) (lambda ()
+                       (interactive)
+                       (unless (get-buffer-window buffer)
+                         (with-selected-window (minibuffer-selected-window)
+                           (register-preview buffer 'show-empty types))))))
+    (define-key map (kbd "<down>") 'register-preview-next)
+    (define-key map (kbd "<up>")   'register-preview-previous)
+    (define-key map (kbd "C-n")    'register-preview-next)
+    (define-key map (kbd "C-p")    'register-preview-previous)
+    (unless (or executing-kbd-macro (null register-use-preview))
+      (register-preview buffer nil types))
     (unwind-protect
=2D	(progn
=2D	  (while (memq (read-key (propertize prompt 'face 'minibuffer-prompt))
=2D		       help-chars)
=2D	    (unless (get-buffer-window buffer)
=2D	      (register-preview buffer 'show-empty)))
=2D          (when (or (eq ?\C-g last-input-event)
=2D                    (eq 'escape last-input-event)
=2D                    (eq ?\C-\[ last-input-event))
=2D            (keyboard-quit))
=2D	  (if (characterp last-input-event) last-input-event
=2D	    (error "Non-character input-event")))
=2D      (and (timerp timer) (cancel-timer timer))
+         (progn
+           (minibuffer-with-setup-hook
+               (lambda ()
+                 (setq timer
+                       (run-with-idle-timer
+                        0.01 'repeat
+                        (lambda ()
+                          (with-selected-window (minibuffer-window)
+                            (let ((input (minibuffer-contents)))
+                              (when (> (length input) 1)
+                                (let ((new (substring input 1))
+                                      (old (substring input 0 1)))
+                                  (setq input (if (or (null smatch)
+                                                      (member new strs))
+                                                  new old))
+                                  (delete-minibuffer-contents)
+                                  (insert input)))
+                              (when (and smatch (not (string=3D input ""))
+                                         (not (member input strs)))
+                                (setq input "")
+                                (delete-minibuffer-contents)
+                                (minibuffer-message "Not matching"))
+                              (when (not (string=3D input pat))
+                                (setq pat input))))
+                          (if (setq win (get-buffer-window buffer))
+                              (with-selected-window win
+                                (let ((ov (make-overlay (point-min) (point=
-min))))
+                                  (goto-char (point-min))
+                                  (remove-overlays)
+                                  (unless (string=3D pat "")
+                                    (if (re-search-forward (concat "^" pat=
) nil t)
+                                        (progn (move-overlay
+                                                ov
+                                                (match-beginning 0) (pos-e=
ol))
+                                               (overlay-put ov 'face 'matc=
h)
+                                               (when msg
+                                                 (with-selected-window (mi=
nibuffer-window)
+                                                   (minibuffer-message msg=
 pat))))
+                                      (with-selected-window (minibuffer-wi=
ndow)
+                                        (minibuffer-message
+                                         "Register `%s' is empty" pat))))))
+                            (unless (string=3D pat "")
+                              (if (member pat strs)
+                                  (with-selected-window (minibuffer-window)
+                                    (minibuffer-message msg pat))
+                                (with-selected-window (minibuffer-window)
+                                  (minibuffer-message
+                                   "Register `%s' is empty" pat)))))))))
+             (setq result (read-from-minibuffer
+                           prompt nil map nil nil (register-preview-get-de=
faults act))))
+           (cl-assert (and result (not (string=3D result "")))
+                      nil "No register specified")
+           (string-to-char result))
+      (when timer (cancel-timer timer))
       (let ((w (get-buffer-window buffer)))
         (and (window-live-p w) (delete-window w)))
       (and (get-buffer buffer) (kill-buffer buffer)))))
=2D-=20
2.34.1


--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


=2D-=20
Thierry

--=-=-=--

--==-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVa9foTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk1OZC/oD6jAYsGPcAsKKCcp/op/lF9d5jiZd
1NXhqjNkKPOiqR1G0texaerIJdPzZM9DrsEPArLrGGEkziwUA6M1rRxx6RB65cTs
ha1dX+RNV1Ha9wr+bIb5cjbHMu1RdGYBP+R54atJn4JJlNsaSy461mkzpDNnrhC9
tudq0Hev6XusKRJPOoJMzQs6OLbEB8N6vk62ZKGj16awOTdQfvYOJug1LTRIJeBZ
pK9KKOZStHPqxC0UpsM4aiTicqT/xId+pxLI3tFh8Yv+qEM22q5e5QDCSqM8YMb5
Sv4WFs29xtPBRAonjljb3k1D6Ge/U3X6vYa7OLAwyhDmvllOoNDbiMfBrqqhAGka
AjP/vqIdl/59+h2ZLOxV6tCNLtbb0ziXEVFMioDo7waSr9zErxwRO3kkJBOTcAsE
kYr7DhuzftD7Ykaz52DwBQwAA62dfbaUEPFw60/DwYJDmquvDaiq4NKPgBX3wDxr
Kk9g+lGZ8OdrILhNnqG1LO+ls6riMjL9uDg=
=KMSD
-----END PGP SIGNATURE-----
--==-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 19 Nov 2023 19:37:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 19 14:37:42 2023
Received: from localhost ([127.0.0.1]:52119 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r4nbx-0001rh-UI
	for submit <at> debbugs.gnu.org; Sun, 19 Nov 2023 14:37:42 -0500
Received: from mout02.posteo.de ([185.67.36.66]:49027)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r4nbt-0001rR-Kj
 for 66394 <at> debbugs.gnu.org; Sun, 19 Nov 2023 14:37:40 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id E7A9F240103
 for <66394 <at> debbugs.gnu.org>; Sun, 19 Nov 2023 20:37:29 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1700422649; bh=H9mAtTzFb283bNNSBcdK5A6+8aoN1wDDe0LPIJ42Cgk=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=FZbVaSRAjH/TtZh5+V0aOpuVqc7P7AFDFUC96+Ko/hl25PPmXFpV1YpyiQnQKa7yo
 W7PsOOlx4UXF7z5DUopcJHOBHZqqmszr2TNjaGL+oZgl5Fwgyi534Ei1/5FqPhYCxK
 aZVuutkJ6BLqxWbOdWLkXIeiDD/wqMNtLcGkEifm7dU7Cj7Sqd5MZjRO0bsTQhvJak
 NnNtmK2st+4t8fkIkQ0kWHIPOUL7Y0v+Nr/7qA8V9u1IiOkQw/YgAimuBwcmI7IuO9
 NW1DmMVBWM2So7PdgaJHWkLtIskW57MGtMk4RUHTwXNkCR7y0JLiPplPkbF2XNJFfp
 nyI5z07Bdh4vA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SYLWW4n9yz6ty0;
 Sun, 19 Nov 2023 20:37:27 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87r0l73029.fsf@HIDDEN> (Michael Heerdegen's message of "Fri, 03
 Nov 2023 05:58:22 +0100")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN> <87r0l73029.fsf@HIDDEN>
Date: Sun, 19 Nov 2023 19:37:18 +0000
Message-ID: <87fs11y1ox.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> > Maybe in the future we might need to pass other predicates as well.
>> > What when a user wants to add another register command?
>>
>> You can with the current register-preview.el add a new command and
>> control filtering of this command.
>
> Cool, thanks.  Looks reasonable.
>
> In my perfect world, the `register-commands-data' would not be specified
> as a list but also using methods.  Maybe also
> `register-preview-get-defaults'.
>
> I will have a closer look tomorrow, had been a little busy so that I
> just now returned to this thread.

Here all the work done so far.

diff --git a/lisp/register.el b/lisp/register.el
index ca6de450993..78643d10c17 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -35,6 +35,8 @@
=20
 ;; FIXME: Clean up namespace usage!
=20
+(declare-function frameset-register-p "frameset")
+
 (cl-defstruct
   (registerv (:constructor nil)
 	     (:constructor registerv--make (&optional data print-func
@@ -91,6 +93,7 @@ of the marked text."
   :type '(choice (const :tag "None" nil)
 		 (character :tag "Use register" :value ?+)))
=20
+;; FIXME: This is no more needed, remove it.
 (defcustom register-preview-delay 1
   "If non-nil, time to wait in seconds before popping up register preview =
window.
 If nil, do not show register previews, unless `help-char' (or a member of
@@ -99,6 +102,14 @@ If nil, do not show register previews, unless `help-cha=
r' (or a member of
   :type '(choice number (const :tag "No preview unless requested" nil))
   :group 'register)
=20
+(defcustom register-preview-default-keys (mapcar #'string (number-sequence=
 ?a ?z))
+  "Default keys for setting a new register."
+  :type '(repeat string))
+
+(defcustom register-use-preview t
+  "Always show register preview when non nil."
+  :type 'boolean)
+
 (defun get-register (register)
   "Return contents of Emacs register named REGISTER, or nil if none."
   (alist-get register register-alist))
@@ -128,53 +139,263 @@ See the documentation of the variable `register-alis=
t' for possible VALUEs."
 Called with one argument, a cons (NAME . CONTENTS) as found in `register-a=
list'.
 The function should return a string, the description of the argument.")
=20
=2D(defun register-preview (buffer &optional show-empty)
+(cl-defstruct register-preview-info
+  "Store data for a specific register command.
+TYPES are the types of register supported.
+MSG is the minibuffer message to send when a register is selected.
+ACT is the type of action the command is doing on register.
+SMATCH accept a boolean value to say if command accept non matching regist=
er."
+  types msg act smatch)
+
+(cl-defgeneric register-command-info (command)
+  "Returns a `register-preview-info' object storing data for COMMAND."
+  (ignore command))
+(cl-defmethod register-command-info ((_command (eql insert-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Insert register `%s'"
+   :act 'insert
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql jump-to-register)))
+  (make-register-preview-info
+   :types  '(window frame marker kmacro
+             file buffer file-query)
+   :msg "Jump to register `%s'"
+   :act 'jump
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql view-register)))
+  (make-register-preview-info
+   :types '(all)
+   :msg "View register `%s'"
+   :act 'view
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql append-to-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Append to register `%s'"
+   :act 'modify
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql prepend-to-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Prepend to register `%s'"
+   :act 'modify
+   :smatch t))
+(cl-defmethod register-command-info ((_command (eql increment-register)))
+  (make-register-preview-info
+   :types '(string number)
+   :msg "Increment register `%s'"
+   :act 'modify
+   :smatch t))
+
+(defun register-preview-forward-line (arg)
+  "Move to next or previous line in register preview buffer.
+If ARG is positive goto next line, if negative to previous.
+Do nothing when defining or executing kmacros."
+  ;; Ensure user enter manually key in minibuffer when recording a macro.
+  (unless (or defining-kbd-macro executing-kbd-macro
+              (not (get-buffer-window "*Register Preview*" 'visible)))
+    (let ((fn (if (> arg 0) #'eobp #'bobp))
+          (posfn (if (> arg 0)
+                     #'point-min
+                     (lambda () (1- (point-max)))))
+          str)
+      (with-current-buffer "*Register Preview*"
+        (let ((ovs (overlays-in (point-min) (point-max)))
+              pos)
+          (goto-char (if ovs
+                         (overlay-start (car ovs))
+                         (point-min)))
+          (setq pos (point))
+          (and ovs (forward-line arg))
+          (when (and (funcall fn)
+                     (or (> arg 0) (eql pos (point))))
+            (goto-char (funcall posfn)))
+          (setq str (buffer-substring-no-properties
+                     (pos-bol) (1+ (pos-bol))))
+          (remove-overlays)
+          (with-selected-window (minibuffer-window)
+            (delete-minibuffer-contents)
+            (insert str)))))))
+
+(defun register-preview-next ()
+  "Goto next line in register preview buffer."
+  (interactive)
+  (register-preview-forward-line 1))
+
+(defun register-preview-previous ()
+  "Goto previous line in register preview buffer."
+  (interactive)
+  (register-preview-forward-line -1))
+
+(defun register-type (register)
+  "Return REGISTER type.
+Current register types actually returned are one of:
+- string
+- number
+- marker
+- buffer
+- file
+- file-query
+- window
+- frame
+- kmacro
+
+One can add new types to a specific command by defining a new `cl-defmetho=
d'
+matching this command. Predicate for type in new `cl-defmethod' should
+satisfy `cl-typep' otherwise the new type should be defined with
+`cl-deftype'."
+  ;; Call register--type against the register value.
+  (register--type (if (consp (cdr register))
+                     (cadr register)
+                   (cdr register))))
+
+(cl-defgeneric register--type (regval)
+  "Returns type of register value REGVAL."
+  (ignore regval))
+
+(cl-defmethod register--type ((_regval string)) 'string)
+(cl-defmethod register--type ((_regval number)) 'number)
+(cl-defmethod register--type ((_regval marker)) 'marker)
+(cl-defmethod register--type ((_regval (eql 'buffer))) 'buffer)
+(cl-defmethod register--type ((_regval (eql 'file))) 'file)
+(cl-defmethod register--type ((_regval (eql 'file-query))) 'file-query)
+(cl-defmethod register--type ((_regval window-configuration)) 'window)
+(cl-deftype frame-register () '(satisfies frameset-register-p))
+(cl-defmethod register--type :extra "frame-register" (_regval) 'frame)
+(cl-deftype kmacro-register () '(satisfies kmacro-register-p))
+(cl-defmethod register--type :extra "kmacro-register" (_regval) 'kmacro)
+
+(defun register-of-type-alist (types)
+  "Filter `register-alist' according to TYPES."
+  (if (memq 'all types)
+      register-alist
+    (cl-loop for register in register-alist
+             when (memq (register-type register) types)
+             collect register)))
+
+(defun register-preview-1 (buffer &optional show-empty types)
   "Pop up a window showing the registers preview in BUFFER.
 If SHOW-EMPTY is non-nil, show the window even if no registers.
+Argument TYPES (a list) specify the types of register to show, when nil sh=
ow all
+registers, see `register-type' for suitable types.=20
 Format of each entry is controlled by the variable `register-preview-funct=
ion'."
=2D  (when (or show-empty (consp register-alist))
=2D    (with-current-buffer-window
=2D     buffer
=2D     (cons 'display-buffer-below-selected
=2D	   '((window-height . fit-window-to-buffer)
=2D	     (preserve-size . (nil . t))))
=2D     nil
=2D     (with-current-buffer standard-output
=2D       (setq cursor-in-non-selected-windows nil)
=2D       (mapc (lambda (elem)
=2D               (when (get-register (car elem))
=2D                 (insert (funcall register-preview-function elem))))
=2D             register-alist)))))
+  (let ((registers (register-of-type-alist (or types '(all)))))
+    (when (or show-empty (consp registers))
+      (with-current-buffer-window
+        buffer
+        (cons 'display-buffer-below-selected
+	      '((window-height . fit-window-to-buffer)
+	        (preserve-size . (nil . t))))
+        nil
+        (with-current-buffer standard-output
+          (setq cursor-in-non-selected-windows nil)
+          (mapc (lambda (elem)
+                  (when (get-register (car elem))
+                    (insert (funcall register-preview-function elem))))
+                registers))))))
+
+(cl-defgeneric register-preview-get-defaults (action)
+  "Returns default registers according to ACTION."
+  (ignore action))
+(cl-defmethod register-preview-get-defaults ((_action (eql set)))
+  (cl-loop for s in register-preview-default-keys
+           unless (assoc (string-to-char s) register-alist)
+           collect s))
=20
 (defun register-read-with-preview (prompt)
   "Read and return a register name, possibly showing existing registers.
=2DPrompt with the string PROMPT.  If `register-alist' and
=2D`register-preview-delay' are both non-nil, display a window
=2Dlisting existing registers after `register-preview-delay' seconds.
+Prompt with the string PROMPT.
 If `help-char' (or a member of `help-event-list') is pressed,
 display such a window regardless."
   (let* ((buffer "*Register Preview*")
=2D	 (timer (when (numberp register-preview-delay)
=2D		  (run-with-timer register-preview-delay nil
=2D				  (lambda ()
=2D				    (unless (get-buffer-window buffer)
=2D				      (register-preview buffer))))))
=2D	 (help-chars (cl-loop for c in (cons help-char help-event-list)
=2D			      when (not (get-register c))
=2D			      collect c)))
+         (pat "")
+         (map (let ((m (make-sparse-keymap)))
+                (set-keymap-parent m minibuffer-local-map)
+                m))
+         (data (register-command-info this-command))
+         types msg result timer act win strs smatch)
+    (if data
+        (setq types  (register-preview-info-types data)
+              msg    (register-preview-info-msg   data)
+              act    (register-preview-info-act   data)
+              smatch (register-preview-info-smatch data))
+      (setq types '(all)
+            msg   "Overwrite register `%s'"
+            act   'set))
+    (setq strs (mapcar (lambda (x)
+                         (string (car x)))
+                       (register-of-type-alist types)))
+    (when (and (memq act '(insert jump view)) (null strs))
+      (error "No register suitable for `%s'" act))
+    (dolist (k (cons help-char help-event-list))
+      (define-key map
+          (vector k) (lambda ()
+                       (interactive)
+                       (unless (get-buffer-window buffer)
+                         (with-selected-window (minibuffer-selected-window)
+                           (register-preview-1 buffer 'show-empty types)))=
)))
+    (define-key map (kbd "<down>") 'register-preview-next)
+    (define-key map (kbd "<up>")   'register-preview-previous)
+    (define-key map (kbd "C-n")    'register-preview-next)
+    (define-key map (kbd "C-p")    'register-preview-previous)
+    (unless (or executing-kbd-macro (null register-use-preview))
+      (register-preview-1 buffer nil types))
     (unwind-protect
=2D	(progn
=2D	  (while (memq (read-key (propertize prompt 'face 'minibuffer-prompt))
=2D		       help-chars)
=2D	    (unless (get-buffer-window buffer)
=2D	      (register-preview buffer 'show-empty)))
=2D          (when (or (eq ?\C-g last-input-event)
=2D                    (eq 'escape last-input-event)
=2D                    (eq ?\C-\[ last-input-event))
=2D            (keyboard-quit))
=2D	  (if (characterp last-input-event) last-input-event
=2D	    (error "Non-character input-event")))
=2D      (and (timerp timer) (cancel-timer timer))
+         (progn
+           (minibuffer-with-setup-hook
+               (lambda ()
+                 (setq timer
+                       (run-with-idle-timer
+                        0.01 'repeat
+                        (lambda ()
+                          (with-selected-window (minibuffer-window)
+                            (let ((input (minibuffer-contents)))
+                              (when (> (length input) 1)
+                                (let ((new (substring input 1))
+                                      (old (substring input 0 1)))
+                                  (setq input (if (or (null smatch)
+                                                      (member new strs))
+                                                  new old))
+                                  (delete-minibuffer-contents)
+                                  (insert input)))
+                              (when (and smatch (not (string=3D input ""))
+                                         (not (member input strs)))
+                                (setq input "")
+                                (delete-minibuffer-contents)
+                                (minibuffer-message "Not matching"))
+                              (when (not (string=3D input pat))
+                                (setq pat input))))
+                          (if (setq win (get-buffer-window buffer))
+                              (with-selected-window win
+                                (let ((ov (make-overlay (point-min) (point=
-min))))
+                                  (goto-char (point-min))
+                                  (remove-overlays)
+                                  (unless (string=3D pat "")
+                                    (if (re-search-forward (concat "^" pat=
) nil t)
+                                        (progn (move-overlay
+                                                ov
+                                                (match-beginning 0) (pos-e=
ol))
+                                               (overlay-put ov 'face 'matc=
h)
+                                               (when msg
+                                                 (with-selected-window (mi=
nibuffer-window)
+                                                   (minibuffer-message msg=
 pat))))
+                                      (with-selected-window (minibuffer-wi=
ndow)
+                                        (minibuffer-message
+                                         "Register `%s' is empty" pat))))))
+                            (unless (string=3D pat "")
+                              (if (member pat strs)
+                                  (with-selected-window (minibuffer-window)
+                                    (minibuffer-message msg pat))
+                                (with-selected-window (minibuffer-window)
+                                  (minibuffer-message
+                                   "Register `%s' is empty" pat)))))))))
+             (setq result (read-from-minibuffer
+                           prompt nil map nil nil (register-preview-get-de=
faults act))))
+           (cl-assert (and result (not (string=3D result "")))
+                      nil "No register specified")
+           (string-to-char result))
+      (when timer (cancel-timer timer))
       (let ((w (get-buffer-window buffer)))
         (and (window-live-p w) (delete-window w)))
       (and (get-buffer buffer) (kill-buffer buffer)))))

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVaY+4THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk7F+DADG4beZfHjB1wX6RyP7cTObatdM55qR
oxuWIg6OAGMIywKhUecN0RxrpPUgO7BAh8jCpvEq8yvvJmdtVC/lQQdHJ3ByB3HP
Fff91T2sMXmhIko9RUclVUWK+p3pHd9IlCsEY0IJBcNJdHggZuwz4ztHTUItlF6i
MflZ3nVi8UCrHZeJ+FPCuW5r/G2MaJKRL00JTdUhvBN9Dz8ErpaC5vSe+U47v22k
3hbpI81wWTQ4pdNcydXMaxYq54SNI4Zog1BeFG0tHQXIPL/w9632jTwVScz++TG3
rpY5d/cKSR+AxaTXyLRijCs90wwIxPn6fzNIjKzhhpMDtA5V/jcdsd6efFCziKX4
qf/e8UkAnW0baQFP4uwNy0TamUyH/mS+3/ZW/R9MXt71uV7KJ0v/ZMPKb8Lwb9MI
C6Bndv4q8vqWN5soCYSyIveVNgss3DmiUW7FaaMT8M8sQRRkKPr7FVxWYkz95iyF
G03Hyi9f8Hrq8u354Gr/0nrkXs8rHnhLa0I=
=ZYRs
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 18 Nov 2023 18:40:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 18 13:40:19 2023
Received: from localhost ([127.0.0.1]:49517 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1r4QEl-0000RI-Ls
	for submit <at> debbugs.gnu.org; Sat, 18 Nov 2023 13:40:19 -0500
Received: from mout01.posteo.de ([185.67.36.65]:56347)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1r4QEj-0000R1-2f
 for 66394 <at> debbugs.gnu.org; Sat, 18 Nov 2023 13:40:10 -0500
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id 37858240029
 for <66394 <at> debbugs.gnu.org>; Sat, 18 Nov 2023 19:40:01 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1700332801; bh=oeEAAOKRpDRWfvazJ9vZgEvu0PPf9hUcj3ENRxsl/nw=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=PaKY86smOtRcmanEWYl2UbaUJ9gfStI3jaQteuKjlvzXqd/AQ4rmUJKlttl0ON7kn
 em46I1eJZvyEXOyhApCNWoh6mFKpXoCKOqkmDJ8enV7+JlZji1yBFvZ42gycb/hgN/
 uOGvaQCONIeZYgDXD07t4nhYbKOK4xZt2MjltMgR5IU9P+dMVt9EtFY4RE1wAEl/lK
 9HsX9ELFQo/UTl7B8eeuzjKIL23QlwRnDx8tOof8NbIq1gzsyyP1JOMs9pp/HjDnxp
 Ig45DM3l1hOnOQBxiJo/3GlHI/Ldr6MR+XHi2nXP1CFOaDOWq35MBsJGZaFB7vSE49
 3s1er2XcE749g==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SXjHh2QFHz6tyK;
 Sat, 18 Nov 2023 19:40:00 +0100 (CET)
From: Thierry Volpiatto <thievol@HIDDEN>
To: Stefan Kangas <stefankangas@HIDDEN>
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
In-Reply-To: <CADwFkmnPNXmW3OwRTH-7ozqS5Qs5oumyOKQ5Du25HmatxnOTaw@HIDDEN>
 (Stefan Kangas's message of "Sun, 15 Oct 2023 05:55:39 -0700")
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
 <E1qrU18-0004CA-DX@HIDDEN> <87bkd0jp01.fsf@HIDDEN>
 <CADwFkmnjnZLWd2xZYSmRc54-8SBjnpGM=3nWsWChadww2jMHQQ@HIDDEN>
 <877cnojj3l.fsf@HIDDEN>
 <CADwFkmnPNXmW3OwRTH-7ozqS5Qs5oumyOKQ5Du25HmatxnOTaw@HIDDEN>
Date: Sat, 18 Nov 2023 18:39:54 +0000
Message-ID: <874jhi7vnp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Hello Stefan,

Stefan Kangas <stefankangas@HIDDEN> writes:

> reopen 66394
> thanks
>
> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>>> If it's fine by you, I'd like to reopen this bug report.
>>
>> Ok, please do.
>
> Done, thanks.

More than one month now, what do you want to do with this?
I had constructive exchanges with Michael and the code has been updated
according to those discussions...

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmVZBPoTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkzyNC/9nG2VPMrXSQ5QKOyLTcCe+2fY18lYR
/puZt7RyFcb9cGgzwkiAiJw079X2jUaLrB3NQAwb8j6DBYvAmzrLniTDsS7DSQT1
3KelYiWqvBcj8gAKwYQAS1M65bzGt7z7B8y9A+PlgBBfhoYdNjMKMFCTs/zw0Yj9
y+XFjfa2mghagez4qPy+yzVmj5ex5P1PP1SXZOkm8sRsGng9LvWmrTeecxvuOZAE
7DWS/Ps7GMSXsLQFW2ohK2wt6HZfrupx97kwq+ITrERQzkyNLSaAyqNor+lL2N21
k9xRzJEHPC8I8sl3OE8MxOY1oKYyMB196npac22L3Z7btWVpKWQjT5noBu33YSDv
yhuWQ/i10021ljU4X6Ib8L1Sa5GGTvfe4jVkBLvqHwxspPo4EBt6YdS+E31Iy14c
irNCqPbtlmzKUl1Wa4MmO3b01yABBRm4jmHkUEDEKVttR6Nc12MhCSh7klP4hV4S
FQB8XFNzLPaInl8DdhYpWPzkHsQVWFY9M04=
=ckCI
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 3 Nov 2023 04:59:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 03 00:59:03 2023
Received: from localhost ([127.0.0.1]:56623 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qymGp-0005wW-Rq
	for submit <at> debbugs.gnu.org; Fri, 03 Nov 2023 00:59:03 -0400
Received: from mout.web.de ([212.227.17.12]:49651)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qymGl-0005wG-9g
 for 66394 <at> debbugs.gnu.org; Fri, 03 Nov 2023 00:58:59 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698987492; x=1699592292; i=michael_heerdegen@HIDDEN;
 bh=iJq5jqzzEYY1aiXhz5GcUKiWyoRJwyM1QwfopwzBl8w=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=NypOmdXqEcneSgeVy8zz/PQUZ3SccBTV960kLv03Vj9VmwVOwTGve52h+DUzOVX7
 XSbTnHOtMpDJgiyk9sLlXGJZCd5Rpmt2ZRd1iR6VbQTdRFHecJ2q8QLlqpHmKInXO
 ltAHRCXpyKkuptyLV4I/SKgv6N6vFV7/WYyVGy4ezfCZIYUTrUTAIf2s0hZaluzg4
 3RNUvXEHGpcTP2LoveU029PuGZfrZ+FU3v0zo2dZjoVQroku9vBqjlBWhmaR0K4kt
 xTqCpHZoZm5KPYK9Vwnu1enUgczC2d4RwTN7WozknXz3s6uiFLhH22EO4B5XZnxG7
 mEL6nENmOPsG1PT5JA==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1Mdf8F-1rYNzZ2Pg1-00ZVJ4; Fri, 03
 Nov 2023 05:58:12 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87h6mcr8ol.fsf@HIDDEN> (Thierry Volpiatto's message of "Fri, 
 27 Oct 2023 04:24:23 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
 <87h6mcr8ol.fsf@HIDDEN>
Date: Fri, 03 Nov 2023 05:58:22 +0100
Message-ID: <87r0l73029.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:jgDPo/CkR8b8SSxXu7lrfpmSt5oDNwn0C0O8XlX+YKb+pLEayqU
 NG7I+kFUWxd0v7gRoUYI6IX2fkZZmH8BHOPrTQju00XmbaSVoVxc0MlMhqeAoIYJMAE+s/p
 eFXxwX7Q2/bTLv7Y4eVCrN621AKqFa4cS2tv7Z9reyALOpWkbfEMfksYHEUWrTN9aXSybBk
 /r+PSI3iipQqRmSWkOPLw==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:u6GQR3Su4PQ=;LNLx1ZRrpPKAjbmAEm46Dg6+y+K
 20GMhrsSNl2/fhB57bS/hOhSkWi7o2VwPpCpSQVg1BRPFmNDrp4XoVjJdZBzK1xboXRpd++DU
 cLSjIFxb4MhjvFStk8e9ngZg85mhpUn2AWkOPwDRS7BWwVrGE6zq8oQwWUQNyUel8OzA+dwK9
 sBoycRjB7BFkg4q67mRN6u3q4nJWpxlAqaCri1jXpoxN41gU1BppDkwZeLfoM+jvixonfTy9l
 R9AtddWE3w9wRApDIZplYepxgRartbACGolRH2PAyEPbYeP003crdl+9JowEZKlRcTs2BZ6Sz
 s3tY0xJjHG9XrUeUbnhoemnD7H1m0LS7W6lulkrP6nB/xrH2LF2NAUeWZK76M92CTw+UZogD4
 TtaIGgOfu4fWtPTci39P8901h3Y84nfqwk3oWhUeFvh07qdBoxUFk8SBRxBLg1GrOL5zbZiJQ
 0+FGBXIY7A6KcewRmxPAOBMw4pw3EHssX3FleGdBT/LqQWtFdxf8B5jdWXVykqkAqNctlMOfd
 28ptsxcuKJCMh+QCDA2/4elqykPXm7/lsXOjfYw9GR+O9gF0XX5IcDDtcntmUZgDD3V9HHAmx
 woiEspVrrE6hfWZ1s2HrX4Fojpik1j/5vk/RFwA4bAHD4f7P6CnSBuCfYFx2POX9H3lcsCQdg
 /ay3vCfH+fmbKnffFlan4HeCrj6z84DxFZuB1AouSqwXCbb5WitPHp7rvXTFzkzO23rJ++lIa
 ZSGm0WHeHpmN7It4aVsirLY89mvWu+k5O9H5txBWB3pM/jdyWM5GlqHIhxVLxKSLZ23ucAWDa
 DrmFcQipE/OfaSawsq6J7bAZfYyjXnlJ1MxhgTpGaPjCVrg7XLGPYaY2j0DvXJD3GxbBJoboq
 3i91NI4tVHAVhb8vmAZROeJZeWPQJfLmIqd36fDWwL8dBZBwJMyNQ1enCFPKKco8E5S+CYp0f
 ZQt1Jw==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> > Maybe in the future we might need to pass other predicates as well.
> > What when a user wants to add another register command?
>
> You can with the current register-preview.el add a new command and
> control filtering of this command.

Cool, thanks.  Looks reasonable.

In my perfect world, the `register-commands-data' would not be specified
as a list but also using methods.  Maybe also
`register-preview-get-defaults'.

I will have a closer look tomorrow, had been a little busy so that I
just now returned to this thread.


Regards,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 27 Oct 2023 04:28:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 27 00:28:45 2023
Received: from localhost ([127.0.0.1]:34878 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qwESi-0006Zc-Qn
	for submit <at> debbugs.gnu.org; Fri, 27 Oct 2023 00:28:45 -0400
Received: from mout02.posteo.de ([185.67.36.66]:56449)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qwESd-0006ZI-HD
 for 66394 <at> debbugs.gnu.org; Fri, 27 Oct 2023 00:28:43 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id D192E240104
 for <66394 <at> debbugs.gnu.org>; Fri, 27 Oct 2023 06:28:01 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1698380881; bh=NSTbRSPZoKjGEZ+VQ5aKOY8p+uzkH0SV+uC/nx7uQYw=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=VoXp3hBS9Ro0BtUcmk/D4nuc0DvdXLAIJTcmRwrErwu3wiigUjBFN3bSQ9WzkHGDe
 8i3zycKPA9dlaQrDwjeM6qGazFRLpinUHTKdDbDEF+WPZFTx9nyogt2QZeeiu/+hkb
 b6DvKckIEze3X82Pweo46zBN4k/j7KF4WXQxUB74ehnpRTVtb1WOEORCvaZKSD++JC
 EtanD/tORJb6ycK4fpP/1doTJeH/Ukv2eG6aT9Sj66OWYR+oMz+p/PVdN8AKAii1qr
 fFxapr3GbgLgtIZpI5JTEnv/xAzO6HXAISJzQOYPBI+h3Z6Wscyyi3Svcwfq2gkUpH
 VRm9Iprhb6hqg==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SGqQm4s5cz6tm4;
 Fri, 27 Oct 2023 06:28:00 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN> <87ttqcg8gw.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Fri, 27 Oct 2023 04:24:23 +0000
In-reply-to: <87ttqcg8gw.fsf@HIDDEN>
Message-ID: <87h6mcr8ol.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> Why do you need another argument as long as you use `this-command`?
>> You can use e.g. (pcase this-command ('foo #'foo-p) etc...)
>
> I doubt all potential uses will use `this-command'.
>
> It's cleaner if the command that knows what it wants passes the
> information via argument than to make the other function derive it
> indirectly from the context (functional style).

It is what I did initially after realizing it is simpler to use
this-command from register-read-with-preview.

> Maybe in the future we might need to pass other predicates as well.
> What when a user wants to add another register command?

You can with the current register-preview.el add a new command and
control filtering of this command.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmU7PEoTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk/5NC/9Acyiv1z4qlmazVYH4gEgNxXlgvhWG
iiBL7qsEGKGwATK/Ii3islIloRzD33FuxWh93oAyEBR/6FKYtN4qAVm2+Mb0OZtv
h7aDsNPnro6ehEClJFxwAbErOqmh8OPNGIESmz5XfXTHRFv7kL5NRuUW/vCGL/z1
5dYWQxeP93CxWmDQ/MzTAAgiYPDVLnJqYdTUbTe4JoySb1OIeRZL9aJCST3U1ApQ
wTjwuB2/VIVZT0eiWvsTZKjcYtY3IlK91XsON3pii3P+Q/E5aDInBBJY+eqlgd82
ylsqGPSv4KXfHKZ2BH6h6RR9HsEHconG3cm3BqM6d1Zy3e6vjTckCprJeY3JHHHk
xLo+t5ZBkxuku/nVrx8RjaeY3BaBImoukZXo7MkjNd4Pf6l9VfksciKBY9dkWW4O
uuk7nIn2eQaYk+sema4a09ZiHdQGo47QpUwn0PtFgggFExLegH1BSat7bmg2cI33
PLOtZIJxZ5fHuYTH1f77Xq+aQ9/8UynKNkk=
=mXK4
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 27 Oct 2023 01:28:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 26 21:28:34 2023
Received: from localhost ([127.0.0.1]:34751 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qwBeM-0007hF-H7
	for submit <at> debbugs.gnu.org; Thu, 26 Oct 2023 21:28:34 -0400
Received: from mout.web.de ([212.227.15.4]:56975)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qwBeH-0007gy-CA
 for 66394 <at> debbugs.gnu.org; Thu, 26 Oct 2023 21:28:33 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698370071; x=1698974871; i=michael_heerdegen@HIDDEN;
 bh=nFEB0mp+iS/dm27fQ9cutynOyrTBKRV/KkxL5YE6Udg=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=BcpDuKFgk8AyhmiM7D1mQuviJfmF7NNolEeXasapAMDjHsaxlXOIzm8WLr4SjDtX
 IAWw8eOVUCr23VKrM/EyILlEePSHeI9iRGXDsfTiTtBWmv7LvdeaBzBqfIbUlopnZ
 N5SsrFGxgL+ceiZKso1Ki9WbIVbkzdibin07hVOuf992/Hjm79YsSt++4S66F1vHp
 WEVXFECa3cJ4vFrBk+6re+MycYGtJAgQilNNKTYQq8EeqaLyUaruAHpjeEZCL0jw/
 avtXIyKIAUtLUB0AIiiAnzBXYqzdEHCFUSEvE/6OXT4vtGw3w0UUjO+I6z/X6iMjw
 MjFNsfSyOV7xKGagHA==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb006
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MFayw-1qhMjZ0ukw-00H5KH; Fri, 27
 Oct 2023 03:27:51 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87zg05rewi.fsf@HIDDEN> (Thierry Volpiatto's message of "Thu, 
 26 Oct 2023 06:17:07 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
 <87zg05rewi.fsf@HIDDEN>
Date: Fri, 27 Oct 2023 03:27:59 +0200
Message-ID: <87ttqcg8gw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:8mICF8YARWgCnOkVboNU+JRfK0guLkuqYyxUxjMP0HBvbKi0VsG
 GxZTD3MVrfaDkszhga57sVp9mY6TM2AZ6nKbuOmFeHc/mW2J8jaMi7vgwv03M9PVRuGNS9g
 UMC6OAomhiv7bGfdkYTT7KP0Rc4rkaR535SzPXnr8X7M9wb/vmfethga6BLf2ZcKyc5/ZRE
 duNAjzH9+7skQVDcrm6EA==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:+HIEQ5m3Ke0=;bNut3RhmbAGy1kc/I1Xa7nEd2RQ
 AlZ6Fh86ev7FEHcgvGjeQvfvt69XEAUYAEGQSqpSobAYD88b+Gm+ZTXz5PtaNpBoVVms7UVnX
 lwAYqkga67tjSQqQw3ToxhjCBN2psUYKLE6IfR57fbGZ3+D+N3tv/SjVoe6Wi0gFh6puDgtJR
 Ea8gGV2k+A2KjSsjLSR2zrbf62X56bKD92+432O5CtyjO8CGTMoKiF6iCfBD9+hW04JmA+5wB
 a42q0sDgRAwB9/Uj0ng7yroLzP/JfRzXD9TQe65UDfC2TEPPsi9+YoJFL1KnhlWP5WNLO4KTT
 wEO4lTVn9Rc5crjcYtNF2C0+niJ5y9GkYwDiHJLXEsAmifq5thEE0QWd8hnU6lhrjl5U+YRNn
 8+fa20t/GmVvTC4TiLT84zxiVk+2NzevlUKGXKZHc63si3txSEpjJiIjWW8yROe8cSFyPxDXr
 9AWRr1muXQHVB6kXm6uG8QPYTwjvg4JW/DP2x3hJe8+5RgVNswag50+tcHD5PDwUS98LOxf2K
 ahO+vO1dMkYAl8X3+snWDaAFKX8X7zLS7L3uJxsJWV4L3ud7ZtjMvCI0hx8ZLUReM51Hp2/bb
 LfECioy+BtRoWub4MRXsCW2p7og+7433pLoJ/oN7BFEK5yzCQe+O1PhtZDF04KqnXGBpcQOK8
 buyjo+z3CYTcyw4DPnrG6YQEbCRYDPLueNG5gYJzf+famKyZXM94SMB5ooiJqg4tHIaw1U3rP
 aHxb7eqnH8mwN7YVwotXH8Ov9hAyCYgR4sp7gw2v1y7uQ8Fmn0Gcvs4c84XwMwXUU59gvR7Hb
 hr9bMBBcSLR/Met26oblvMF/iqqKbaNM0cXafNYSP/GOm0exWcCse3lY0aHPAruv73fXQjmqO
 CYgnjFxAuZC62wQncUwm2NUdP4GZKUPOH2yZtkK6u5LEUWy1d1m+YDqb5SRf3ZXAP7B7foC20
 m8fi9g==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> Why do you need another argument as long as you use `this-command`?
> You can use e.g. (pcase this-command ('foo #'foo-p) etc...)

I doubt all potential uses will use `this-command'.

It's cleaner if the command that knows what it wants passes the
information via argument than to make the other function derive it
indirectly from the context (functional style).

Maybe in the future we might need to pass other predicates as well.
What when a user wants to add another register command?  Or if a future
command needs to prompt more than once?

A predicate passed to the function can also be wrapped for further
filtering etc... that's all more controllable and extensible than hiding
the decision in a defun.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 26 Oct 2023 08:02:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 26 04:02:06 2023
Received: from localhost ([127.0.0.1]:60536 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qvvJe-0002HA-3U
	for submit <at> debbugs.gnu.org; Thu, 26 Oct 2023 04:02:06 -0400
Received: from mout02.posteo.de ([185.67.36.66]:40011)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qvvJa-0002Gb-Jv
 for 66394 <at> debbugs.gnu.org; Thu, 26 Oct 2023 04:02:05 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id DC606240103
 for <66394 <at> debbugs.gnu.org>; Thu, 26 Oct 2023 10:01:25 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1698307285; bh=6PedGOi8gOyenwNCN22xMxz4oaPKwP3xmq4SN6hIYsY=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=LZwEJfNjioZWH4QEa8UUXmE94w86JBJyWbnrS1dbk7+A+g/D99VEyLLwf2zf3+23P
 5isAEV7UnOlI4R6cotHcCOiA2vykFQb9L0t6Wjyw6zAqYVHEyY/cZ3s5Y09fvQVTZT
 DcvsBlkNEkp3I2UPHI81JvMdnUJ2Dv0LAFjQNpnevCin4d0tbHf62RmxtC37pPWmJR
 2QxAzk+Dg/IGr+RUZ2l2FXRbmNJL26xWJNO5qBVIiwqzHWTjAkCK6vMBifgci1aywM
 lESbE96istnJ/7BXwwlwV7YvDLX7HIA7sLo33CZ6IH8do4YMSCQDj1d4SSpmsRBp+1
 RzrHHJtOTG0SQ==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SGJCS5Vmbz9rxF;
 Thu, 26 Oct 2023 10:01:24 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN> <8734xyc8z0.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Thu, 26 Oct 2023 06:17:07 +0000
In-reply-to: <8734xyc8z0.fsf@HIDDEN>
Message-ID: <87zg05rewi.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> Not sure to understand what you want to do here.
>
> Maybe it's easier if I post a patch.  Will try to do this tomorrow.

Yes, not sure to understand what you want to do.

> What I want to do is that `register-read-with-preview' accepts another
> argument, a predicate, that is used to filter the registers to be
> included in the preview.

Why do you need another argument as long as you use `this-command`?
You can use e.g. (pcase this-command ('foo #'foo-p) etc...)
Isn't it?

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmU6HM0THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkzZ2C/9roIB4m2aZurX/QtzqTeju5BjRiVK5
Wh26FwBp71hExEP6p1CdjSL5M6SsLawVMWXgLjhPn3v7dmP0DsMJZaeyc+7jW4YJ
Fpa6HnObSxhrT7XyqDSo9U4KS1YMWZLOiqzlrp2dkxdo9y5qQvTapycbZ13I+UUe
PDBnNZrW5mfJNDLBpBmjaZI1i6kl6r4+zp1v3qe0V0aVcy6qJGraECSafLiziTBU
6iqvxfQmPcqAgnUNSyuXZ6T/cMQknm2Ce3EQAy/bK/eMJiGBiM6wLCwSawJ/BZKh
tNtsxW5d1BwZn140bAHTZLvThuoKRVE/upACy8AAYnF+pp1hxkO9f9KsFSJjWbdB
pJvz/MMz3kuuHhyNkALZppGHxvZW6jgYfYHb4Pm1g2oNCzlVuoQLlZHH2mxiWviw
Se4TORSHK2UNBBAi8bxSty+oDXFf5vpNQA6JhL5jecFPW0CkfNxFsqOesJRQwMhY
L/wU1xrAMU5qCNVklNhMsXD3gJOcBtqI5j0=
=DSc3
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 26 Oct 2023 04:19:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 26 00:19:00 2023
Received: from localhost ([127.0.0.1]:60392 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qvrpj-0001RJ-Na
	for submit <at> debbugs.gnu.org; Thu, 26 Oct 2023 00:19:00 -0400
Received: from mout.web.de ([212.227.17.11]:46189)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qvrpg-0001Qx-6S
 for 66394 <at> debbugs.gnu.org; Thu, 26 Oct 2023 00:18:58 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698293898; x=1698898698; i=michael_heerdegen@HIDDEN;
 bh=hEEDMCwxFO7wBl9qsuELFbThO5FlwODVeh99r8RLu8o=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=SBDBFeCbSVe39rZsQoZNQYu1hlpZ6chmvZbcSxiXgqY2015XrH/jyFGkUSr1ns03
 3pTCioP1G9rhPcexKbk7bDvKHESmXGr1j7RZWTQsl9I6JsOE/iqcefQ7/J5XGbSeo
 qg+FmzLgRNB4Z31/kO3+UMVp2+Philr0NCsmJ6syg2Fboh1qHv4k7Ioo6XrnxlSs/
 vuzLuZWxtrvYoi4XRHoHSiWk9RSzJ/C4ssSBh4l5SX76hWLG1ugwblvUbV57ZpS16
 /GbIQuCbV+vHjuA2/rUgPDEVORVpEWiJsjNtcLx0BvB7KjPjPUa7cwoB0KNKpOqbN
 HG391T+smFhB3mUuww==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1Mf3uS-1rOt7I2as6-00gPVA; Thu, 26
 Oct 2023 06:18:18 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <877cnb2n63.fsf@HIDDEN> (Thierry Volpiatto's message of "Wed, 
 25 Oct 2023 06:38:16 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
 <877cnb2n63.fsf@HIDDEN>
Date: Thu, 26 Oct 2023 06:18:27 +0200
Message-ID: <8734xyc8z0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:14c6EbuXCZDwnE68sRuTZ0j0E1cvPFyuPgHkkrQB3tzcQm8U8Ix
 Et8cz1y3GI91YKEOAaoRxo0UR/iIrgAaiFTJmX0GVqjBOqyiSJlQAS/TMPMB+3mk6P973Tc
 9j+B8vMFaqlrjBudqog6brumToHAr8NUoglZ4zN9mn55WXI/Yog1l1BUatizfc9Rwb5QUgr
 r8ioo76OTpKPW4dGa2QhQ==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:365vsViaJXc=;56PNruD9LYsHTQjpOLhPaJj5Elc
 6s3fCm2x9VWs5R+1l+W68pf5c/N0YVrO0MjROXowXdnAz/fT8cbScWwdHm1bzLbvGKM/kO6ta
 EUAQl/ZbRq/5kJ0bwzzFCqL2MpEYQxNbmf762ORZCL3FCNi5RcYUsrh3a1Gm3GqvhsFoIbZcD
 YtG6uZJHFM5A6gM4zKfzGZR8X81QWNQk8hACkGjfMewSRyUuhCEzUpmtBc9nlmDnl5NqxO7Ei
 FpbEigk3r9ouxUQF0ntJP+DJqcpHVxr4/a86vv1uVQyHnd80RsNziDS/9CChHi9q62jAvuj0P
 jM2fc0mXNERUfkdYsvs8JlpkNMIda/icZ5crBCLwh5IYImzstT9KRmnuUrUZ3fNjVO6a75gYO
 4vmkV74f/5/GDOKVoV5tZoG0rYe5eBxvUuY0R/AbGxXbSzi2KVlgXOuM7RNWOEqUQ3Cg5PGEA
 +xN+20mWd+tD/yHbOCuF9ibTQPxzplBtweEXlvNp/8JouA4BHCHtVJ1/BtV6ygyN0PeL97iT1
 LD7Q24uZ+3susLOJkoXfcPPJzBphA6MNc6pMgsiG/+9UhsQQn+df6DNJOpr2jbY7KxUOHSLBt
 EbztwN5hayAwjjFxKmefq67dUfgaTd+KbnTnBPLjtN6bT+UM/jvTvMJ6bh6Vh3iQJmKFhDlsA
 v9Ae/hd99HGPnazUVFr73ldL209plL2bLx3myFRtxvT9T942XNRkMRfju3EPjMCJPJErqu286
 c5fN6nwmc7jBw51gyCl30jzreRBuL7EL9fSb7Zwo2/EMJYL6uue9Kn12vcqWv80TPKFU/cwE1
 uEqiTiC5GBciZBj5sDMqxvY3PFWcwqwI1jm88Lrb8odsz/ptVbcu3/hBxpDzZXD8ygsakiGdl
 iGBons3R3fpfKNAg4E6tcUlqKtCE0MeU36SnMrgPUQwhJFKI+0Nc7rWpCzE3+Rt2j3kypQ9xd
 EIRLujZJulrxtMXcTsZdyhkLbZc=
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> Not sure to understand what you want to do here.

Maybe it's easier if I post a patch.  Will try to do this tomorrow.

What I want to do is that `register-read-with-preview' accepts another
argument, a predicate, that is used to filter the registers to be
included in the preview.

And the hierarchy defining which registers support which operations I
want to define implicitly using method specializers, not explicitly
using types.

Because I think using generics is more flexible.  When the type system
you propose defines, for example, that string registers can be inserted,
and appendend and prepended to (we have commands for that), and
then, say, somebody wants to define a wrapper register type "read-only
register" that can hold anything a register can hold but with the
difference that the read-only register can't be modified, you want to
fall back to the filtering of the base type (which can be anything, so
this has to be done dynamically) - but disallow append and prepend for
string registers, for example.

Just an example, but such wrappers can be useful for registers.  You can
define registers with annotations for example: the annotations are
displayed in the preview but don't affect the behavior of the base
register.

Such things are hard to code using a type system.  Of course there are
more changes to be made to allow everything I outlined, but I want that
we don't do anything that limits what could be added to register.el in
the future.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Oct 2023 07:10:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 25 03:10:32 2023
Received: from localhost ([127.0.0.1]:57184 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qvY2B-0000uW-Lm
	for submit <at> debbugs.gnu.org; Wed, 25 Oct 2023 03:10:32 -0400
Received: from mout02.posteo.de ([185.67.36.66]:58417)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qvY25-0000uD-Cu
 for 66394 <at> debbugs.gnu.org; Wed, 25 Oct 2023 03:10:30 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 3B533240103
 for <66394 <at> debbugs.gnu.org>; Wed, 25 Oct 2023 09:09:48 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1698217789; bh=22P/6tOF++DOUEG0DRVNEAPwffBiCT17r1JiiDBcEY8=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=Mw7Jm8y38DX0jW3HOUnFLJCioYSwB6y70DPsaoZM8dLfDJyZnWLES4NnhJnsdjUMA
 w7C1RE9MOEEYxmKrCEg5+S8Fu1bwigLEEYfr3fDm5/ppP3lcB85wsxLlF5fbt5XoOm
 lb9zHqVFFULCFyyrN3Dv9WcRpiMXrvhpAO37KC+BKCJsZLMGe0fjxbft67X9f4Zqq/
 35Uw4sh0u4ArBF94Cxgq3ioPvjEkQy+WWGX7Q+e1BYtQAXiw9lGFi1S2kGHK84fXya
 QAV0GAgDU4LpYIIuOPVbW83kR2MaduxtvrsiumLG+tv7c36N4qU1c6Uqz2vTFKUVVR
 UBUAILOUV/ilA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SFg6N0sWrz9rxN;
 Wed, 25 Oct 2023 09:09:47 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN> <87wmvbibpr.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Wed, 25 Oct 2023 06:38:16 +0000
In-reply-to: <87wmvbibpr.fsf@HIDDEN>
Message-ID: <877cnb2n63.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> A possible solution for this is adding two vars, insert-register-types
>> and jump-to-register-types and define register-type like this (named
>> register--type here):
>>
>> (defun register--type (register)
>>   ;; Call register/type against the register value.
>>   (register/type (if (consp (cdr register))
>>                      (cadr register)
>>                    (cdr register))))
>>
>> (cl-defgeneric register/type (regval))
>>
>> (cl-defmethod register/type ((regval string)) 'string)
>> (cl-defmethod register/type ((regval number)) 'number)
>> (cl-defmethod register/type ((regval marker)) 'marker)
>> (cl-defmethod register/type ((regval window-configuration)) 'window)
>> (cl-deftype frame-register () '(satisfies frameset-register-p))
>> (cl-defmethod register/type :extra "frame-register" (regval) 'frame)
>>
>> ;; set a new register and check its type like this:
>> (register--type (car register-alist))
>
> This looks promising.
>
> But I'm not sure whether the detour via type names (instead of an
> approach using only generics) is the best solution.  Why not define just
> a new generic (register-eligible-for-command-p REG COMMAND) and use that
> as predicate in the interactive specs of the commands (providing
> `this-command' as second arg)?  Seems simpler to me and still more
> extensible and controllable.

Not sure to understand what you want to do here.

We don't want to modify each command, and anyway I don't see what
(register-eligible-for-command-p REG COMMAND) would do in the
interactive spec of each command.

There is two things we want to make more flexible:

1) The ability to allow adding a new type of register and
use this type of register to filter out the register-alist according to
the command in use.

2) Allow one to add a new register command
and assign its type, message to use and action it
provide.

Example, if I want to define a new command register-delete:

    (defun register-delete (register)
      (interactive (list (register-read-with-preview "Delete register: ")))
      (setq register-alist (delete register register-alist)))

If I run this command I will have a minibuffer message "Overwrite
register <n>", this is not what I expect, I expect "Delete register
<n>".

So we need something to customize this.
I added a new var and a structure to achieve this, so now one can do in
e.g. its .emacs:

    (with-eval-after-load 'register
      (require 'register-preview)
      (add-to-list 'register-commands-data
                   `(register-delete
                     .
                     ,(make-register-preview-commands
                       :types '(all)
                       :msg "Delete register `%s'"
                       :act 'delete)))
      (defun register-delete (register)
        (interactive (list (register-read-with-preview "Delete register: ")=
))
        (setq register-alist (delete register register-alist))))


But maybe what you propose is simpler to achieve the two tasks above,
don't know.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmU4vzUTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk0tYDAC6CwhEYMwOXn4e2oQAoEqUB72xC4MH
Em5OShCq1WvwbOLh4tg+zfTO5exdmgbWabhVfNXp3DyBKfTOBWqrRwxyeQPu+YRd
NAyqbOp01E88i+NyRH4HTUW4dyY4npg27SRJBy6cQ4poLKYLkCAb4sCrFf3gza9X
sZP5XTHJK8LOT92jPL37y+rFs8gtBapF1HmPCOwzD5tLIqQ/DgRNcgttnx6r4zCA
p3EC8NsK6GPabLeYl5BlQ5Js+NGqUpEg8p90QwOSFcKoUBFo129cLXpoWLNHC/KC
uZSxCAUb2XDu67F0vOKqK2tr9sZZvALV+UCRY3epcKG5PGHgvyeeTHieuxvoUfEN
GLXUeiqS9hZfcikZCnGCcutDGGYV/yrAIKc8xguiMNMWoXo9iFQHwQ1059sRknuy
gCsgbG132OauoKvPgcYP4guLpE+7Moyt8n5WYLzXXqtXTY+BhJ90XdjFCasxG0aW
vYLcEdSUokHmZ0G1mMsdwhfx1HtebuQw7Ks=
=NLgf
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Oct 2023 04:10:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 25 00:10:57 2023
Received: from localhost ([127.0.0.1]:57067 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qvVEP-0001wG-8C
	for submit <at> debbugs.gnu.org; Wed, 25 Oct 2023 00:10:57 -0400
Received: from mout.web.de ([212.227.17.12]:51179)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qvVEL-0001vz-Gw
 for 66394 <at> debbugs.gnu.org; Wed, 25 Oct 2023 00:10:55 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698207016; x=1698811816; i=michael_heerdegen@HIDDEN;
 bh=YutlNiwCQYixMt0WAge2YTvr2QEyNEQQADuayC0EWuE=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=JI3q7zZCE0B5tcyLEW6d9i3HqG13bg47ft//v5RyECJ7L0258xxjElYLjE/M2p5+
 szqeb1JCl020Nfc5uTEuMjaZ1Ky2RFYjo8ohGe0Zfwb3ebHBPwKNI+NnmhweHDjcZ
 Vt4mZ4O7JW/KrUz2A7RzNIPocNmsipG4SRLXe5q7AHBtmEZNz656J9Qc1qE1X4dXe
 jImidddZxn9Uda5qg9DraWAkYvKo+DazDY6VLPZDftHfxj35Ny1jNeTW3PGL1VTcj
 YUgo0uTDEn7etYhzISY01AfY3xwKURhVlXgdySXrNbwEtPYNdaMBH9lJaDM2RBFJ7
 wnAWTTiy26t34z9sJA==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1M43Kc-1qvVDk15Oa-00007u; Wed, 25
 Oct 2023 06:10:16 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87ttqgpjiz.fsf@HIDDEN> (Thierry Volpiatto's message of "Tue, 
 24 Oct 2023 07:19:11 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87ttqgpjiz.fsf@HIDDEN>
Date: Wed, 25 Oct 2023 06:10:24 +0200
Message-ID: <87wmvbibpr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:8hHVIwSZte9RAPgUzoaW/JxS8jG3NGx7D5I3jHdhsBn4k2A+zY7
 g/Lk1kPdQgEsHqQ7WqCQwzt0hBejlHlY+ARI70k2Uo+1kOo+fKoFKmv6LUbrjdVku3tPQeA
 5vDtRU44Qk3yCC7MPx1hID6DMfeSo+/wdO0cSarVi/8KMbdJCKHgGp9V4/r736HADflrBf8
 h56R4S1REYgog2/3RWOvg==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:N7XjkybEbv8=;fj4wP9zck2KfgUCtjTOVlcrXiTV
 LwgEqlWmJRz+XGbezDV7W6zY/IhCWV/RpPk5bjJZBcmT87+RCnV4qoPWmxI0fbjsHXLcjCJmQ
 IuMrK00KO9tZg4f/1H6BRuk412EYVEQH19NKpHFNlYS2HjyEqLWZmHvzXclL3ej4HTjuxqLTK
 v07o1Vb6NhH7LoX6t4rhIZhnoT3PmLiCfe7Qhszp4ro1hoy/Cgo9RbuS6l9NARPhk5tsxgt3v
 5cE04gWysr+c45l+msO8Q9v2p3kWOIyFiFu9SDGg0aawrabKeRRoJ/haJHvqKBVPtdqn0BYMM
 Ho+n2ifjtKBN+qo0g3CPyHODhu0ocHMww/FZXU9q9bhEzNn6vM1+Kd4BTaYB86jt0pUG5l7TM
 /yQRPUdeuoeHaDj8q+YcvxTMhiia/7xmHFRsvuDOMdayOgRNTVOY7WObTX6X84j1wldM3ar7C
 ARy/WTo5tmSjUa4iLUugFvWL68rFJGlAjMsdwNjn1xkp7mthopSWiYeHjYguzLmuOLP6s/fi9
 IuHMjb/RVJMimmPWzgzOaKfBJa4Mf8te0rO5rEhkv5aUuHaRaJngkX15VHFssAszqFegknd+8
 eFxx97i2IMIiv33OKmXuMNbLaoJ1F5lYIKHLoqcvLMP9GJc5tI/H9yAo8WX2Mb8PiZacVBUd9
 JmbK0hdrtiKGj0mv5gaoZNrTUKYe8F4LfmUK6iNSSUeV01lqQyMM/i6xUsg/jauB50i01uMg0
 NCMGCKRoaH8AbJKX/wv0KWkyxqH72V64AI5r9lIFzdct96A81GfCqkj8l1jCqCImTe9ybfDGP
 jIU51X/+QtQtljS+p/hR69/HeYBInIzMSVMBxPp/8UchUPsXUqkvj1tnbXZa05wJJhUu56Oix
 /SiCPse8yy80sCY1xBtPsS16Jub5c3++AVNvS6amBlaln3jyz7i7PrqIf9Q3DcJ3HZ08DDpqU
 xgFFZA==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> A possible solution for this is adding two vars, insert-register-types
> and jump-to-register-types and define register-type like this (named
> register--type here):
>
> (defun register--type (register)
>   ;; Call register/type against the register value.
>   (register/type (if (consp (cdr register))
>                      (cadr register)
>                    (cdr register))))
>
> (cl-defgeneric register/type (regval))
>
> (cl-defmethod register/type ((regval string)) 'string)
> (cl-defmethod register/type ((regval number)) 'number)
> (cl-defmethod register/type ((regval marker)) 'marker)
> (cl-defmethod register/type ((regval window-configuration)) 'window)
> (cl-deftype frame-register () '(satisfies frameset-register-p))
> (cl-defmethod register/type :extra "frame-register" (regval) 'frame)
>
> ;; set a new register and check its type like this:
> (register--type (car register-alist))

This looks promising.

But I'm not sure whether the detour via type names (instead of an
approach using only generics) is the best solution.  Why not define just
a new generic (register-eligible-for-command-p REG COMMAND) and use that
as predicate in the interactive specs of the commands (providing
`this-command' as second arg)?  Seems simpler to me and still more
extensible and controllable.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 25 Oct 2023 03:55:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 24 23:55:14 2023
Received: from localhost ([127.0.0.1]:57062 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qvUzC-0001Xj-K8
	for submit <at> debbugs.gnu.org; Tue, 24 Oct 2023 23:55:14 -0400
Received: from mout.web.de ([212.227.17.11]:32969)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qvUz7-0001XQ-Nb
 for 66394 <at> debbugs.gnu.org; Tue, 24 Oct 2023 23:55:12 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698206073; x=1698810873; i=michael_heerdegen@HIDDEN;
 bh=q0trBo8WUeGt2OypkB9pWh/YKOfF92Pr9DfAANCkRnc=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=imZ2fJaLrxXRkeR1CGOBgMkwoZM1n5nBp7fmB1PPSLVHNU4/ucV2nHw2+l/7oVqY
 BuGKExCBCplf9SUCXPaxotO2haggzuo+ZpCe0Kqvq3r5dUWiHtE+mjDIyRpwACglP
 ZVckJx/SUzEt23yPWJijV43pdRhMDBhXrHCJUIxeUKIjejOVx9LqkjMZ5z7OTWqO5
 0nvBBd8Ab04SW4ihPuAodCbSYxW8cDcsddifD2fR4qfyZ0A8iWZpKZRhOB5vaDxcp
 JoScZO4OJXvfQR5/aen9tmV1DdS9MVCSefYqu94Ev32XCX17DCublLOrOUiksOhgf
 YJslja58JgVtX8JOBg==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MdO9K-1rUYkC3kzQ-00ZKrb; Wed, 25
 Oct 2023 05:54:32 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <878r7spoj2.fsf@HIDDEN> (Thierry Volpiatto's message of "Tue, 
 24 Oct 2023 05:30:20 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87msw99a95.fsf@HIDDEN> <87bkcovg7e.fsf@HIDDEN>
 <878r7spoj2.fsf@HIDDEN>
Date: Wed, 25 Oct 2023 05:54:40 +0200
Message-ID: <871qdjjr0f.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:uiFknLOqZlaoBQ9eniHUrv/8yk3KYBLPcMIIzWOL4zTz403eR8S
 4YDHvb+ndzuAmYmt1mgHq7k9LWepk5CHkhBd1uCFQMoy3aWrqZlIsZyVOGOXjRGz1vPUCGl
 eSbdG5t3AOux+xHg6/jO9qFuxRh3agXmdOGMKXlEl9zvLStmhsNgd2qj4rVQWSALjredaH6
 /JJeEBGj59Jc4D0zuULGw==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:tnbNIgbRiGY=;C1y3MIj1tkl2MjgO+tTvCqzDWK7
 VKHqiTuBx2eawqD5pHztbb9bap/iMziu3vbuy3SnUtOAHFiE7WGOtB78r1+H6rVBn6xdQWPi0
 egLcuITwxPIQvMUQrjLGiWQRl2HqJWjs2MSDIzPCnYH75XF0kuLeEmDMORwfs+A6SPClmDWUN
 FNWesHalJgAvrts2+Uu8/rX3YHErp5numXS6wQPXlJGxkP7tiK/EcQJQAeyrUFf0OvhirFrAF
 vUyGqWAJCutJhyi5pCBIv7BaV1Es7eekX2vVB0RBI3MH2j+1LGrdyykxh7mxtcpouaopnLEyQ
 VaZn4zR/5qwRqnq1uovSM1VQdw30YBLjiwAKqgG2WrEq5iB8ZNYu8d1doqDk8jVoK5FldZOd0
 b0SJpFmpfipDOrNL3YlHGiWOx3mV7AH7TrnCyDr9hUtwHynpXm48z2anzQ706mnUaip/Dgo6X
 X90sOUr3GVHPekEvt/GyMSidko62+3/L1ccjGi9F4lXQscsehZqOEnferj1d2o3oIM8oa+ppP
 7CVX9vws+Y7LdjvdqWlONHN3grj4qfNsz1iE43/ALZ275j8u/SJ3fcNeokI4GDQWQSbl6wht5
 DyUtP6wvf1UjBGIMcu0HFo7GDY9tHB7g4cV+ja9w8tbXe+bI5btzpBTjDZDffr62RBz8Mr40o
 bCczGSnRlAB1l51I8GuTpbVFVhKZ7F6RkK2mm54lg6d+qtYDhrW36dso8rQuuRCA3ZYTh0PnF
 ojiaYa8sYpeIHKr9dZYBpbfVBpcCoobc3vF6X210QKoys05tiGJwRzzDgjt9B2wd0p6Cs2rIr
 6J4SpnArV5ueFb0dJshx0zkLNovrxz4/Ng5KUPdVsww1ID4G/FSQ7E1V7kihkJnvXvbRmUEA+
 vy5KsB+vhftGu5szkYk/VBz4eqJxYWtTmhTRxjLV6ClQgQG7ActchGJPVWs32p5fa1azDQNR5
 5z/P4021hqL6x/JpVibIp5lxubs=
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> > * Multiple times I saw "contains no text" where a better hint would have
> >   been to say "empty".  Not all registers contain text.  Happens
> >   e.g. for C-x r SPC R where R is any unused register.
>
> Yes I used the message vanilla Emacs already use somewhere, but yes
> empty seems better.

Thanks.  In register.el I see a message like that only for text related
register commands.


Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 24 Oct 2023 07:28:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 24 03:28:19 2023
Received: from localhost ([127.0.0.1]:52937 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qvBpr-0001o9-8f
	for submit <at> debbugs.gnu.org; Tue, 24 Oct 2023 03:28:19 -0400
Received: from mout02.posteo.de ([185.67.36.66]:43291)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qvBpn-0001nn-8Z
 for 66394 <at> debbugs.gnu.org; Tue, 24 Oct 2023 03:28:18 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id C6137240101
 for <66394 <at> debbugs.gnu.org>; Tue, 24 Oct 2023 09:27:39 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1698132459; bh=ccTYxRDO8AefTEGbPty59icoIj/ARACxX3ZOrnlULn0=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=ozIjq6XEh31+6RyMwVShed344Ruph0jQv8b1L5+ukCdd0CY8WkMhH8Ml50d2Dcphf
 zF9XPPlfQWmqhkQK7tOJea3ppbXj7xfPITEbyaGBYaGe3A2dZp1GD+Wn0mbhduvKvx
 VZfMubwVugDlSGTGHrzbgQeK4+Z5u6m13qD3ildj1aQu49EGA+se3MHUCHcLN+Bkcq
 EpMv3KKGrNvcJaIYM3Plziufcfvjs/yLH3kXSi7rC+pFXXk/enBSfAALsslhhgLgtT
 U7drhJetO/zJOq8Pt7vX3fKw4oViM3glO336rDuNeRz/OMRC+Y2scLh03r8FFE0GGq
 ooHOCdW2nuVPw==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SF3YQ6klrz9rxG;
 Tue, 24 Oct 2023 09:27:38 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Tue, 24 Oct 2023 07:19:11 +0000
In-reply-to: <87y1fut1wp.fsf@HIDDEN>
Message-ID: <87ttqgpjiz.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> It would not be good to carve the current register type system
> into stone.  Instead of your `register-type' function I would prefer
> something extensible, for the case of new register types being added
> (even a normal user might want to do this).  So, when one wants to add a
> new register type, it is necessary that one is able to declare, in some
> way, whether registers of this type should be included or not for
> `insert-register' (and maybe also `jump-to-register').

A possible solution for this is adding two vars, insert-register-types
and jump-to-register-types and define register-type like this (named
register--type here):

(defun register--type (register)
  ;; Call register/type against the register value.
  (register/type (if (consp (cdr register))
                     (cadr register)
                   (cdr register))))

(cl-defgeneric register/type (regval))

(cl-defmethod register/type ((regval string)) 'string)
(cl-defmethod register/type ((regval number)) 'number)
(cl-defmethod register/type ((regval marker)) 'marker)
(cl-defmethod register/type ((regval window-configuration)) 'window)
(cl-deftype frame-register () '(satisfies frameset-register-p))
(cl-defmethod register/type :extra "frame-register" (regval) 'frame)

;; set a new register and check its type like this:
(register--type (car register-alist))

So if one wants a new register type he has just to add the type to one
of insert-register-types or jump-to-register-types and add a new
defmethod for this type. If the new type in not one of cl-typep he may
have to define a new type like above.


=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmU3ceQTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk7E8DACojdkNHaOcU+9LsTtd3xoZr+HfKrFW
DoLiUqMCJnL2qwQykHJkfxXxIBzIg+AyRA+7DIU2VxJFhpGUj+OTj2cHjaIXCtRF
DXpTsNaQmrZ3bzBoz/sJKOJh8N/fEPUWthLQh88cnFheApjofKdrdMz3ML1yiz2R
Nz4sKA4OF2xvdMGUfuTlYd5QIqTZsb0mwEc2ek0LSV6buGqejwvYJ/iZChlZo8Hj
liBVCO1vng3HR52PNYh/AZWNmAttRnLPiPEWWmpgQOUKKWKkwskIZT7q/9vlU1V9
+iPQk/1INvgAecUy4UHxGefJKvi7L+mpnHo+/3NU3/OLO9fMGr6yUrxKqbae18kP
j+qiexjMgPxEzA65R9M2/AdyxjTif1Rux5lUMaf9iR5ReVNmdIjPjlCRpI0ZEG1/
lpJdZfvHvmZQLxxdw88kMMeFCO0V8b35qZbfKusfQSUl8FEBFH9UYYYMtJY5WBZy
t8f8U+qAWjHhfauaOOlFVqfST7tAQvGx5Qk=
=VCS0
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 24 Oct 2023 05:40:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 24 01:40:17 2023
Received: from localhost ([127.0.0.1]:52734 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qvA9I-000795-Rd
	for submit <at> debbugs.gnu.org; Tue, 24 Oct 2023 01:40:17 -0400
Received: from mout02.posteo.de ([185.67.36.66]:57311)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qvA9G-00078n-1s
 for 66394 <at> debbugs.gnu.org; Tue, 24 Oct 2023 01:40:16 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 59C8B240103
 for <66394 <at> debbugs.gnu.org>; Tue, 24 Oct 2023 07:39:38 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1698125978; bh=nTV5u+LqAy4LgF4SY2kepRNUUzFgMIpOiAfiq19fwWQ=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=YOWKvBSEqCrN+BjPU1anMtIenI5eEgxqdqYYFkJUK2YW4XqpY1M6gNfDAa35S0BKd
 fnNy4VOD1DWKOzpS5aqoQnYwcTUNPWhwNpC88x7T9g5dODscip1mo85x2HP87ZDgny
 gNVjc1EcA72HpBy00y9lTAHwCEeZND4Y2KQUQiXdHJ2MsjZK2JK+fSHaR+Y8PDLI4U
 YHcde6WB4dYwubnAmaJawoQa19xyI9pgMtmySFk33b7sJve5D1k+m3r/ffSA36GrAD
 AdXbWNO9zKqaz6jMrLi+TqjCcWnh9930Z1qXgdFazGoik7vhnFK2BDLo7jjdck5tmX
 ROK7hbSD7PILw==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SF18n0WvPz6tx0;
 Tue, 24 Oct 2023 07:39:36 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87msw99a95.fsf@HIDDEN> <87bkcovg7e.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Tue, 24 Oct 2023 05:30:20 +0000
In-reply-to: <87bkcovg7e.fsf@HIDDEN>
Message-ID: <878r7spoj2.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> Yes but I think this should go into another commit on top of my patch
>> to avoid having a "too big patch".
>
> Yes, maybe.
>
> Ok, some more remarks (I have looked at that url now...):
>
> * Would it make sense to also allow M-n (known as "future history" for
>   `completing-read') to gather the next free register (seems also
>   natural - just a thought)

It is already done ;-)

> * Multiple times I saw "contains no text" where a better hint would have
>   been to say "empty".  Not all registers contain text.  Happens
>   e.g. for C-x r SPC R where R is any unused register.

Yes I used the message vanilla Emacs already use somewhere, but yes
empty seems better.

> * register-preview-default-keys may be initialized using
>   (mapcar #'string (number-sequence ?a ?z)) if you like.

Yes could be done.=20

PS: I found a bug in my code with frame configs not appearing in preview,
now fixed, will update the gist right now with your suggestions as well.

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmU3WJETHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk4AQC/9N0LZLvCJzGeG05FqUCk8T6OpJGKR6
PPQxQylivR2oitfTrCT7hlUfPhWtwQeoEpWTfybQ4M/JYq87N7s9FjKI7EQpj90v
71d2ai0eYC48QVgV2hwanmgHAbTDDwEB+pRmh8wSoftXOZJ/2I18aX65D8caTzCH
njllJayiUD9M+l4KSxE8CwBA/idBAqHWzie0dFJPx/+EoqQz7CzXGuWILaaiKvmI
3tF7tWEKWMeH/64TP8ftw6sdoQ6oWeHl6lYQpbzWL6wDLQj4P43AQqcArt6JklcL
XO+tQbsM2OQe35BKTVTybtdNo9oe1kpGkopZDpBLgbJE9lSW9OQbEOMA4kXbZuFP
edgj5PxYGbAllNAW++WzhQSt3f6mbN6MaLgnlQ5dUBple3FHZBYMVDTIpQthqjjr
FpNF7G8kJxEGJWsnCxrrK+J/vGKtWxScEDrIcSWJli/q6kMjWiwpnq1uyM6bFqYb
1G2JjMaMUfzV9DcrSgHFhjRbqFQ6xFasLUU=
=OtUk
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 24 Oct 2023 03:54:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 23 23:54:44 2023
Received: from localhost ([127.0.0.1]:52692 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qv8V9-00046E-Os
	for submit <at> debbugs.gnu.org; Mon, 23 Oct 2023 23:54:44 -0400
Received: from mout.web.de ([217.72.192.78]:60849)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qv8V4-00045s-1i
 for 66394 <at> debbugs.gnu.org; Mon, 23 Oct 2023 23:54:41 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698119640; x=1698724440; i=michael_heerdegen@HIDDEN;
 bh=KpK+TesMjoGedSwPwSsyt4n98AOTghroduLVC3Gu184=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=p4B3y3zwfGYJQPhnQXK7IAdEYgik/pNjdUAPNKRM+99f2lQCj9CXsUfXkgbRGQ6a
 brObaRf8QAng7TZG11/pYGSfIotSMWNwXuyvAIVZa6/3vjaz6eXm0WAp+BcWbarPB
 1xnxI500YmccKVyBJFj4XvLUKxnfpsH0/tXwql1pPKg8sRxnOfPEamEngEMc/JQHi
 ydk7v3OIF1v4+6fYWSlFX7UAJQ4BpO15xyHGRAUVKf69C2mNnla985AWLcAiP0Q8S
 yFDM78jG5F0hYhKMhFHDYwr/AxXKfvplPZ7zdrJVKP9PbytNm87XdPC7oQE8Ef7Xf
 WQuxlsVAIUOoHJA0Ew==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb105
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MmQcl-1rLMRF2jWz-00iMuQ; Tue, 24
 Oct 2023 05:54:00 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87bkcovg7e.fsf@HIDDEN> (Michael Heerdegen's message of "Tue, 24
 Oct 2023 05:42:45 +0200")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87msw99a95.fsf@HIDDEN> <87bkcovg7e.fsf@HIDDEN>
Date: Tue, 24 Oct 2023 05:54:08 +0200
Message-ID: <87cyx4pten.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:X/aW4C+xCvPIrp8WPHldZqzgmLI7dl82456FPpAvHQpwCaT0QKi
 Obxr1amb+8pfWilQuLdPuSIa4dW1J4cRd0phw5d5DTr+j+FHnBIa7BMb6eg+B/gkrXPOtE+
 53oXRPFttVUUrzHjXca9X7qQiiLDnRwZ1GD2EedPe3jb8OphZVu0FBH7beYmKfO18WEuHgN
 aA3t3cahH9sbXEVSVWOow==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:U5vrHqxE0Qs=;ibKzwLxvh2aa4/De7L/NEEw2G2H
 eejR1Xt4TpcbphHdcQllOKftwgDxWOTVhUIWXmKisAbgDx5McgIolunWKl1rToARrknPiDEOH
 ZrFC2Ldb+fm2Cbpn9bbmOPdwBg56HU1AqBuGuzU8sV4CogZpkC7ObSSVi+4HxwX5DwNw29Xpg
 +gpqYumCD+I9aKxBU5FCSmPFGYk3tZvM2Q621FcNWrMxSRqEYURU80N5OkF8OtAp8qmQjQpvF
 VNof40d4XcUL4IU8mG9eQwHsdpefq/ddLM8k7yx4HV3OnwmzuBSavYeTB6NRdfFcRpag+yZie
 ewzxRd78JDIIl5P5KGYGq/ZF90YXAVDLFNYTRG3Oq/vKr31Ytn81cipmXPs5/r1/4SINmg3Y6
 6C/A3XIlyUIZEIOCkHSjLPwZkodkNQJDeeRy+ZDssfLnKon/TR1u9fVhTiE/2H8UeV+5JEhBY
 8EydZeUDIQEBJY8VtAx4tt4Eo3HV08KwpK83oqE5YKrcGinAyZYE9liq5GoiGySqTSKsm1GVb
 0bKW716vj8lBuHPdNi3w9Q7OkFApgGoA5q9N9iYxORRgS4WwpVzVEYDWn0WpSQswBXqG4YEEx
 C7K4eunCLWoqEapYzas66PlVSnVGRQZNPvHgZ7ojwx5j1B3CsE41Yvnyx2soPfacMV3k2nE9I
 cGSt6lvpi8PbPXwg8eAg3gx5du/VjMEdMwuXgytAinS2TcHMUK2CRS/ymV2JJ7CFN5SENQY5t
 EKWC1qb2AtevU9jJjn/dt44SKiSMXvrnHR1cg+poYbzChCLXz3YUQ+4yPMdlwvi1OxgUnG+Vf
 cO84ksWrePtkydKdsqdccorW3j8amLk9Z1zV1N+IcWBhSKNT8qK15gmpmMavgYSkFadrN72Nr
 M8mCf/nUJCcSY9K/rx/6ObYn8OF04jM59IevFrNJlhXl7UPgOzJMxbK41zevmN+Oo2Y18N4l1
 k942MQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 66394
Cc: Evgenii Klimov <eugene.dev@HIDDEN>, 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Hope we get more opinions about this interface suggestion.

Adding Evgenii to the thread.  AFAIR he had suggested a subset of this
suggestion (the filtering part, in July in emacs-devel).  Maybe he feels
like trying Thierry's approach.  Code is here, just eval if interested:

  https://gist.github.com/thierryvolpiatto/2219f99ac96ed1b468fac204bca23b4a

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 24 Oct 2023 03:43:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 23 23:43:21 2023
Received: from localhost ([127.0.0.1]:52682 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qv8K9-0003ii-9p
	for submit <at> debbugs.gnu.org; Mon, 23 Oct 2023 23:43:21 -0400
Received: from mout.web.de ([212.227.17.11]:57277)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qv8K2-0003iM-Hx
 for 66394 <at> debbugs.gnu.org; Mon, 23 Oct 2023 23:43:18 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698118957; x=1698723757; i=michael_heerdegen@HIDDEN;
 bh=EwAKO8K8dvrXZjD54KgzlutlE2WyeOZq1Pf8Q6goHP0=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=hl42Ac0e3WMh0kc6NuVUKnq+WbF92LHQMJy/itHNaSvj+KZ0bMJ7E+n23XgiDtVZ
 ChkDnh4zA6jmLUf+6FeaS7re/ODiPtQUegvs8kkftsYJnPBOSBC7yO3wQKXd54dNy
 VOvscL7RLigDhzEHvU/Z7Db7aNfC/gdMO9kHz6QUEqwOn2g75A3RdyyAiZ4lQzHKs
 Nr0kkOkm8WWTiEwyfITxdbm1Kv7X0mcWfB/JvJHjgGsWnSjeH8d6ZY1dEAMsofpxj
 6x13TOGBFuub3bzMTsTiPoTGyiG9UYbLvvklaC2i+v089J+nJAuNGM7hD4Q8eBvia
 wbaztZ4s+QBcBwF+Tg==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MSZHv-1r5sl21odt-00SzFe; Tue, 24
 Oct 2023 05:42:37 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87msw99a95.fsf@HIDDEN> (Thierry Volpiatto's message of "Mon, 
 23 Oct 2023 05:14:07 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
 <87msw99a95.fsf@HIDDEN>
Date: Tue, 24 Oct 2023 05:42:45 +0200
Message-ID: <87bkcovg7e.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:MQLyS1ge9z5Af8PozR1siOqzctfmmBVvpzve/zQoNNJjudCTmJk
 5mPRsgIpj1NmqqlROoR8dfwBYHdUTrHxf+iYzvvurHfxt56p961kMJ0Pa0U64AezkyduFXQ
 hnzGm2FjfOavk7Ey0h+UzJaetjKo0bEoDZNzTVObBswFv/s6pluCSZszG7tA/EysGnG1Xlw
 ycB09qUjFdSHriRzNu5Vg==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:wfv7U28Hte8=;HDLw2/Zl3ClrabK5H+z0aB4LrXl
 BJHJxNU/KVHl8c0VxnpHDEFF35wqF9spQ1e/Le7AfFQHR08yOoJHxwNA4IY0dsKzoGVMKMAon
 yLyiGOUnaY4R9qiGUeRHkAHytANDZpxZjibG2DZ2DNsfd3/12yUOaoZ5sLPPSy97y5t309J1W
 ZzsWUu9fBgPjrxB/JElRUPvKVATz+ifyBLtPUuytJ5RTlN1x6TLH3nA3UL/tsI2o0fuD8e8QF
 vbfl0gJPjQJvPlqIrfx9kOimKx5S/j8EfDTXWP7k8t7s8Gmpj4zAv2mjeSu9Y3mf3aN8724zV
 UOEnuO84yIIAAbs+JGq2051R0R4RV7uOaUw3ubTE5ebrsnq7NkpZv5YUVIF6qUAUeYZQBG3Z4
 7XYCbSSelyzZJhW+7Q8htzE0ZpXGW8mVC/M3yb/muiPlwbMMDa+miJSFEgiDzNIeB8TrTvBtC
 NshdaHXv7VwzhIZ/fobZfOh7gcoZ0netNPCRsEUyEi4gjHqJeTchkub6LbD2tmpVc/t50RHor
 fu1fT09Cg5txlYfxymIFrtj737MMLsj2KvADB789V03dtHLa0Jr0KCTZEtsTxnlKTXcaLUk0I
 rWkoB+EsQb49jDDTHCL1VOJjIepquXsV1ituO1MyxmkNjMJCJ9rY0ts4lGI82atrW/GvFtzuA
 zhrnVv3yfYXkEzxVKuyXg+5LWCpjc0LkhivliC5FMlu6vrOyvQhfprF26buA4ccV8pwYhrA3V
 B9AWLz7Wzq2M8MfcyE90rggdlO+bkCxkvfVAwOUjNhYsImDUPD7BkIJYS8T4/r7adjW0aLbtK
 pjh12YWA4Axh0SmYwMOhct2yGHfRViSBHbgMmk5Y3Giji/HmcjE2RNVT/Dn1nhFBJEDYin9ez
 tK6dTDGt3aZ31UiIcW0ZFdVvZZkwwKlfo2t+FmJ+Cdbnr+AuJUqk0BwQHvU43RCcYK78BCt0N
 cIb16V24Ti9iIR+MMDHnv8TQThk=
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> Yes but I think this should go into another commit on top of my patch
> to avoid having a "too big patch".

Yes, maybe.

Ok, some more remarks (I have looked at that url now...):

* Would it make sense to also allow M-n (known as "future history" for
  `completing-read') to gather the next free register (seems also
  natural - just a thought)

* Multiple times I saw "contains no text" where a better hint would have
  been to say "empty".  Not all registers contain text.  Happens
  e.g. for C-x r SPC R where R is any unused register.

* register-preview-default-keys may be initialized using
  (mapcar #'string (number-sequence ?a ?z)) if you like.


Hope we get more opinions about this interface suggestion.


Thx,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 23 Oct 2023 05:30:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 23 01:30:46 2023
Received: from localhost ([127.0.0.1]:48841 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qunWY-0005OD-Eg
	for submit <at> debbugs.gnu.org; Mon, 23 Oct 2023 01:30:46 -0400
Received: from mout01.posteo.de ([185.67.36.65]:56619)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qunWU-0005Nv-9w
 for 66394 <at> debbugs.gnu.org; Mon, 23 Oct 2023 01:30:45 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id D2EEF240027
 for <66394 <at> debbugs.gnu.org>; Mon, 23 Oct 2023 07:30:06 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1698039006; bh=0QfLB3IJhPq2HB5yZhBq4kRftTeNAKUZQt4zUkfxC5Y=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=eWZHGlbM6JiZXARLJAKghokMWU4CSWVptMxOl7dncNCH10mJsvTc5YyCqbD6nO45c
 mcWtZ8CPzUsx5MwE0e7BtGZ2h/xsPwKKDRvZWOFw5Ry57L/o5QBa2uyLtlV7tkFe2V
 AR3+lWZCdYtSWBSyuTGhlf4c+nSvDc5kSw+LARsIPI7guFrVSgV5pxkF/53H5/ffw0
 XZDiXQC5pOW/WWVNUyF/2/WjKHwYsbB7GdHvKK8ohJKWNxT3qk66UkTvPm6piHgoML
 r0gRULzh/Tdw8MdAPcirp2mfI/y8y2bdcR00jTBA0TpCluxY74ZveCkFPYogOQi2VE
 piVREnKXY0pHg==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SDP0F5WYPz9rxM;
 Mon, 23 Oct 2023 07:30:05 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN> <87y1fut1wp.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Mon, 23 Oct 2023 05:14:07 +0000
In-reply-to: <87y1fut1wp.fsf@HIDDEN>
Message-ID: <87msw99a95.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> > For jumping?  Why is this useful?
>>
>> Well, actually with original behavior you can jump to a register
>> recorded as a string, which returns an error of course because the
>> register is meant to use with insert.  Now the situation is better
>> because the candidates are filtered but you can still jump to an
>> unwanted place, read-from-minibuffer lets you the time to see where you
>> are going.
>
> Ah - ok.  Then that's definitely useful.  Haven't yet tried the complete
> code, but I had a look at the link you posted.
>
> It would not be good to carve the current register type system
> into stone.  Instead of your `register-type' function I would prefer
> something extensible, for the case of new register types being added
> (even a normal user might want to do this).  So, when one wants to add a
> new register type, it is necessary that one is able to declare, in some
> way, whether registers of this type should be included or not for
> `insert-register' (and maybe also `jump-to-register').
>
> Instead of a detour via type names a better way seems to be adding new
> predicate methods that accept one argument, a register, and should
> return non-nil when the argument register can be inserted, or jumped to.

Not sure to understand what you envisage here, but if you do something
like this you have to make the types used for the two register commands
configurable as well.
Actually we have insert-register that accept '(string number) types and
jump-to-register that accept '(window frame marker) types and this is
hardcoded. I guess you want to make register-type a generic function and
add several method that fit the types we actually have and if one wants
to add a new type he just have to write a new defmethod and add the new
type to the methods suitable for insert or jump.

> I can try to modify your patch accordingly if you are interested.

Yes but I think this should go into another commit on top of my patch to
avoid having a "too big patch".

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmU2BNYTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk7w8C/44172MjI8dPJ2Up4OxxPvztomcZhpb
J8RT02cl7vW+4L/NXzEsF+g1Hivxr4HcfosiNjG5KmGMhEqGQx27w8UdpUIzsIvl
aAsAI4b2JgiHGbwfN5qvIGlieNnKbLuha3awe6tn2hQApLC3f4zQGqd5SPSjwJCt
OQV01nzEOPMFLt6fRdzn395wf8JqKaneLKQYcW/p14eSnAWSu4WPEtxtWqRQ4inX
Nsqki/GqR5OVrWhSAzMb+rtaWtKdnHX48JpSaRpItEdqJgMTSp+vCrnrLUDslPJM
l89IV3g7gKZ/Sdbsl7QCML6jwgXMGzz+P4i01QpbpTyISIbDOdeINg7b1FEluY7S
GPwxBjPpMsVq1AZx4uIaafeIFGW0D4h3OAoqSsq7z93jJx5seOC24K+qDox+zyMn
EgSmuTPXuChKlWDp3MnvbG/RvlKNrKYq0m/s7wS2FdiiaKO668qIXKvTBcpFsvc2
5exnfRwN2SS8GaP6T+NlSbEI5nFYN+MulTo=
=4nAl
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 23 Oct 2023 04:10:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 23 00:10:29 2023
Received: from localhost ([127.0.0.1]:48764 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qumGr-0002N0-A6
	for submit <at> debbugs.gnu.org; Mon, 23 Oct 2023 00:10:29 -0400
Received: from mout.web.de ([212.227.15.4]:33085)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qumGo-0002Ml-Qo
 for 66394 <at> debbugs.gnu.org; Mon, 23 Oct 2023 00:10:27 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1698034190; x=1698638990; i=michael_heerdegen@HIDDEN;
 bh=FwwY4Jwmzs310CVxve1JeF9uhDz6Gw1vw/SP3n0ACZ4=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=AK8hwRPtXgX3bYhDuV13WKWQp5jlZcvEtgzZgjbVoAQHlPyoEVfZR7et/1rYl6ur
 mvjStglPktH0qWlGvd9RnrLc1QVdq97pUIhHxSZpYLzEJ7zr4iKejXcPndtxTz3yW
 GPL2wAG1gZ+8Zn7FfTPnsc4wddpns0yhZVfC1oW67IrK9FvD0xqleefSoZDTbrNYl
 kzLk0WG7DEdwfoceFIc2q/fO5Ty8fJaB/TMSl0MvGY4rEIw41dT/ZBVatI2V2+2zn
 TV0MlHYkok16s6aQx4TCFOYvrdOT+gxUUpd5a0xn9ci7bjiIWOCpkpTL6n/+DvHR8
 33Ud9VhWHEX7xDVfYQ==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb006
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MQgp0-1r7LKq2feI-00NvTL; Mon, 23
 Oct 2023 06:09:50 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87y1fwtyrl.fsf@HIDDEN> (Thierry Volpiatto's message of "Sat, 
 21 Oct 2023 03:34:43 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
 <87y1fwtyrl.fsf@HIDDEN>
Date: Mon, 23 Oct 2023 06:09:58 +0200
Message-ID: <87y1fut1wp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:pzpYEpaLFARp5WUJJcQNtF9USNkDQwlWln64D+e012fTJ0YNhbW
 3d8aahn09w4TZwrFkMAnuIR0lU697l02R8ny55cKzeGqpBYrJCKJQN4z9FmDmYturEaLDRo
 FA9gFholvQSDzdsIZUNdGmdHdpBRX2j/ok2xLOH7d9OYwJ0CF8bCc2JrOc/ImoO1jyKUqqh
 QW3z8eBtPY61pHsHUuItg==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:ys474W+P8fg=;tCshqYccn7abhBsdu6SaRNg1G+p
 HgDlVcaLYr8SwR25Zv+Kwlrp4v6AoIBF+BwGCFtPos89gYtlAEXc8c8egV78x7+fEypuKmiv0
 kF/ZGFRig23cPcPhO7BhgW8yR+Z+fwpbZw3lLcCR5a/KwJnfum+w/sEqQjdG3em88X5GHY6wM
 In5Uic8hMS4NWVlf4WwniOAV5kh/RF4AS1WQj/ey8Mu5SlgoBEBEL9FfBGlCFzVWxo6l6lGJw
 PtR38UIi3MMfC8lbScTavSSsBgoi1lpILkEQ/yG18VEvGKCTN+p26hpnxXC/bnkL6UEEIESCG
 WpGGD8VuUgXGcc2J6PEWacd1Y+8ggxewwG5iEvxZMjriaAg1K74D64eSONmynIOSXtubEG2Um
 muhRADsQ/VKtXOJi6RqT6IdTX6gNRNVEukuiNNa8A2pMpf9V0jA7FGrImEEB6BDyEhtEhWlgM
 Xf5K24i3295PnV6JbSQV2DeIpdmx4tEZnUn2fjVTr48TtCSdDjA9Ig+IuL39jd2ozAa+QiCy0
 1/SEbRRQIbIFU/jzUGrXSlYPjp4mOp8OLRx8vEHmFNjvsGHwLCZtwgx+2u2YgYCB9sc+RXfSF
 kGMbVnQbY+OREwOoU0RlmH3efsbS0qUZJIbJBP0aqXn3BdZhV3MacAeP2eELJ/m7zeNF0Y9qW
 SxIDercd6cBhit/yaL21ZJawYle/Sxfdn1h6CVfSWnAQCjdaaoWjgpJdykDYsxjAO55XO4k8X
 fGpz4yE3DGW/mx6t9NQcIgLqvbu7j1BhciKSBWJ1M5YyyhDb43ErkOozrDnFscwO4zeL9iQQN
 BuC/BP2UjAeczAFYwUCT0inK5Zwl2Zgz7/x0WbKe+nQ8wWlkQw8A4x81aIRK20ahfqKuT/hHL
 S0DXxM+SNIp9M2dJJJsDjwVqRahXdliS0e4Q2Yc2/+eZOHlf+ZGnbfujOncKd/DGClu3DBcNX
 Y7eACapcVXclbDz+Xh1XZjqlKiA=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> > For jumping?  Why is this useful?
>
> Well, actually with original behavior you can jump to a register
> recorded as a string, which returns an error of course because the
> register is meant to use with insert.  Now the situation is better
> because the candidates are filtered but you can still jump to an
> unwanted place, read-from-minibuffer lets you the time to see where you
> are going.

Ah - ok.  Then that's definitely useful.  Haven't yet tried the complete
code, but I had a look at the link you posted.

It would not be good to carve the current register type system
into stone.  Instead of your `register-type' function I would prefer
something extensible, for the case of new register types being added
(even a normal user might want to do this).  So, when one wants to add a
new register type, it is necessary that one is able to declare, in some
way, whether registers of this type should be included or not for
`insert-register' (and maybe also `jump-to-register').

Instead of a detour via type names a better way seems to be adding new
predicate methods that accept one argument, a register, and should
return non-nil when the argument register can be inserted, or jumped to.

I can try to modify your patch accordingly if you are interested.


Thx,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 21 Oct 2023 03:56:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 20 23:56:28 2023
Received: from localhost ([127.0.0.1]:42004 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qu36C-0005LP-21
	for submit <at> debbugs.gnu.org; Fri, 20 Oct 2023 23:56:28 -0400
Received: from mout01.posteo.de ([185.67.36.65]:35711)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qu367-0005L8-P7
 for 66394 <at> debbugs.gnu.org; Fri, 20 Oct 2023 23:56:26 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id B2E3F240028
 for <66394 <at> debbugs.gnu.org>; Sat, 21 Oct 2023 05:55:49 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1697860549; bh=y7EFUqxEkCy353ZP2HQKLA71qkTmLpP7KXGm28rN0Mw=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=WHwr4juixHxks7z2VUMXfo4knsiDETn4zq9uy3QAFm786BAIiITB7Jsjtd/ZRhiOL
 aq0896MgpeS1yCI0Q8jjdp0/PV1A3eH86m6HNQ0VZD1uqVMPPmVxbX7Zl8Gflx4pHn
 3AHARIa5iT3gohxbQvjDylb3tRqyJyCvsArN9OWgTOQiyTwJQP5itH6zGut6hEzCCd
 BtZsUpXobCCzjigSS+EaqunM4Sl41tAYRjHZ6uP+t+zbwUWCDMXcB+Wjee1dnefbKi
 89UjZDwuCCG9r7SjxxHw6UYlJlERdKRls+EyoEPpbR7n/ozDtWCIc5LOnQF9exYI2m
 l4Xv2Po7J6khQ==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SC70N6wCtz6txm;
 Sat, 21 Oct 2023 05:55:48 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN> <87bkcslr18.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Sat, 21 Oct 2023 03:34:43 +0000
In-reply-to: <87bkcslr18.fsf@HIDDEN>
Message-ID: <87y1fwtyrl.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> > For keys like C-a you also need to hit C-q.  It's not 100%
>> > compatible.
>>
>> I don't understand, what C-a and C-q have to do here? Also, what C-q
>> is intended to do in minibuffer?
>
> Registers are characters.  Control characters are valid registers.  So
> you can for example do C-x r s C-a to save the region string into register
> `C-a'.  Your patch complicates inputting such registers.  Dunno if
> people use such registers, but I wanted to mention this.  It's a bit
> harder now to use non-printable characters as registers now.

Yes, probably this is one downside of this patch, but as you mentionned
one can use C-q C-a if really needed, I for one never used such
registers.

>
>> > But wait: What I find confusing is that I also need need to confirm for
>> > `jump-to-register'.  Is this intended?
>>
>> Do you mean RET? If so yes.
>
> For jumping?  Why is this useful?

Well, actually with original behavior you can jump to a register
recorded as a string, which returns an error of course because the
register is meant to use with insert.  Now the situation is better
because the candidates are filtered but you can still jump to an
unwanted place, read-from-minibuffer lets you the time to see where you
are going.

>
>> >> Note that now you can use M-n to select in minibuffer the available
>> >> keys (this only for setting or modifying a register).
>> >
>> > In Helm or in vanilla Emacs?  I don't see that for M-n in vanilla Emac=
s.
>>
>> Once the patch is applied, C-x r x M-n (repeat if necessary), same for
>> C-x r w/n etc...
>
> Is this part in the patch you had been posting in the first messages?
> Because I only get "End of history; no default available" with that
> patch installed.

No, I will prepare a patch later, when there is interest in this
feature, for now use the gist I maintain here as mentionned previously:

https://gist.github.com/thierryvolpiatto/2219f99ac96ed1b468fac204bca23b4a

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUzS74THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk+kHDAC0wew7ufsr5ydzSAFSq6DY1HEAnk9Y
6hjo+IIUj1pJOvhvE5kxCy5ZC3Zpu0Inir5U63GhS/IphwznYs8d+LPS461HU7Am
YOQNl8Rc0DvKQltSBmb6Yl2Dvei0Zk26lHPp/+RTXotIaoH6FRp8+bUPU/MFkFuj
VfxwwUTJjARtfdtcqEYA/K7UawASvTUXKBF76y5XZoDnH8AcETWKBAaqknDRXfVK
gtttO+OpOp4mYU8jYs68nqCBsDGZ0a16uIf7d39plIRPmfRHp1k7EzME1cYFky+J
us/Bloor/HJoBkBrMcA2KHIwuBZWA6GCFJIWVsAtogj1Wz/wG0GbORZ0/uo7wBIq
mO26kHHpltmUyJzZ1J6ZWqvNbk7OTFDE8tICebameRGxEu55ahYxoFIcwk8Zb42I
PzQAozbGjv0/gAfhS8blNEBk3TsWPZL8L8/JEZcVwRaGNfqB0dnymst7gE0bjKJO
nvxfku++Bmjz6qZiA7lQTxGq5aUabCe8KOM=
=QxXV
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 21 Oct 2023 01:10:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 20 21:10:33 2023
Received: from localhost ([127.0.0.1]:41901 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qu0VZ-0008Dp-LE
	for submit <at> debbugs.gnu.org; Fri, 20 Oct 2023 21:10:33 -0400
Received: from mout.web.de ([217.72.192.78]:42283)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qu0VU-0008DW-5e
 for 66394 <at> debbugs.gnu.org; Fri, 20 Oct 2023 21:10:28 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1697850589; x=1698455389; i=michael_heerdegen@HIDDEN;
 bh=PrUEpfvbdxC0xz89ysQwOIHkqhUSTixvxVV+fI5Wg3c=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=Kdp/8m4s1SmhYwoYV0ZgTssR0bRaRb1LdZPSOVF6qIM3DEtDWU23a5jRcYCPtdKu
 LkeyLUNuFz5myqLyHtMrwbpJprFConm4V3iEQAE/hJQnaTUkzcqigTFiTOLPoFuW/
 0zzLoxJyaCnIlyPtNv5KYCl4wDH0iYaOEWdruAVneIwERepH6siH7qJ2WJ+WCan0F
 UnTsLHXHpcAa34B3hnxb0r3F4qZg72vHr6DmYIwEUp2MvlDENS0ub7uFU3e3zgHUy
 /TYJ6okUOe7KMrHXeTbkivedU7pD1XjxfLodpew/wWPwS0kDb2SnqDLIFFkJI1a1D
 sE/K1R2B+du/BG5yEw==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb105
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1N14pE-1rdptX1qbi-012Maf; Sat, 21
 Oct 2023 03:09:49 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <8734y5vnj7.fsf@HIDDEN> (Thierry Volpiatto's message of "Fri, 
 20 Oct 2023 05:49:26 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
 <8734y5vnj7.fsf@HIDDEN>
Date: Sat, 21 Oct 2023 03:09:55 +0200
Message-ID: <87bkcslr18.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:P98hpJowKAsHL2Ysgckrljm8Imw5TjI2PFDJDDGSs3gRiLSqIt6
 qbxdT8JAXOOVkEVUa6jOZmRuaNx92w3bWKadRYtAJyIahCI4NLtY4s575PkVoYhiaYm57Lr
 8lCRbiI4riormqNfrrlTObPBXEiADWF9mQUgcTmwbBXDXq21QWOYLw0a44kMp/5Z7/yg8j7
 RkQH2gjjFbhbcjNZDQzig==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:kIZ54iX+l4A=;Qk//EcUAtdQICs0awt0a7UGvzRs
 I4NmdXj6d4+zx9f4hYS+dKcKCU/5PEPBLUWNo+3NAzBIHnG7+XLUJ5H1ddKwjbTZMr/pkj1e/
 UaY2h8grxTubbXDcvvYjSqRftFPzwbq3AEF5plAmHKiLbAh10zz+2XxcrSTmZEQExuL0nHoO8
 dbOX1WXQB9Hzyxpo+7kLWcTJ+WUr+Z+96xm3IhS8szgwqlNLbB1wcI6iakkFCQ0wxmrMVJIc2
 gqgr0UF90YQyp/fs/59W6BEjWDEeZWh5gkwnOQ9W5EnBPnipVJrWsgAkg0AmuiQADbgtoFIw2
 K5xZnqLpC45x87gz7EVnVb63imnx1znyanpai7sAjRO/W05Ri7qLS8oInmC3uVZnKTKj4L7D4
 AkacwMEu5pRMCWbKuHnywry24730WTHrPoYXV+tHu3EtY6JQTKaUEYZN2oRQQc8xRC9rFYNfn
 kcYxlNkru4QJQyqXFmbhQjBHgNvDXkvmT3qSOxfFWZlh54HKoYt7+vGKdVXqDhr4H6ufNfFhW
 0yHGfHRBak3N5aGwoqewS/K22tf3ukM3AFd8+FBl0wTfOLrDjOOcqOlou3+sA+kC3swMOwEYh
 VumMwCSK21yTHjlSoVVvox3qq/f2xfv907HHyxves8eXErnaw7B+q9CLsTSOR+V6h4CCsGgbS
 HAUuOC4adKe95T4Ne88Jao6qXm4Ve/lsSdz4yrrc2/EkwOXzpD0YTF0rCJrOU81yItWZ1R3HK
 CinR5mrClCzF8fzX4FfwM4TN106igsvNK+H9PXbykYNJS8ovvk6/ybcn8Z7Jd/d7Pdxerowhi
 JqdhWXU49Y8f/pJTRXG7lMrCBcc75iLJGjUZkTfCmTafFhZgfe8rf9IefUtyJ96HHt2hrgeIM
 HEvTTHOvjNvb88C1+t0ASrjlfyvP/WGUfA3udb2moxB/WDxrXpIV9KlcAHC/9GrKapqiSwHlB
 fe8gzuTTtFzV12FbXWq4pFjMZmg=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> > For keys like C-a you also need to hit C-q.  It's not 100%
> > compatible.
>
> I don't understand, what C-a and C-q have to do here? Also, what C-q
> is intended to do in minibuffer?

Registers are characters.  Control characters are valid registers.  So
you can for example do C-x r s C-a to save the region string into register
`C-a'.  Your patch complicates inputting such registers.  Dunno if
people use such registers, but I wanted to mention this.  It's a bit
harder now to use non-printable characters as registers now.


> > But wait: What I find confusing is that I also need need to confirm for
> > `jump-to-register'.  Is this intended?
>
> Do you mean RET? If so yes.

For jumping?  Why is this useful?


> >> Note that now you can use M-n to select in minibuffer the available
> >> keys (this only for setting or modifying a register).
> >
> > In Helm or in vanilla Emacs?  I don't see that for M-n in vanilla Emacs.
>
> Once the patch is applied, C-x r x M-n (repeat if necessary), same for
> C-x r w/n etc...

Is this part in the patch you had been posting in the first messages?
Because I only get "End of history; no default available" with that
patch installed.


> > Oh, and there is a little bug when the register binding list is empty
> > (e.g. after restarting Emacs): your code errors because Emacs does not
> > pop up a preview window in that case.
>
> I think you mean when hitting C-n/p or up/down?
> It is fixed in last version of the patch (not publied yet).

Let me try to be more precise what I saw: If I start Emacs modified with
your patch and do C-x r s with an active region, I see this message in
the minibuffer:

  Error running timer: (error "No buffer named *Register Preview*")

Maybe that's already what you have fixed.

One more detail: I see "Invalid face reference: helm-match" in the
*Messages* of emacs -Q.  Still using your first patch (Could you please
post the newest version again?).


Thanks so far,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 20 Oct 2023 06:03:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 20 02:03:55 2023
Received: from localhost ([127.0.0.1]:38473 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qtibz-00022t-9M
	for submit <at> debbugs.gnu.org; Fri, 20 Oct 2023 02:03:55 -0400
Received: from mout02.posteo.de ([185.67.36.66]:44749)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qtibu-00022c-O6
 for 66394 <at> debbugs.gnu.org; Fri, 20 Oct 2023 02:03:53 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 871CD240101
 for <66394 <at> debbugs.gnu.org>; Fri, 20 Oct 2023 08:03:17 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1697781797; bh=mklZ2qC0muRIy3YgaZmThThjXhuhR30FiehWLS5nQuY=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=CfSRf6A9IvlXXLcuOAOPMfgwnNxLYupsEYTvXA5ccVFocL/WVwx7Bw0A2s3oz0JJE
 Uyfna4k5Nzy5LQvWdjgIz5mC3dvCZtLKJH2wSLbvlagfwTxWP1YEpx2QRrCQx1B7WF
 2vKz9ris2zCYvCdbwI0MTAa0zOe71JWLjScuoXtk8Dl/AreEBDIU7mC4p8HoXZmU6g
 qE0KHLtDJHxyYYp+oGfSKxunPmemAfl92Am2jdQJiKOcy9BhQicAJMebgkR/tkfOvn
 cnIEN3VXbSyLT4P8Rn5QItTc8/bZQb97UFtWyeDUkBtTq9ZMZFvd3HEcAZUDwq539s
 Oi8Evt24woI1g==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4SBYsw4H7Wz6tvr;
 Fri, 20 Oct 2023 08:03:16 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN> <87a5sddh14.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Fri, 20 Oct 2023 05:49:26 +0000
In-reply-to: <87a5sddh14.fsf@HIDDEN>
Message-ID: <8734y5vnj7.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> There is only RET as additional key and it is a good thing IMO as it let
>> the time to user to see what he is doing.  Anyway using a real
>> minibuffer with its keymap is much better and allows further
>> modifications in the future to fit the needs of everybody. Using
>> read-key doesn't allow more alternatives.
>
> For keys like C-a you also need to hit C-q.  It's not 100% compatible.

I don't understand, what C-a and C-q have to do here? Also, what C-q is
intended to do in minibuffer?

> But wait: What I find confusing is that I also need need to confirm for
> `jump-to-register'.  Is this intended?

Do you mean RET? If so yes.

>
>> Note that now you can use M-n to select in minibuffer the available
>> keys (this only for setting or modifying a register).
>
> In Helm or in vanilla Emacs?  I don't see that for M-n in vanilla Emacs.

Once the patch is applied, C-x r x M-n (repeat if necessary), same for
C-x r w/n etc...

> Oh, and there is a little bug when the register binding list is empty
> (e.g. after restarting Emacs): your code errors because Emacs does not
> pop up a preview window in that case.

I think you mean when hitting C-n/p or up/down?
It is fixed in last version of the patch (not publied yet).

>
> Michael.


=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUyGBwTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk2JkC/wOTCW+WKHqSXYKaEjctjV8sQ3J1rVx
YSZ81i8Cj7WR1lAPkdQo6dzXK+3eAWEXAMnZeM1WsBMz+G+CuyorAKGA/BAltO96
zelaM0i5Fxo6C8BhNZhehPn/4MBZKJ1Af6uL4BpBphUbyMhz2nKzVEjspg4IJrWu
CeF/BdTxZEFa5Pwp3Chbqn/m701ZMLTyHJcutHw5UgoO4hBHu5cxQEBnIJqdntnZ
IoEHXq0fvTI0GyrTlJb2oHkwbvxgzYLMkG0pfgmGiVh4ShxrOXtcTOTIjOz/70Bs
NKSU3P4F4oU5W51n3Hf1fTmxhdF4Xz/7W71/hsdeZgXTQA7CiQB9u6V8TcBxFAUJ
t9xObmTZzB5iANdCI2Q/0My6Q6cnUbrPkcPTMttrWbLLAYncrRTo1PCIdX3oSbMk
mzKQuseBeAJbxCyd7hv7rK6PYYKJLhSRR//x/ZuPTmbcNmpFlczyXFmFYiWyLkj8
RFysSePJhO1SA7v/PBDTzmNQxKdR0RUqmv4=
=1D+M
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 20 Oct 2023 05:01:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 20 01:01:25 2023
Received: from localhost ([127.0.0.1]:38434 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qthdV-0008GQ-2v
	for submit <at> debbugs.gnu.org; Fri, 20 Oct 2023 01:01:25 -0400
Received: from mout.web.de ([212.227.15.14]:60349)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qthdS-0008GC-PI
 for 66394 <at> debbugs.gnu.org; Fri, 20 Oct 2023 01:01:24 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1697778048; x=1698382848; i=michael_heerdegen@HIDDEN;
 bh=udk2XmjIbva6x8XR0upxQV2V4Wm64UANynNe8VNx+hg=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=usPAacnUGT4FIqfJf/DRAIW6fiFVv1JzayWFUdxvrVLmIRggGJ70m+78duZ1szD1
 OKBidhC+ZEcSISvhCn4TUyapY39le7tm+6Lmwc6cYCs2jsG44g1m0wcpcnvChuFJs
 O1gBMhF5Cs/xUjq7/Cw0tmLk78DkFUQhsp6kIJ3TrysZEoZgzo49rfShPULeAaVnF
 YFvMYoKmaCb+CmKuX5Kc7rvYDrRMXenBrlvfdhJrY/T4Y5yTGsLHH3IFYT3YDDOJr
 9gquLPr+zUGmeK5PRhYQKeBH7cYDVdK/F3OzXj7tsnRWmT8jpq6E0JW0UhK1Z8eYQ
 UkTqW86UlSB43LoHXQ==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1N4621-1rcDLN3S6L-0101k5; Fri, 20
 Oct 2023 07:00:48 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <875y3386ep.fsf@HIDDEN> (Thierry Volpiatto's message of "Thu, 
 19 Oct 2023 06:16:13 +0000")
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
 <875y3386ep.fsf@HIDDEN>
Date: Fri, 20 Oct 2023 07:00:55 +0200
Message-ID: <87a5sddh14.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:GB9PzgiSVYnawrC8PNMkyA/SaZApXcZgPEVv0NnPkDx1yuG0lRa
 Hkzgm15aJ4Jn1DIKyssgDK+PhmlIw0qPE4BWhfyzWSRInQGuDyVAhU71m/pmVnlKGBmFhPk
 2VR/qPhGe0ZoTczKMoiPEFwrJN9+losjgcNYCqXz2XhrUaQio+4sIom7DnnRYtqYzHBEPa9
 U5BJNNz1VvMadE3RQwU8w==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:R30tWRwc8kc=;ZH6lWKr1b7m7HUGVQxOv5WNqPTV
 C76TWcZRErpL6oeiuVjpzP7lXuMH9+2X+1EygjrcjkLdXrA/CXWzQi6HT3Jjpr5ntxcCaa1RF
 6DiXuHQgxFdU6vlnexpBVzvnRElPIQY8NBC1R3+ZJtXdxPc6lWBA5qPlgw2AeGzNwZa6q7wyK
 oveFI9KkdNASY6qTkzXnfGClOkU6YTMMWbC85g5Lc8u+vBh1l7mAw/fOwX4k+FzrmH4Q2+oB0
 9h/WXOZ1HIsMQjiCjnk+YBNvDFxESAbiZ0i/AnyQuGJhzoMp1ncZwGgkC1R5FsJn57b6Yq2Mj
 a/qzVTmDQI5VbmfnTSMRYxGTR+y4NaoUR2hy92q65UJXLw6ifJjyohDYP9B8wCYZpwi6QixJU
 nAekAjuLZ7//w9qYKXc85mwfp3/SOd6v2rQks8Hwq1cVDTIfpXf2Iyl6bPbeVxMcKCEu/rNHW
 3GEjjvi/P8tD9Jnvq5UqpTFFTIsi7XJJw5m/ZGnHKugnOKm3LZgJA8zuMxiqJhnsLWZfV23Cs
 helAZFKBlkZNQBRlxubqu1VWmGBquiXu6DuFgBv45IidpxGSJeWYaUy2cIknjkeIm2471b2zO
 NBrVdJn2WfcMCaKlDOVvGv0VdiATJJY2FOkT2DPF9/dGXU54ub2cqp0CSO8SHGmQzR3WsY9o6
 noBhFeGq5wGsmL2IYdtnSATtFuAWKIsu6s9Iapt2ZcDPcWye4t+2AkjxBB2hPMLIK8vl66BeM
 M03aog94HS8YeSZlBAKC3Gdd3vl6uTPtZD0s9YU3e1igxE7SjY5NiSRRybt3R+LYnu04NTQx+
 hZiANBMWbMEQusBsUb59qH5FQlHjeH8LZIlT8+79O64dOXQfvOhf2hi0a4ny5iX0CyLK8Z49D
 Xs4EejK5Cf4rx2B1YzyuQm/2bY/pTss1kqyI6vXY7fxuF/1CumYcLXUSMVkOZMDZ0+4gNyBDv
 KT/4OPnF5VcsbU2EbmQ+d6/zcNY=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> There is only RET as additional key and it is a good thing IMO as it let
> the time to user to see what he is doing.  Anyway using a real
> minibuffer with its keymap is much better and allows further
> modifications in the future to fit the needs of everybody. Using
> read-key doesn't allow more alternatives.

For keys like C-a you also need to hit C-q.  It's not 100% compatible.

But wait: What I find confusing is that I also need need to confirm for
`jump-to-register'.  Is this intended?


> Note that now you can use M-n to select in minibuffer the available
> keys (this only for setting or modifying a register).

In Helm or in vanilla Emacs?  I don't see that for M-n in vanilla Emacs.

Oh, and there is a little bug when the register binding list is empty
(e.g. after restarting Emacs): your code errors because Emacs does not
pop up a preview window in that case.


Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 19 Oct 2023 06:37:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 19 02:37:47 2023
Received: from localhost ([127.0.0.1]:35691 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qtMfD-0002VY-C6
	for submit <at> debbugs.gnu.org; Thu, 19 Oct 2023 02:37:47 -0400
Received: from mout01.posteo.de ([185.67.36.65]:36317)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qtMf9-0002VG-Vg
 for 66394 <at> debbugs.gnu.org; Thu, 19 Oct 2023 02:37:46 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id 2FBD7240028
 for <66394 <at> debbugs.gnu.org>; Thu, 19 Oct 2023 08:37:11 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1697697431; bh=8JEmQvjW8LQWL1eCoTixuRYLMTb+ILx1kaCOJcMtchg=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=czxEEk/Qez9SYH0RwkF9ElHnmSCXGJ79eMq8IfK/tZGg18G5cVT28q4ubinrprpS7
 8JvUyzrwIrI3jZbG8+Qla72vx62/h3cWRawK25mwQNodfhUHS3aAgWy+mUt0Q3Dqi+
 C3LSPJCQb8C/CAzUvYNEL3INIA98Rv3lIgcmrHhu8PH94pV00+fHOZ8R/srTxa4ig2
 EqHDWW34T0+qp1c5tfouxrBDsJGXtaWEJn3T+vH+aif49qvJRTR1vjMeFpRvmU6vIr
 D8H656Ob08tUhI9kXEFpjjgYizBxJZ5tglBRVvw1XJ17FHOtmmzwp7ugfv6jC0UChl
 FNYf1Wuwpj0/A==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4S9ygV0JmPz6tn4;
 Thu, 19 Oct 2023 08:37:09 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <87sf67qqmp.fsf@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
Date: Thu, 19 Oct 2023 06:16:13 +0000
In-reply-to: <87sf67qqmp.fsf@HIDDEN>
Message-ID: <875y3386ep.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Hello Michael,

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> When using `copy-to-register`, it is hard to see which register is
>> already taken in the preview buffer.  This patch highlight the
>> register entered at prompt if it is already taken otherwise a
>> minibuffer message is sent to notify user the register is available.
>> If any interest here is the patch, feel free to modify if needed.
>
> I am not sure what's the best way to address this kind of problem.  If
> your version is accepted, I would vote for an option to get the old
> behavior back.  Your intended behavior is safer but requires more keys
> (at least confirmation with RET).  Some people might prefer the old way.

There is only RET as additional key and it is a good thing IMO as it let
the time to user to see what he is doing.  Anyway using a real
minibuffer with its keymap is much better and allows further
modifications in the future to fit the needs of everybody. Using
read-key doesn't allow more alternatives.

> I'm also not sure about the visual feedback.  If you use lots of
> registers you might miss your register highlighting in the preview
> buffer.

It's easy to make the selection always visible, now fixed, thanks.

> Maybe using the minibuffer always for the visual feedback might be
> better, I don't know.  Or give only feedback when the register is
> already taken?  Or maybe require the user to hit RET two times to
> confirm overwriting?

Don't think it is necessary with the register highlighting, and with the
real minibuffer, we must hit RET at least one time to exit wich act as a
confirmation (previously read-key was exiting immediately).
>
> Personally I hacked the code so that I can lock registers I don't want
> to overwrite.  I can also restore registers.  That takes away a bit of
> the pressure.

Ok, that's another approach but doesn't help to see what is available or
not.
Note that now you can use M-n to select in minibuffer the available keys (t=
his
only for setting or modifying a register).

> There also had been a request to be able to delete register bindings,
> but it had been rejected.

You can delete your registers with helm, but this is unrelated to this
thread.

> In any way there should be some way to allow a cleaner working with
> registers.

Probably what I propose is not perfect but it is a first step to have
something better than what we have actually.

Thanks for your feedback.

> Just my two cents.
>
>
> Michael.


=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUwzo4THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk/gQDACgC9gKdSMvTTV7zTiNDILllS5Pi0XT
myJqwdca9QK3LbM/x2gRVQH62aIQkRFR490uM1uJXWIR3EFt9pu2nAvq5fT2q/BZ
XW4Z2V8RHG2HZJAj/rWE0Qxuv5MqZPbTsfx9f5PvhPs09Rm01ShXGIxgC+PPEAFt
wBur2qFgH9rS0QZ6dowPWZe40HHyR2D8XzqcDo/OyL7NZ5XulQL06MgaozcNl8/X
0yxXxwRRNKc83lZ5iSVBPrE33CH0p+sOeT57WUzwkzlH848PsZ+w340QDadxOcKc
wssfxc29MM6LcOCtpzFsYvlr3QnLGWx/1AmNFt+Pn9GtSwEp8oYeS8DrOQXZJ8TG
75Y9fQAbSU3dCugYipoy6p+wrNfw/CYTBBOYRDkNGEbn9cRxWyfpf8kIHjc/Y3Mj
4zm6w7Yqn0reifgQhiTRWjIFl4fIaU3kG7C4U83tB9+IhpR7g82i6+YROTnSNWgD
moOpKzp4DeT4hgr1so9v28OSY+5RH0Q0w40=
=hupe
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 19 Oct 2023 02:43:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 18 22:43:26 2023
Received: from localhost ([127.0.0.1]:35298 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qtJ0Q-0002JX-77
	for submit <at> debbugs.gnu.org; Wed, 18 Oct 2023 22:43:26 -0400
Received: from mout.web.de ([212.227.15.3]:60985)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1qtJ0L-0002JF-FI
 for 66394 <at> debbugs.gnu.org; Wed, 18 Oct 2023 22:43:25 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1697683368; x=1698288168; i=michael_heerdegen@HIDDEN;
 bh=VVoygofp8qDnFQICp6mDwCxWLV6yX6OB/Mg8YAMqKZs=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:
 Date;
 b=QMgp9Zr0vySlrio6OUWAe+8+zabGfih1dOFakpAgcypla0sHEOE46cFRb6k2szUS
 YwyJNUeTg9JU961WWJeBoOlc4xjpkp3DbIO4xZ/1kg1GcoNAjsc+FzJTSjhKf/aCR
 Ebett0+yQk54xRS/eAEjoxy31fGCFyWMfqdJM9A3ch53ReFaF2aMJv+x4g6uqV16a
 qDLBWpRJ5GdFd5Tx5CD1hjmXWHSOTP+R37oE2EzU8Rc70bAh+JZajEFI3P3R82UMb
 +wZ4v9X+tF6wKihfbwiNs8j4BgdhK2lfPywZOpYjarMy5FgOy4CJAWJOjBvF1gGGr
 KbcgayB5tHdkmbzVMg==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([84.59.210.159]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MhFhe-1rOUos0kvC-00eOQz; Thu, 19
 Oct 2023 04:42:48 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
Subject: Re: bug#66394: 29.1; Make register-read-with-preview more useful
In-Reply-To: <87il7ib6cu.fsf@HIDDEN> (Thierry Volpiatto's message of "Sat, 
 07 Oct 2023 19:03:47 +0000")
References: <87il7ib6cu.fsf@HIDDEN>
Date: Thu, 19 Oct 2023 04:42:54 +0200
Message-ID: <87sf67qqmp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:oDQEcYdGAAw5EgYSwrFE2qqV000oXkFg7NtNK6nI2aHj7fBJYP6
 Jab1TPkaYUY2/vYB9UG5nBzzC1MCzaebVC+YhDPoyGyl89cwAA71y2VnPnL9UimUWDGDXaD
 ziHq+S2Jf3+L2TC7+WH88cYkxokOw3FpWgJ3C2BnKFyQigj6zWnuK+/gSwTQMrdl4WK4X4+
 rJmmHKk/FRL+6f1uiZWEQ==
X-Spam-Flag: NO
UI-OutboundReport: notjunk:1;M01:P0:RwD28WuoX0Y=;9qZFy6V16Y+jiTaO8259++L2PlU
 ZDbDAi4nSFBWutxQOhiFtsPLnXTHvfU2OGK3XIUDOeT3LF9YxHYMzSHVneljYg9Fef30fHO9o
 P9IAVDWEvHcJjxQQ+S04gOOV2qJflHZ/VLiUmVrZTjMxcIQxhvXAnfPYSjgVwAYXEmmJQopKb
 9asnh1P8Yj2RAKeVFEjEgDILLMqF0BlIpIDhCnUIFNwc1xpHYqmpjc59xUFmZhE9eZIgv+ti0
 FA40wIXNh5m9j7OGL7/yj9RmIWVwgU7QssTaJctShCDFdjqNmn7E+mCelamlr3H/4a6v+pXFS
 X9PT1iFulu/k/NyY4n4lcdP1KpC4FS8lMr9IPgpjBc0Sm1YF6UlTFoJJPHyy5wOUZdhUcsLXJ
 pzbjGbIuHtbTNOwEv2Hphn44Nl+RvVVCufkPIydMXEqEfPHuO3Gg6k18VKumQ7moERQdcDqeo
 pJ3Rs8VaXTgNPO9KWtQ8IdMBG7kYLVCBOU7+3yUgwYXOQk6sYG5elZe8NPS4f9jlFzW9UKFWo
 zyTfzfOIemR6tuYSSRYBJuvKvdJfo1hpXLDFYAavznNkvlhcfLa4s2vDagVqS6dgFZa+wjwEO
 8NEEr41S77Xlq+gI4Hk8zYNMI0dP8TvPlSZIHAIqBwLUd9IXmsaq/r6+/A6S5MiX5qtryfWwh
 5N2yp7Z4uiFdBOcHjwvFM7363XQReX4IQipegDb6XgRIKonYcGG1r0hhEjh3pmFDPY646vX1h
 G7bHEM4l9g9z5n0Kin+/VwS9kFmpozXByh2XxJxDbHesoeL5HJirocxR6hVnp0KRa/iBih850
 8BtvdAsvb1ecKgqVs2vBoKv/xJf/kx8EY+NpAUSsjJS2y2E51mfd5nkWKUFUTN/95s1GrSDGb
 znI/fkv0SgiYJt98NKTHbZoxwhv1HFK6WYQ4MDxKiKZMUDbl3CEajofntXrATzDoqAgGpGMS2
 yEi3+QBhZsz/wFhU28tWOvKIP+g=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> When using `copy-to-register`, it is hard to see which register is
> already taken in the preview buffer.  This patch highlight the
> register entered at prompt if it is already taken otherwise a
> minibuffer message is sent to notify user the register is available.
> If any interest here is the patch, feel free to modify if needed.

I am not sure what's the best way to address this kind of problem.  If
your version is accepted, I would vote for an option to get the old
behavior back.  Your intended behavior is safer but requires more keys
(at least confirmation with RET).  Some people might prefer the old way.

I'm also not sure about the visual feedback.  If you use lots of
registers you might miss your register highlighting in the preview
buffer.  Maybe using the minibuffer always for the visual feedback might
be better, I don't know.  Or give only feedback when the register is
already taken?  Or maybe require the user to hit RET two times to
confirm overwriting?

Personally I hacked the code so that I can lock registers I don't want
to overwrite.  I can also restore registers.  That takes away a bit of
the pressure.

There also had been a request to be able to delete register bindings,
but it had been rejected.

In any way there should be some way to allow a cleaner working with
registers.

Just my two cents.


Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 16 Oct 2023 02:04:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 15 22:04:53 2023
Received: from localhost ([127.0.0.1]:55043 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qsCyS-0001H9-Nx
	for submit <at> debbugs.gnu.org; Sun, 15 Oct 2023 22:04:53 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:42118)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rms@HIDDEN>) id 1qsCyQ-0001Fb-PH
 for 66394 <at> debbugs.gnu.org; Sun, 15 Oct 2023 22:04:51 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rms@HIDDEN>)
 id 1qsCxw-00062r-TC; Sun, 15 Oct 2023 22:04:20 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=Date:References:Subject:In-Reply-To:To:From:
 mime-version; bh=jZnln0di7/abhvMzsZi2TzEeI+M3O1eG3UIEy+pTPEQ=; b=eOKu8GRzopm8
 B4ApPwrXC88ETNqmaIo393t7HCaFYUzrv9gnGqpMC+YSIIr3RAVLlPYTnoH+FYRr+MZ2E49b8nSfm
 9KsYVMb97ty0Ivw32Us1PiQSRXmfK+eepEYoukmy9bAnelEAHJBFHtmdOSTHbqz999PPnPFFzFInB
 6LgE22En8b6CwJ3ubo/ESRKj2NgK/y80ETrsJOZZ3ORGY5VwPZl29YO+WXkqMo4d+ixlX3zm86bVh
 34rip50MNCAjnNFjCZ8zhWaeU/hzS5YC54wHcGb2IbTMKleaTQuYpr4kuOgEyiIs0Q25U7cJA1wIq
 zOvSSJVDkvhJ0twWrNrbgQ==;
Received: from rms by fencepost.gnu.org with local (Exim 4.90_1)
 (envelope-from <rms@HIDDEN>)
 id 1qsCxv-0005kj-Qy; Sun, 15 Oct 2023 22:04:20 -0400
Content-Type: text/plain; charset=Utf-8
From: Richard Stallman <rms@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <875y39oi0y.fsf@HIDDEN> (message from Thierry Volpiatto on
 Sat, 14 Oct 2023 05:59:07 +0000)
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
 <E1qrU18-0004CA-DX@HIDDEN> <875y39oi0y.fsf@HIDDEN>
Message-Id: <E1qsCxv-0005kj-Qy@HIDDEN>
Date: Sun, 15 Oct 2023 22:04:19 -0400
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: rms@HIDDEN
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

[[[ To any NSA and FBI agents reading my email: please consider    ]]]
[[[ whether defending the US Constitution against all enemies,     ]]]
[[[ foreign or domestic, requires you to follow Snowden's example. ]]]

  > I don't invite anybody to collaborate on github.
  > The code is stored there and AFAIK anybody can look at it without creating an
  > account, if any interest in this code I will provide a patch on this
  > list, what I did in previous mails without any answer BTW...

That is not as bad.  But if the code is only to look at, would it work
just as well to refer people to the code in the ELPA repo?
be an equally good place to refer people to?

Ifthat method has some drawback compared with referring to github, can
you describe the drawback?

-- 
Dr Richard Stallman (https://stallman.org)
Chief GNUisance of the GNU Project (https://gnu.org)
Founder, Free Software Foundation (https://fsf.org)
Internet Hall-of-Famer (https://internethalloffame.org)






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.
Did not alter fixed versions and reopened. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 15 Oct 2023 12:56:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 15 08:56:14 2023
Received: from localhost ([127.0.0.1]:51412 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qs0fG-0005EN-0Q
	for submit <at> debbugs.gnu.org; Sun, 15 Oct 2023 08:56:14 -0400
Received: from mail-lj1-x231.google.com ([2a00:1450:4864:20::231]:45197)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefankangas@HIDDEN>) id 1qs0fD-0005E2-E3
 for 66394 <at> debbugs.gnu.org; Sun, 15 Oct 2023 08:56:12 -0400
Received: by mail-lj1-x231.google.com with SMTP id
 38308e7fff4ca-2c50cf61f6dso23351791fa.2
 for <66394 <at> debbugs.gnu.org>; Sun, 15 Oct 2023 05:55:47 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20230601; t=1697374541; x=1697979341; darn=debbugs.gnu.org;
 h=cc:to:subject:message-id:date:mime-version:references:in-reply-to
 :from:from:to:cc:subject:date:message-id:reply-to;
 bh=KwgYTnZtBVlRpUhMs/knF3ap5tVARqs+LbUPyAK8d8A=;
 b=QVbrb+uC/Hf120RDghwcweq8P1WA/HuuDK/VJ++fBbc9B8Aadu2oVO3bCr64REQ0om
 1efZ6UTBgIhHYrJT1PqOuGPZ3rmNglMSTXZZN3sNtfuPyPD1WZtEh0Lc6xyOsJRQbwuT
 22ZAjEh9ODeuN6r5fypVtoSj8vxoLtfdhyKddwPoKu0bo2celEakl39gHquHG43+IfqA
 iknO87U+XI9X/72XY31jAhZE+W67dLrC09d42oKgA/MpVZ09EJfK98+74NiBx7flea5T
 GWOV5d9wIjD7R9wwh/juDc/S0qxv8KV0F7CC9znKJwPzcsPQF5ldHXFfGd0M8qFtuzQA
 irvA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20230601; t=1697374541; x=1697979341;
 h=cc:to:subject:message-id:date:mime-version:references:in-reply-to
 :from:x-gm-message-state:from:to:cc:subject:date:message-id:reply-to;
 bh=KwgYTnZtBVlRpUhMs/knF3ap5tVARqs+LbUPyAK8d8A=;
 b=WDeIsrDyU8NPPNjOzsZ9DQfi/EG42AiMLHIhltXBWlEC2sHOHk0vEgGCMVvUPlOIOg
 o/s0sA1UFbe3mrwQfjAa0xVn/4bQvn09gHNMfOzavioVAm+AVYBGZPNUlcmocKi++D6n
 zttUfKjh/uuf+P0IC21zQqJqh2DWMvkwQsipDbnauaPAw8CgsiptrCtMWeLq5WYabnxl
 oellLswW9XplliEp97bQqEFaX5deE3kGuxhjkVSFHVtPO9S69T57U5mXF+Dk2pffGu3k
 snk9BkcQUsCnIIBtMHVadby5c+VXkFqnrrvlbgYIlapvvw5bNX324VLn5Yyz9Is2orZj
 ZHIw==
X-Gm-Message-State: AOJu0YzNnyUhEWfQJuJEv+ZYVxdvfI7EFGk5ZzXPnfSM1smfWtxrifpq
 7+DIQvjTdFkWV5zGk/ZwJcOqeI4xj9LgulLuBZQ=
X-Google-Smtp-Source: AGHT+IF4y65iFQZ8WMXo46rvFTxDyUxU7Ed0sGXSi8jxfpYjStTJ2TBELkPbANbp4xqpS3dMvCgD5/5TulIFThpPBQE=
X-Received: by 2002:a2e:8445:0:b0:2c0:3186:8efa with SMTP id
 u5-20020a2e8445000000b002c031868efamr22329829ljh.11.1697374541092; Sun, 15
 Oct 2023 05:55:41 -0700 (PDT)
Received: from 753933720722 named unknown by gmailapi.google.com with
 HTTPREST; Sun, 15 Oct 2023 05:55:39 -0700
From: Stefan Kangas <stefankangas@HIDDEN>
In-Reply-To: <877cnojj3l.fsf@HIDDEN>
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
 <E1qrU18-0004CA-DX@HIDDEN> <87bkd0jp01.fsf@HIDDEN>
 <CADwFkmnjnZLWd2xZYSmRc54-8SBjnpGM=3nWsWChadww2jMHQQ@HIDDEN>
 <877cnojj3l.fsf@HIDDEN>
MIME-Version: 1.0
Date: Sun, 15 Oct 2023 05:55:39 -0700
Message-ID: <CADwFkmnPNXmW3OwRTH-7ozqS5Qs5oumyOKQ5Du25HmatxnOTaw@HIDDEN>
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
To: Thierry Volpiatto <thievol@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

reopen 66394
thanks

Thierry Volpiatto <thievol@HIDDEN> writes:

>> If it's fine by you, I'd like to reopen this bug report.
>
> Ok, please do.

Done, thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 15 Oct 2023 10:06:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 15 06:06:48 2023
Received: from localhost ([127.0.0.1]:51243 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qry1H-0005Uu-S0
	for submit <at> debbugs.gnu.org; Sun, 15 Oct 2023 06:06:48 -0400
Received: from mout02.posteo.de ([185.67.36.66]:37481)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qry1D-0005Ub-Hq
 for 66394 <at> debbugs.gnu.org; Sun, 15 Oct 2023 06:06:46 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 3DFDC240105
 for <66394 <at> debbugs.gnu.org>; Sun, 15 Oct 2023 12:06:13 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1697364373; bh=z8Fi0NmkZvW2EAKmYJo7KyrdE9LWBapiNSx+X/sj3Dk=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=cFa4aU7tGcC8ymNnkNaa16XFNPCf8Yr+Xa3JyU03V5qxHgAwViAC3ZiDU+69AmxB+
 uic3J28xpkJUoiG7iimqH6cR10uqKGl0+Ok/DfPHHMk1fVsZe8I5QbZvWVIH3rmcoK
 ujc4/d7U0wKWEb3ysOZUGzkkoDi5+WyoZPnHkWL2sqBSrAoT80nF7SYrP49GEo5Yfy
 7fWG13t7FWSP9ZXIxmAg01boROSiSHEwC9pW14vfFH8uSSNINA8yZA++13zyD+ntql
 KjDIhMAyBzRpnVoj0dwDkj2AKvghM+A0DmWH2zWmwnKWXf1CQ8z8RuupNgQ3C6f/z8
 szrkgnq4XGwmA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4S7bVX3jv2z6tvJ;
 Sun, 15 Oct 2023 12:06:12 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
 <E1qrU18-0004CA-DX@HIDDEN> <87bkd0jp01.fsf@HIDDEN>
 <CADwFkmnjnZLWd2xZYSmRc54-8SBjnpGM=3nWsWChadww2jMHQQ@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: Stefan Kangas <stefankangas@HIDDEN>
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
Date: Sun, 15 Oct 2023 10:05:38 +0000
In-reply-to: <CADwFkmnjnZLWd2xZYSmRc54-8SBjnpGM=3nWsWChadww2jMHQQ@HIDDEN>
Message-ID: <877cnojj3l.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Stefan Kangas <stefankangas@HIDDEN> writes:

> Thierry Volpiatto <thievol@HIDDEN> writes:
>
>> Closed for no interest in this feature.
>
> The lack of a reply doesn't mean that there is a lack of interest.  As
> for myself, I've been too busy to find the time to review it in the last
> week.  I also have many other things on my plate.
>
> In the future, please allow for, at minimum, 2-4 weeks to let people
> comment, and then feel free to ping us if you still didn't get a reply.
>
> If it's fine by you, I'd like to reopen this bug report.

Ok, please do.

Thanks.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUruY8THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk3GyC/9xAYPAs1o5DF45ziYEI7Wn5BRH6W1f
ul6+/aOsKkruZeF2CsBLJGLVA9DcTpCGBch0u+Q6SVVifWXUhPrNxmFXPTU1g7Sd
6nKB7bztC60YXD5FWbOpX57/Qgq29LTxVBBqmu4TgGgHUNZ9jaCOFE6kaDFcwOKF
Cyr6Qe8xqIckLR5fXsAZAFmbqyVdvMcjDtVB78y6Lif8p82l0tUxjfzaF/xbblh7
0dnn2w5UB6Cspho49nrMeAIRi/m3Tgre87s3imdTXTDr1dcZTVVJUImJemR59B/P
Kfr40PRsPKCo8XDiW6WxwVSz+BZWLvxf5OTImI5VY+HZ+tQa0ts5e/1y1Fv+JdK3
1uWZArBIRoWJicJ/OmZIp4A+tOz7o6WsMpWZKpuhhFdzmGOPqtsXGMp0xcQzkpT/
hInlUWMzs5m6H0fcb4i8DRh3li040YEed/FkTjUGGFH3AeeYQl0ebAllsz7YuROT
qqb8ABMqrWzAKtcxZpWyvhr2COzq56X1FFk=
=ycgP
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 15 Oct 2023 08:18:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 15 04:18:44 2023
Received: from localhost ([127.0.0.1]:51173 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qrwKh-00020j-TH
	for submit <at> debbugs.gnu.org; Sun, 15 Oct 2023 04:18:44 -0400
Received: from mail-lj1-x233.google.com ([2a00:1450:4864:20::233]:61837)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefankangas@HIDDEN>) id 1qrwKe-00020S-B2
 for 66394 <at> debbugs.gnu.org; Sun, 15 Oct 2023 04:18:42 -0400
Received: by mail-lj1-x233.google.com with SMTP id
 38308e7fff4ca-2c51388ccebso11181031fa.3
 for <66394 <at> debbugs.gnu.org>; Sun, 15 Oct 2023 01:18:16 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20230601; t=1697357889; x=1697962689; darn=debbugs.gnu.org;
 h=to:subject:message-id:date:mime-version:references:in-reply-to:from
 :from:to:cc:subject:date:message-id:reply-to;
 bh=4KLrC0GnihPOluYkNErFlqsWCB9mYBtJZWZQVEYNTLw=;
 b=BpnM2PUtWRaj09pPV60JfFyabAT9ysaf/AE1m/2YhcyKq68SnlUiKOsB0an7+FiGq4
 2Noo1UwO5My3VCJASA9y9XU+yhyD6RsOB8Vjv09dYw8dgponUwsgwUXI6MGG6nOof3v9
 gPHl9w7OuN1/48gYi8cqk1xwHqPreEOZAikcogd4s6gJls478JlR9ZSnEaPDqupJ4UBK
 WtnkE+FLGPdtIPMhkow9c8aepi4BIUFrT+oJv2MSCTpu4X6Uhcjyqfu+LMyJoZ97hZa0
 epQl9FJ7+PQjciaNWE+/1hNcphTuy5HXR572OtlYUDDtXUNtj3DW/xvUYvwODXxugn9k
 vS1Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20230601; t=1697357889; x=1697962689;
 h=to:subject:message-id:date:mime-version:references:in-reply-to:from
 :x-gm-message-state:from:to:cc:subject:date:message-id:reply-to;
 bh=4KLrC0GnihPOluYkNErFlqsWCB9mYBtJZWZQVEYNTLw=;
 b=ajFGbwSfOkG8/jgG4yJlG1giDscB5feO50rH+qkICxEuhQp5bkHw/HpL+joNjngmuF
 fvf5EOVgYhCH8aYz26polZ255a/AQkU1ZLSzToqc34/sbKljLd0S63a2tWFRNp3tWrcO
 AKds2iKmD3D6rHmc/C5BPNJxYSfR8gbJ6juV02f4Ct3gaVvBmmge9Fc/8XBDmw3H37hr
 NJzXlecDnDxtr/AxJxhdNJKK59g/sJyuVAoGgLktIfuZoSoNgvn5/xxTDXQEssqAPbue
 3NJ1LJlsNG4mn06cCmquLCSsHcvxfyOtUM3h80FxykiUeAi/yNJs2wgr25eRxELceTAe
 gH1g==
X-Gm-Message-State: AOJu0YzSIqRp1NHmhwrxq+l9MdeG/uFtZy8Gh5CLudmPFgvz9/4rGB3o
 dQy0SaL3aALLgmtKmn5t04gkhliwEPgjusc9x8A=
X-Google-Smtp-Source: AGHT+IG21WBHJXg82nlCFQQaQKWQoBHwYP6+6dGZCA0tYdn5FZy8/YFclWY7tRBJFASgUrjdORUnBfNFAxHDmjvdzeM=
X-Received: by 2002:a05:651c:220e:b0:2c4:feef:64ee with SMTP id
 y14-20020a05651c220e00b002c4feef64eemr5982578ljq.50.1697357889430; Sun, 15
 Oct 2023 01:18:09 -0700 (PDT)
Received: from 753933720722 named unknown by gmailapi.google.com with
 HTTPREST; Sun, 15 Oct 2023 01:18:08 -0700
From: Stefan Kangas <stefankangas@HIDDEN>
In-Reply-To: <87bkd0jp01.fsf@HIDDEN>
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
 <E1qrU18-0004CA-DX@HIDDEN> <87bkd0jp01.fsf@HIDDEN>
MIME-Version: 1.0
Date: Sun, 15 Oct 2023 01:18:08 -0700
Message-ID: <CADwFkmnjnZLWd2xZYSmRc54-8SBjnpGM=3nWsWChadww2jMHQQ@HIDDEN>
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
To: Thierry Volpiatto <thievol@HIDDEN>, 66394 <at> debbugs.gnu.org
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 66394
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Thierry Volpiatto <thievol@HIDDEN> writes:

> Closed for no interest in this feature.

The lack of a reply doesn't mean that there is a lack of interest.  As
for myself, I've been too busy to find the time to review it in the last
week.  I also have many other things on my plate.

In the future, please allow for, at minimum, 2-4 weeks to let people
comment, and then feel free to ping us if you still didn't get a reply.

If it's fine by you, I'd like to reopen this bug report.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394-done <at> debbugs.gnu.org:


Received: (at 66394-done) by debbugs.gnu.org; 15 Oct 2023 07:59:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 15 03:59:17 2023
Received: from localhost ([127.0.0.1]:51161 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qrw1s-0001SD-SF
	for submit <at> debbugs.gnu.org; Sun, 15 Oct 2023 03:59:17 -0400
Received: from mout02.posteo.de ([185.67.36.66]:46155)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qrw1q-0001Rw-FX
 for 66394-done <at> debbugs.gnu.org; Sun, 15 Oct 2023 03:59:15 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 3D669240101
 for <66394-done <at> debbugs.gnu.org>; Sun, 15 Oct 2023 09:58:44 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1697356724; bh=Sho1qnaiE4AUN5/T2EN8m9bABtDeueNh8jSGCucXXS4=;
 h=From:To:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=pAbfCbfVEkMvGxjH8Vx9zQCBlUkDGrNMcgtD2Qd106epb8ZQSwW3qgScmzJw9Gq4W
 MkjMaOlNi8pfKs4DsnKRVV0k0YRoAb+caqEmKoGeoGJm0zFFrN7PqHO35Zb3nCqhj6
 m0LgQ4BmjznWw2JN8TD4Go0hON6ZXUJy4NXCD/i2K2sYv0SQuUbI0c/DRdKYv/D0eK
 oG5npC6WPMw8jIpnTj0hGIfCeWgbaW6h1XzjuY902KdyUSTeOZ52N/4JjoH5QGDqi6
 rkNCPk0sRQuk5Oa7pz22eHpcxM2EqqTv4TYOryyCdmFI3+J/Fe168m9DiGm1VXhR/f
 u88RE2A+5XSqA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4S7XgR4dKTz9rxR
 for <66394-done <at> debbugs.gnu.org>; Sun, 15 Oct 2023 09:58:43 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
 <E1qrU18-0004CA-DX@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: 66394-done <at> debbugs.gnu.org
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
Date: Sun, 15 Oct 2023 07:56:35 +0000
In-reply-to: <E1qrU18-0004CA-DX@HIDDEN>
Message-ID: <87bkd0jp01.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394-done
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Closed for no interest in this feature.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUrm64THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvk/AIC/wLex+xVuruzzmst4kVSR3ADr64xfhx
xmF9fkzEoLnO1TkB/eYO+SsS/uYUrTcQya9MXZ9C+CSeH9u10xFMiedEeyor7RzY
3bKfHTL7sv1/6X6hwphh3dcHuc/YeYu53YWvoSAPsnnIDOhXofuYdvBOKU75afkz
3xJ/qal74kUHvObWwlB0k3ajx0ktvB912oE2hbsUsQwDkx4NCWVJ4JN0RpXB3KsM
uEAQ7v22tURdgAl99kwQVkoUCrL++hQVkt9ViHv0kDURLZ+ItS7nC/57ZYEr8IAq
JHBq8XCiTfc6n71Mr7DmKliV7pqYznimcpy2OYzWhZDpVP7PfTEQ9yfZGUB4MoZO
NAznkm397sOfqtqABM0Ndy0FekmqCyr+FL21lS2oc6RHTJEyR50qR6K1VX5B6URm
PxC4ozN4sGv3k1lyoEqXBn4zfjXWqQA/vzRJO6bgfHFa9pJa8gH+6rCUqyVqfUXS
x2JVpZKFVsfJJMemaK+MtvvkHuHtMBCt4Og=
=h5t3
-----END PGP SIGNATURE-----
--=-=-=--




Notification sent to Thierry Volpiatto <thievol@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Thierry Volpiatto <thievol@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 14 Oct 2023 06:06:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 14 02:06:31 2023
Received: from localhost ([127.0.0.1]:47681 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qrXnD-0002Li-2H
	for submit <at> debbugs.gnu.org; Sat, 14 Oct 2023 02:06:31 -0400
Received: from mout01.posteo.de ([185.67.36.65]:40627)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qrXn8-0002LT-6y
 for 66394 <at> debbugs.gnu.org; Sat, 14 Oct 2023 02:06:30 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id DA0EB240027
 for <66394 <at> debbugs.gnu.org>; Sat, 14 Oct 2023 08:05:56 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1697263556; bh=hKzbybdMyz3kcZmV5COhus4oa6rvf0fU9s0Marjurxg=;
 h=From:To:Cc:Subject:Date:Message-ID:MIME-Version:From;
 b=llhZ9x64AqS2e/9UHwJaXC3HtqBZUK3Rd3NLkEwoGr2EXFPdkd4RXT9AwEBWj/jRH
 qgXOU2sgeKaP1NzonZAHfeX3aKm/SLrmqVUtdOV6xB/2dvvFyFhwoXLXPuRgWB5irm
 oU5YS8eL1meZdeUXO+0ngYqrINVFlROOtQRhkI+KVdRETGTpD58k4cV59qz/QkfXVU
 Z+xTLYy8uiYz+tZOEGpETlyO3Ols4Bzm5/RqLPov3faGoxBEsY+VtyNEl8DVAARmXp
 3SULj02IKn4GMTDN/lII4AdJeM+vpFMrjzAJt5n6fIHj6xEOaoiczfG4E8gsucKzh0
 64wuaAA6t1ydA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4S6tCm09VYz9rxP;
 Sat, 14 Oct 2023 08:05:55 +0200 (CEST)
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
 <E1qrU18-0004CA-DX@HIDDEN>
From: Thierry Volpiatto <thievol@HIDDEN>
To: rms@HIDDEN
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
Date: Sat, 14 Oct 2023 05:59:07 +0000
In-reply-to: <E1qrU18-0004CA-DX@HIDDEN>
Message-ID: <875y39oi0y.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Richard Stallman <rms@HIDDEN> writes:

> Thanks for inviting people to work with you on improving this code.
> But please don't use github as the place to host your free software --
> especially not if it relates to GNU.
>
> Github requires a person to run nonfree software simply to make an
> account; so if you invite people to collaborate with you on that
> platform, indirectly that asks people to run nonfree software.

I don't invite anybody to collaborate on github.
The code is stored there and AFAIK anybody can look at it without creating =
an
account, if any interest in this code I will provide a patch on this
list, what I did in previous mails without any answer BTW...

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUqL70THHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkzJ3C/9fUBlDRmryCNwB5nDpKSJ1WZNwwJmw
WcZ2QKkVoQl2KZ2R2KDQtLrcXm9tTsVIWg2eWYgc8a/GZ1sPNn0x4H5ohGG+QGWy
dmjrIF3tOdga2gsOwTiknZWN8UMIAx2iw4zDnLeHRFAD5yiWxh0QNYIYoyVbnf/L
qBRPDZnjtW7zBvPhGc6glOL7V8hfPp45QZA/ozh4japl/aUYjqQN2hnOzH8CwAMH
obOrTxjKru2jYqIVwwUiXCsHUxpaVAvXZ7wlAiNPji+uXIyebMYIbfCr2O2hXnSJ
38R6cufYe7pmW8mKUYxUcjnw9sTZ2ZcFUE/2PDjt1J7UpDiCrEakayL67B+0UrCp
J0IypwiLf2XFH0tmTf2OJoFWDPOOVaLWecCtE1P/sjWMYDDDt/0xp9NMV+g2Hotz
axQrFAnW33+z6SPbxlc61nNQL5JS6p0LiTnr6mHRLGrs5e+RBWYuaP8OLdEL3kxq
Pw1KnJzXJaMHOy7x6bijxkkvAGlGGusiZKQ=
=fApv
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 14 Oct 2023 02:05:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 13 22:05:11 2023
Received: from localhost ([127.0.0.1]:47628 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qrU1f-0002I6-Ci
	for submit <at> debbugs.gnu.org; Fri, 13 Oct 2023 22:05:11 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:40014)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rms@HIDDEN>) id 1qrU1d-0002Hq-Id
 for 66394 <at> debbugs.gnu.org; Fri, 13 Oct 2023 22:05:10 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rms@HIDDEN>)
 id 1qrU19-0007Ae-FL; Fri, 13 Oct 2023 22:04:39 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=Date:References:Subject:In-Reply-To:To:From:
 mime-version; bh=Fb29qp8a38nw2poS5GS7yMmMkBsUlT8K3enz6zC1rEk=; b=r/H4Li1IXLJs
 4tzpgDplX7tQC9YQEbv7EvgzIQVD7dvAEB8qesvkPkdaVIS9nx3LTMZB4wX6rj/wUdKVdaxQbGeA9
 2qf9zdXaK3yNfiKB7zmERkhyuBo6WO2W4MMYlEtVBAEnM8mXpI928Cpq6tpf218yWIpAw9IVitSWV
 Ri2oRSsoThgjhtGY7pTCjbw24JsSJOhBgxdrzLMmcejQTQF8/TCnMlygTL5U5MFCKau2MVPjYtDAG
 Djqe0UuoHQr/OnnMw0NMuQzTM/kFjALMg8SOUNgRcngps3lckzixaJ41Tf4Sj5FgEllL0B/8q6EZH
 meCdIEl/1JJ4h8E47ZrLpg==;
Received: from rms by fencepost.gnu.org with local (Exim 4.90_1)
 (envelope-from <rms@HIDDEN>)
 id 1qrU18-0004CA-DX; Fri, 13 Oct 2023 22:04:38 -0400
Content-Type: text/plain; charset=Utf-8
From: Richard Stallman <rms@HIDDEN>
To: Thierry Volpiatto <thievol@HIDDEN>
In-Reply-To: <871qe02uyw.fsf@HIDDEN> (message from Thierry Volpiatto on
 Thu, 12 Oct 2023 06:43:55 +0000)
Subject: Re: bug#66394: [RE] Make register-read-with-preview more useful
References: <87il7ib6cu.fsf@HIDDEN> <871qe02uyw.fsf@HIDDEN>
Message-Id: <E1qrU18-0004CA-DX@HIDDEN>
Date: Fri, 13 Oct 2023 22:04:38 -0400
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
Cc: 66394 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: rms@HIDDEN
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

[[[ To any NSA and FBI agents reading my email: please consider    ]]]
[[[ whether defending the US Constitution against all enemies,     ]]]
[[[ foreign or domestic, requires you to follow Snowden's example. ]]]

Thanks for inviting people to work with you on improving this code.
But please don't use github as the place to host your free software --
especially not if it relates to GNU.

Github requires a person to run nonfree software simply to make an
account; so if you invite people to collaborate with you on that
platform, indirectly that asks people to run nonfree software.

See https://www.gnu.org/software/repo-criteria-evaluation.html.


-- 
Dr Richard Stallman (https://stallman.org)
Chief GNUisance of the GNU Project (https://gnu.org)
Founder, Free Software Foundation (https://fsf.org)
Internet Hall-of-Famer (https://internethalloffame.org)






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 12 Oct 2023 06:53:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 12 02:53:18 2023
Received: from localhost ([127.0.0.1]:40481 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qqpZO-0006vK-B2
	for submit <at> debbugs.gnu.org; Thu, 12 Oct 2023 02:53:18 -0400
Received: from mout02.posteo.de ([185.67.36.66]:39839)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qqpZL-0006v5-Cm
 for 66394 <at> debbugs.gnu.org; Thu, 12 Oct 2023 02:53:16 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id AA6AA240104
 for <66394 <at> debbugs.gnu.org>; Thu, 12 Oct 2023 08:52:46 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1697093566; bh=v/pygO3CdNQpwqdpxayCqQ44ZcywvXmEMFa3B636vNU=;
 h=From:To:Subject:Date:Message-ID:MIME-Version:From;
 b=CzZTfdNFdAR9zK0pGByYel6Rwz3JrmnFFnAEq2zmi2hgoMtHMsRskU/QnlcpytadD
 ++qQymdMAUvUET0NrC4oSem/aV+bJsKV8WlUuQ0uTm1pXz37PQH11etISjsbk1A0QT
 Q7acCEa74wfLSrNeHBgiKyrxSTxuinaMwK2TFxKaGmpvh2Xet6alXzrEk6KtCuvEmr
 1iXapYgk+7oO2scUJ+fjg2IUrVAZx0w6gUHhlrzwoqybVxJI3iyg9p70qjK7FrSItI
 jWRv27Yoly2XQPTkVlI0K7BrXNuQkmXgUZlskQVF4GTp5EYLRPOkKEr4fkGrWz1mu1
 YuNCxw+4c9FvA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4S5gLj5C05z6txf
 for <66394 <at> debbugs.gnu.org>; Thu, 12 Oct 2023 08:52:45 +0200 (CEST)
From: Thierry Volpiatto <thievol@HIDDEN>
To: 66394 <at> debbugs.gnu.org
Subject: [RE] Make register-read-with-preview more useful
Date: Thu, 12 Oct 2023 06:43:55 +0000
Message-ID: <871qe02uyw.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


I moved the code here if any interest.
https://gist.github.com/thierryvolpiatto/2219f99ac96ed1b468fac204bca23b4a

I added filters to register-preview (jump-to-register should show
only positions and insert-register should show only text).
Also added navigation (up and down) in preview buffer (see gif).

Still need to modify (or add) docstrings and also decide what to do with
`register-preview-delay` (just a flag in this patch).
AFAIU the only reason to delay preview is when executing kbd macro, in
this case we could use executing-kbd-macro, but maybe I miss something
and there is other reasons to delay this.

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUnl7cTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkzHXDACWPu93kl7KCjvDBPIrvl86LfMP2CkK
Hs7KHe4VwrEYHW/4yIcBqef3qMoS26jqzOykyNgZsvMgPNbQnfy2Hc02heHMWUCP
MDhz3dL4iNB8WIy1I9QB5DpiAE+hc/aHxIqR0N9Q0XWh+ZQXhLJYMU32UBC2Afha
S4W6IMkMTfqar6t310oH127lZy+J5pwSIy45nWecpZKw/xh7SPk861oyz1WycfqT
WlFJSRF7rfSgUXSHbP+wNf9XE9jDlv7uAuAntIAM1Y9tAOakHKJ+UxAJsAJhlqCP
cUWJgpQHcdbwcngG0GxX/FuTvgMpzM47U3SIotHHsodtgGsVevlfqv43VMtExyQl
qDlJRDwQMtVLtFox95grWgdZVjs2+WZlQDFNs/rpn5ttnlP2sWKfoQVjjfQ0IWIq
wKRF39uCaq/pPqNiDdjZ6oejp7sYX3A/UpZfSfZ3s0u8qFlNmE1IBbdpMs7hyE6y
N+IkH4Z0j1Ct4mlSLvt/4/eSYeQX+b9my0E=
=3CGz
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at 66394 <at> debbugs.gnu.org:


Received: (at 66394) by debbugs.gnu.org; 8 Oct 2023 06:49:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 08 02:49:51 2023
Received: from localhost ([127.0.0.1]:56172 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qpNbq-0007lW-M5
	for submit <at> debbugs.gnu.org; Sun, 08 Oct 2023 02:49:51 -0400
Received: from mout02.posteo.de ([185.67.36.66]:59067)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qpNbn-0007lF-El
 for 66394 <at> debbugs.gnu.org; Sun, 08 Oct 2023 02:49:48 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout02.posteo.de (Postfix) with ESMTPS id 2ADF0240101
 for <66394 <at> debbugs.gnu.org>; Sun,  8 Oct 2023 08:49:21 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1696747761; bh=pIcqiZUYPavDHCgdcEP+QFKdqtPgfmNpvvtjrcEIbCM=;
 h=From:To:Subject:Date:Message-ID:MIME-Version:Autocrypt:OpenPGP:
 From;
 b=rb8eyO6a7GwbEjbnfD2MVvDLDWjRKeBY5oJqcORLmtENV9MzFEBlCQ0B6rFjp5voh
 R0+WwjkgfXihmKxD6ebvO+a37hxB9VpUB1OvP6OhlLSICiBZx3o/9W3h/kvaRfY1sm
 i39ms2/g1EMqiuzBpCP7gUBTKkLU0ElM+kAZ6oVUNrLbCTU4sy8WAHWgVgUW/7e1T/
 yRVQ5uB1lSFH8jEqPGtLGr3vS1QXr8wDA47RobOTaB2sVNR5sT2uHZDd9bDaaJ0Fjq
 +ncJD5DDj7OOkSfFW+0Gs89A2kF/SanJyFVIPC3Kpo8r7fu1K4cdAqoCUejvXvvChW
 7YyUXK4v3OfLA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4S3CSc2pFbz9rxH
 for <66394 <at> debbugs.gnu.org>; Sun,  8 Oct 2023 08:49:20 +0200 (CEST)
From: Thierry Volpiatto <thievol@HIDDEN>
To: 66394 <at> debbugs.gnu.org
Subject: [RE] Make register-read-with-preview more useful
Date: Sun, 08 Oct 2023 06:45:11 +0000
Message-ID: <874jj1obh2.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 66394
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


Here a modified version of the patch that fix the face, send an error
when exiting with empty prompt and prevent adding more than one char in
prompt.
From=20this code, it is now easy to modify the behavior as needed (ideas we=
lcome).

diff --git a/lisp/register.el b/lisp/register.el
index ca6de450993..47645098e6d 100644
=2D-- a/lisp/register.el
+++ b/lisp/register.el
@@ -154,27 +154,45 @@ listing existing registers after `register-preview-de=
lay' seconds.
 If `help-char' (or a member of `help-event-list') is pressed,
 display such a window regardless."
   (let* ((buffer "*Register Preview*")
=2D	 (timer (when (numberp register-preview-delay)
=2D		  (run-with-timer register-preview-delay nil
=2D				  (lambda ()
=2D				    (unless (get-buffer-window buffer)
=2D				      (register-preview buffer))))))
=2D	 (help-chars (cl-loop for c in (cons help-char help-event-list)
=2D			      when (not (get-register c))
=2D			      collect c)))
+         (pat "")
+         result timer)
+    (register-preview buffer)
     (unwind-protect
=2D	(progn
=2D	  (while (memq (read-key (propertize prompt 'face 'minibuffer-prompt))
=2D		       help-chars)
=2D	    (unless (get-buffer-window buffer)
=2D	      (register-preview buffer 'show-empty)))
=2D          (when (or (eq ?\C-g last-input-event)
=2D                    (eq 'escape last-input-event)
=2D                    (eq ?\C-\[ last-input-event))
=2D            (keyboard-quit))
=2D	  (if (characterp last-input-event) last-input-event
=2D	    (error "Non-character input-event")))
=2D      (and (timerp timer) (cancel-timer timer))
+         (progn
+           (minibuffer-with-setup-hook
+               (lambda ()
+                 (setq timer
+                       (run-with-idle-timer
+                        0.3 'repeat
+                        (lambda ()
+                          (with-selected-window (minibuffer-window)
+                            (setq minibuffer-scroll-window
+                                  (get-buffer-window buffer))
+                            (let ((input (minibuffer-contents)))
+                              (when (> (length input) 1)
+                                (setq input (substring input 0 1))
+                                (delete-minibuffer-contents)
+                                (insert input))
+                              (when (not (string=3D input pat))
+                                (setq pat input))))
+                          (with-current-buffer buffer
+                            (let ((ov (make-overlay (point-min) (point-min=
))))
+                              (goto-char (point-min))
+                              (if (string=3D pat "")
+                                  (remove-overlays)
+                                (if (re-search-forward (concat "^" pat) ni=
l t)
+                                    (progn (move-overlay
+                                            ov
+                                            (match-beginning 0) (match-end=
 0))
+                                           (overlay-put ov 'face 'match))
+                                  (with-selected-window (minibuffer-window)
+                                    (minibuffer-message
+                                     "Register `%s' is available" pat)))))=
)))))
+             (setq result (read-from-minibuffer prompt)))
+           (cl-assert (and result (not (string=3D result "")))
+                      nil "No register specified")
+           (string-to-char result))
+      (when timer (cancel-timer timer))
       (let ((w (get-buffer-window buffer)))
         (and (window-live-p w) (delete-window w)))
       (and (get-buffer buffer) (kill-buffer buffer)))))

=2D-=20
Thierry

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHHBAEBCgAxFiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmUiUOoTHHRoaWV2b2xA
cG9zdGVvLm5ldAAKCRAOxW0UHRbvkwV2DACyC6jppr3YWyfOZmMRonIlUWloy9Ox
xJ1uQHZWFaD8GP+TPOg64kns7051J882HMe+M9kd+WriRAE7+P4LR4IXG4YKDmvR
c8+w8OG3PzH7XWsPDWrDXubGTFNgHA26Lz71YoIRq35OBD0TQow4aFUtraBO/Vzy
AqijAZ88ka2ZqQPxZK6gh4kxtWyw7gY3f6XPrJq1S4ZNQLcSZAMCIP+BDD1iyFgB
UKLYr6wrEF2tlAgFJa9dgCJv8GzkYMKgySX5tVG0lDVL2oAitolj3YP01fe2if61
OcMa0z9QWMgjpCCIh5gd0l5+hhZrwG+4wOOSlVph1KN65cEuLK5K2Q/FakruNL2w
PtR1DQDr+G5/NCI4I9Yu4cJBOm8aY5qH5t/KZ2D8djG4pgjHN1+fAXJfj4PbFOcB
hFuihDTI9JVmOw+ZqT+vyKePwv1ABSLoTU41j3DQRUDkFI8Gjhq3eSQyjpUfas5Q
nS9UD9uwW00bx0DjwtCz1uq46zbt6wr4V7o=
=PAiw
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 7 Oct 2023 19:06:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 07 15:06:39 2023
Received: from localhost ([127.0.0.1]:55935 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qpCdK-000365-RC
	for submit <at> debbugs.gnu.org; Sat, 07 Oct 2023 15:06:39 -0400
Received: from lists.gnu.org ([2001:470:142::17]:55012)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thievol@HIDDEN>) id 1qpCdH-00035q-Ud
 for submit <at> debbugs.gnu.org; Sat, 07 Oct 2023 15:06:36 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <thievol@HIDDEN>)
 id 1qpCcr-00024s-N1
 for bug-gnu-emacs@HIDDEN; Sat, 07 Oct 2023 15:06:09 -0400
Received: from mout01.posteo.de ([185.67.36.65])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <thievol@HIDDEN>)
 id 1qpCco-0000aV-P5
 for bug-gnu-emacs@HIDDEN; Sat, 07 Oct 2023 15:06:09 -0400
Received: from submission (posteo.de [185.67.36.169]) 
 by mout01.posteo.de (Postfix) with ESMTPS id C5C36240028
 for <bug-gnu-emacs@HIDDEN>; Sat,  7 Oct 2023 21:05:59 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1696705559; bh=3hHDo4sn0dOBHplr0XOuKtFgsBRfUedjmc4xjtcckHU=;
 h=From:To:Subject:Date:Message-ID:MIME-Version:
 Content-Transfer-Encoding:Autocrypt:OpenPGP:From;
 b=T/cRjLm+9KH4SSnJTJlswJUn/NE8Nvcj5GZmWRJTLPI3Iq0sVnO6xTcpK4JBeQawv
 D3fvTMRryzRasr5Wl2xiP9uZwyQNkzBFuVPyBjwK7v2tsoqQIntbrc9x/NcLCi37tu
 6UxQ/xHpNfK1EUA7Q8F7B21ItFS7zj2VlA5gMham4NwjEl0Kq9MAr8K5Nwi9x3Mgh1
 NGGdk+xaHDWrtPQIy5zZfUZu6B+FCvAxa/Y24Ur78QY/m6+z5+I/KSbFZAGxJPETIG
 GDGmdjbNU4mEUlarTQvUiPK+diL4aKYUj6wrPBul577UEj6rCMKXi4dnvL6f7HApEY
 J5pr8bFf/NWsQ==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 4S2vs306Nsz9rxB
 for <bug-gnu-emacs@HIDDEN>; Sat,  7 Oct 2023 21:05:58 +0200 (CEST)
From: Thierry Volpiatto <thievol@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 29.1; Make register-read-with-preview more useful
Date: Sat, 07 Oct 2023 19:03:47 +0000
Message-ID: <87il7ib6cu.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Autocrypt: addr=thievol@HIDDEN; prefer-encrypt=mutual;
 keydata=xsDNBF8ylcIBDADG+hy+zR6L4/vbdDDZuSaMmSrU3A5QZJpeBCvxTr7MpzzruZbhLPW1K3R6N2MA
 edi8Y+C8o27FVRIjpdbaKMGu9je7JV/TbUQYo3SOwCK1vM4LUn4V6ZLzSYkuiEt4eyMoiDdyvN0p
 kcK6P9x9DCetcEVszXzQg+yzCVrQ2hXWDXWT4M18EC3wtO7RHPouMqGiwBFhBAYErCqFWFxQHkfb
 tG/4yGyJ58rglb65O3qijjMWvYwcWZun9/7qm8Z4/4mHopmo2zgU+OrptnLSZfkZGz3Y7Uf452xQ
 GVq0Fv75NPvQru7y+DYVhuVXXyAmGxt+vf4rIiixMBbhKEPjcxEPAa2LTzex2IsTZR+QVG9uDnqC
 WcgaOEQ58fzXNvNhtwwF/Rgio2XWAJVdmFWS59/k9W58CIUSNKBMZh2XeGdEmtHvDtCxW3z6FJha
 36RzOM3fMNNiAGdFZJA84gcdloJR+sHCDTTPT3784fjr+V8An7sI581NGFzkRQqPvEQCZbUAEQEA
 Ac0SdGhpZXZvbEBwb3N0ZW8ubmV0wsEOBBMBCgA4AhsDBQsJCAcCBhUKCQgLAgQWAgMBAh4BAheA
 FiEEI9twfRN7r3nig/xwDsVtFB0W75MFAmL3HCoACgkQDsVtFB0W75OVEAv/f6XxmtIFz08fUb8h
 Bp/zJP6IC4/rhhh+0GMRIRzLN8DK0jV8JCzYdFHiRJOy2lNIOpmrrCmjRRxferc2G42+ePFIsslx
 hU46VSz1Z83NwIG3mpdYNV5WUTUdgzxExHTNTFCd7NKv0nlHKQaAtdXm5bYnSHsnL7cx8z7lukA/
 EsJocE+GD7QXnsrdlicvdobI0TEN4l73221a72oCvHfYLCVsB6YsNJ5ZGkA1zSjzln5uLAgZ/2r/
 aqlao/AlSZkAk6+hvK0RyAZ/YR4YRZxO8Fsd0gWgFkanRfKfufJ1V0OHZg7yszi3q/hRzS+rZtJ0
 OuzDlh/dyQkxVkZb9vis/+HnGDJrBE5MsmJLcy2Sy3uUnio0fq8q9CrZbudvd1DajlZxPzTm0csP
 eUk45QEgbhEU7MfyAX/mkKxjHajz2cMcHKIap1BqEgJl4BKFeLMcBZ4O1p9ivwtf1Ht2JTp5lOi0
 ItPfhQ4DP8LZ1ZIkN5Kg9v0cyw9meRzAuuR0V2GtzsDNBF8ylcIBDADnIDHEkmk4lUwTlOhwb2yj
 UfmGPnpH3MCCHkjM9H/P1gTHxFWtwFVPcNMCwXWvKSBTF2dZXKERD0yzG06zT53ZMN7EIIeuY6m4
 R8IcMvpohciisWxbFoB4ZY117tVSeqjo946itgbpdeESKl9a8dpn7ytZMyYxPdojlQAqxeAJ8444
 raESh1oTKXb64hlk4l2pSRlrLgjpJBo8asAfZndaxIUKhw68tV8sqeZh9P6cGtHbUELKVJqefNV7
 V7jF5wf3xvRG6Ces3kSKXalLfs+vrVaoOjQeWrc0AtwFWHmt9JLfKrqF+Q2Q7jUidboWmazQM56E
 SJFPpPHmWq8k6DHspsFHOforLouTHJL1556IPne7IV2BGfWc0+xLxalZ8F5F+vnPF/OkrC1CD5iC
 KTjXKa2iZbcYdYQAiL6P8Ac8CgN6EkhpbxRtzrEgChuNGevdi/G/GHG4Zqrh6YFwIa/NHq2aVaFq
 5C1yNTMJd1FRjRzs5JPPlJKpYDnNx+MSp7UAEQEAAcLA9gQYAQoAIAIbDBYhBCPbcH0Te6954oP8
 cA7FbRQdFu+TBQJi9x1ZAAoJEA7FbRQdFu+To6QMAIcvUSiFwCIggxkmYy3ZY0QAMLmIPga8DNPM
 XbfSOBDb2KLGBd+FAA8p2GExpul4r6kOYnGogtojByHmVgrd30/3ZURTM8Vj51wwD05viMZccQHl
 Wd9J/qZIvhBJlJWYnwVxh+2Kg4/hkx7SGc7JJS5GS37+PFQOJHPGMxc+fe4Ty2FdjIOVf3P1Hov9
 K6yBI7Af66qqcL3aKJ4jJidRYN8sMaKOqEu4rcSpTxp8/3Ddbs9HezUgXeUzOLJMcEYFlvCyC8ZS
 l/QDZmpobKbxZ1JAqZM8lnmcZYSV7OsWnxJIYDV1gH5LTLj7bGswXaB4B+qkckihWkRZixu8q1IK
 0c/xwUzyF092uFRM/sQKrSmnwA1+hQiiIuEl4XVz5li0/TmMta3ijUM7GNbl2IjioTRxWWecwad1
 mNHvKTcXPsKDAbHFdLvQzurnroBHQV0jSPNLTP5Suo7RnLbehfg5INpGjToCUlrd2qQqgXW7h5qZ
 TgUq5UmBc7YZ0JYWQgPTbQ==
OpenPGP: url=https://posteo.de/keys/thievol@HIDDEN; preference=encrypt
Received-SPF: pass client-ip=185.67.36.65; envelope-from=thievol@HIDDEN;
 helo=mout01.posteo.de
X-Spam_score_int: -43
X-Spam_score: -4.4
X-Spam_bar: ----
X-Spam_report: (-4.4 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_MED=-2.3, RCVD_IN_MSPIKE_H5=0.001, RCVD_IN_MSPIKE_WL=0.001,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)


When using `copy-to-register`, it is hard to see which register is
already taken in the preview buffer.
This patch highlight the register entered at prompt if it is already
taken otherwise a minibuffer message is sent to notify user the register
is available.
If any interest here is the patch, feel free to modify if needed.
Thanks.

diff --git a/lisp/register.el b/lisp/register.el
index ca6de450993..4c83264d4eb 100644
--- a/lisp/register.el
+++ b/lisp/register.el
@@ -154,27 +154,37 @@ listing existing registers after `register-preview-de=
lay' seconds.
 If `help-char' (or a member of `help-event-list') is pressed,
 display such a window regardless."
   (let* ((buffer "*Register Preview*")
-	 (timer (when (numberp register-preview-delay)
-		  (run-with-timer register-preview-delay nil
-				  (lambda ()
-				    (unless (get-buffer-window buffer)
-				      (register-preview buffer))))))
-	 (help-chars (cl-loop for c in (cons help-char help-event-list)
-			      when (not (get-register c))
-			      collect c)))
+         (pat "")
+         result timer)
+    (register-preview buffer)
     (unwind-protect
-	(progn
-	  (while (memq (read-key (propertize prompt 'face 'minibuffer-prompt))
-		       help-chars)
-	    (unless (get-buffer-window buffer)
-	      (register-preview buffer 'show-empty)))
-          (when (or (eq ?\C-g last-input-event)
-                    (eq 'escape last-input-event)
-                    (eq ?\C-\[ last-input-event))
-            (keyboard-quit))
-	  (if (characterp last-input-event) last-input-event
-	    (error "Non-character input-event")))
-      (and (timerp timer) (cancel-timer timer))
+         (progn
+           (minibuffer-with-setup-hook
+               (lambda ()
+                 (setq timer
+                       (run-with-idle-timer
+                        0.3 'repeat
+                        (lambda ()
+                          (with-selected-window (minibuffer-window)
+                            (let ((input (minibuffer-contents)))
+                              (when (not (string=3D input pat))
+                                (setq pat input))))
+                          (with-current-buffer buffer
+                            (let ((ov (make-overlay (point-min) (point-min=
))))
+                              (goto-char (point-min))
+                              (if (string=3D pat "")
+                                  (remove-overlays)
+                                (if (re-search-forward (concat "^" pat) ni=
l t)
+                                    (progn (move-overlay
+                                            ov
+                                            (match-beginning 0) (match-end=
 0))
+                                           (overlay-put ov 'face 'helm-mat=
ch))
+                                  (with-selected-window (minibuffer-window)
+                                    (minibuffer-message
+                                     "Register `%s' is available" pat)))))=
)))))
+             (setq result (read-from-minibuffer prompt)))
+           (string-to-char result))
+      (when timer (cancel-timer timer))
       (let ((w (get-buffer-window buffer)))
         (and (window-live-p w) (delete-window w)))
       (and (get-buffer buffer) (kill-buffer buffer)))))



In GNU Emacs 29.1 (build 1, x86_64-pc-linux-gnu, X toolkit, cairo
version 1.16.0, Xaw3d scroll bars) of 2023-10-01 built on IPad-S340
Windowing system distributor 'The X.Org Foundation', version 11.0.12101004
System Description: Linux Mint 21.2

Configured using:
 'configure CFLAGS=3D-O8 --bindir=3D/usr/local/sbin/emacs-29.1 --with-cairo
--with-x-toolkit=3Dlucid --with-modules --without-tree-sitter
--without-native-compilation'

Configured features:
ACL CAIRO DBUS FREETYPE GIF GLIB GMP GNUTLS GPM GSETTINGS HARFBUZZ JPEG
JSON LCMS2 LIBOTF LIBSELINUX LIBSYSTEMD LIBXML2 M17N_FLT MODULES NOTIFY
INOTIFY PDUMPER PNG RSVG SECCOMP SOUND THREADS TIFF TOOLKIT_SCROLL_BARS
X11 XAW3D XDBE XIM XINPUT2 XPM LUCID ZLIB

Important settings:
  value of $LANG: fr_FR.UTF-8
  locale-coding-system: utf-8-unix

Major mode: =EE=A4=A6

Minor modes in effect:
  emms-mode-line-mode: t
  emms-playing-time-display-mode: t
  emms-playing-time-mode: t
  bug-reference-prog-mode: t
  server-mode: t
  psession-mode: t
  psession-savehist-mode: t
  global-undo-tree-mode: t
  undo-tree-mode: t
  global-git-gutter-mode: t
  git-gutter-mode: t
  display-time-mode: t
  winner-mode: t
  tv-save-place-mode: t
  helm-epa-mode: t
  helm-descbinds-mode: t
  helm-top-poll-mode: t
  helm-adaptive-mode: t
  helm-mode: t
  helm-minibuffer-history-mode: t
  helm-ff-icon-mode: t
  shell-dirtrack-mode: t
  helm-popup-tip-mode: t
  async-bytecomp-package-mode: t
  dired-async-mode: t
  minibuffer-depth-indicate-mode: t
  gcmh-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  show-paren-mode: t
  mouse-wheel-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  column-number-mode: t
  line-number-mode: t
  auto-fill-function: do-auto-fill
  transient-mark-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t

Load-path shadows:
None found.

Features:
(epa-mail face-remap addressbook-bookmark tv-mu4e-config config-w3m
mu4e-contrib eshell esh-cmd generator esh-ext esh-opt esh-proc esh-io
esh-arg esh-module esh-groups esh-util mu4e-patch mu4e mu4e-org
org-config ob-gnuplot org-crypt org-protocol org ob ob-tangle ob-ref
ob-lob ob-table ob-exp org-macro org-src ob-comint org-pcomplete
org-list org-footnote org-faces org-entities noutline outline
ob-emacs-lisp ob-core ob-eval org-cycle org-table ol org-fold
org-fold-core org-keys oc org-loaddefs org-version org-compat org-macs
mu4e-notification notifications mu4e-main mu4e-view mu4e-mime-parts
gnus-art mm-uu mml2015 mm-view mml-smime smime gnutls dig gnus-sum
gnus-group gnus-undo gnus-start gnus-dbus gnus-cloud nnimap nnmail
mail-source utf7 nnoo gnus-spec gnus-int gnus-range gnus-win gnus
nnheader range appt diary-lib diary-loaddefs cal-menu calendar
cal-loaddefs mu4e-headers mu4e-thread mu4e-compose mu4e-draft
mu4e-actions smtpmail mu4e-search mu4e-lists mu4e-bookmarks mu4e-mark
mu4e-message shr pixel-fill kinsoku url-file svg dom flow-fill hl-line
mu4e-contacts mu4e-update mu4e-folders mu4e-context mu4e-query-items
mu4e-server mu4e-modeline mu4e-vars mu4e-helpers mu4e-config mu4e-window
ido mu4e-obsolete mailalias mailclient textsec uni-scripts idna-mapping
ucs-normalize uni-confusable textsec-check qp helm-dabbrev shadow
mail-extr emacsbug message yank-media puny rfc822 mml mml-sec gnus-util
mm-decode mm-bodies mm-encode mail-parse rfc2231 mailabbrev gmm-utils
mailheader sendmail rfc2047 rfc2045 ietf-drums mm-util mail-prsvr
mail-utils smerge-mode whitespace cl-extra helm-command helm-x-files
helm-for-files helm-bookmark bookmark emms-config emms-mpris
emms-librefm-stream emms-librefm-scrobbler emms-playlist-limit emms-i18n
emms-history emms-score emms-stream-info emms-metaplaylist-mode
emms-bookmarks emms-cue emms-mode-line-icon emms-browser sort
emms-volume emms-volume-sndioctl emms-volume-mixerctl emms-volume-pulse
emms-volume-amixer emms-playlist-sort emms-last-played emms-player-xine
emms-player-mpd tq emms-lyrics emms-url emms-streams emms-show-all
emms-tag-editor emms-tag-tracktag emms-mark emms-mode-line emms-cache
emms-info-native emms-info-spc bindat emms-info-exiftool
emms-info-tinytag emms-info-metaflac emms-info-opusinfo
emms-info-ogginfo emms-info-mp3info emms-playlist-mode emms-player-vlc
emms-player-mpv emms-playing-time emms-info emms-later-do
emms-player-mplayer emms-player-simple emms-source-playlist
emms-source-file locate emms-setup emms emms-compat emms-auto
helm-external helm-net tramp-archive tramp-gvfs tramp-cache time-stamp
zeroconf dbus xml helm-ring helm-elisp helm-eval edebug debug backtrace
find-func helm-info cl-indent helm-ls-git vc-git diff-mode vc
vc-dispatcher jka-compr make-mode flymake-shellcheck cus-start
flymake-proc flymake project warnings thingatpt sh-script smie treesit
executable bug-reference naquadah-theme server imenu psession frameset
undo-tree diff queue pcase git-gutter mule-util dired-extension time
winner describe-variable help-fns radix-tree help-mode tv-utils
tv-save-place.el advice init-helm epa derived epg rfc6068 epg-config
helm-epa isl helm-descbinds cus-edit pp icons wid-edit helm-sys popup
helm-adaptive helm-mode helm-misc helm-files image-dired
image-dired-tags image-dired-external image-dired-util xdg image-mode
exif filenotify tramp tramp-loaddefs trampver tramp-integration files-x
tramp-compat rx shell pcomplete parse-time iso8601 time-date
helm-buffers all-the-icons all-the-icons-faces data-material
data-weathericons data-octicons data-fileicons data-faicons
data-alltheicons helm-occur helm-tags helm-locate helm-grep wgrep-helm
wgrep grep compile text-property-search comint ansi-osc ring helm-regexp
format-spec ansi-color helm-utils helm-help helm-types
helm-extensions-autoloads helm-autoloads helm helm-global-bindings
helm-easymenu edmacro kmacro helm-core easy-mmode async-bytecomp
helm-source helm-multi-match helm-lib dired-async async dired-aux dired
dired-loaddefs mb-depth avoid cus-load gcmh all-the-icons-autoloads
gcmh-autoloads info ledger-mode-autoloads markdown-mode-autoloads
nerd-icons-autoloads w3m-load w3m-autoloads yaml-mode-autoloads package
browse-url url url-proxy url-privacy url-expand url-methods url-history
url-cookie generate-lisp-file url-domsuf url-util mailcap url-handlers
url-parse auth-source cl-seq eieio eieio-core cl-macs password-cache
json subr-x map byte-opt gv bytecomp byte-compile url-vars cl-loaddefs
cl-lib rmc iso-transl tooltip cconv eldoc paren electric uniquify
ediff-hook vc-hooks lisp-float-type elisp-mode mwheel term/x-win x-win
term/common-win x-dnd tool-bar dnd fontset image regexp-opt fringe
tabulated-list replace newcomment text-mode lisp-mode prog-mode register
page tab-bar menu-bar rfn-eshadow isearch easymenu timer select
scroll-bar mouse jit-lock font-lock syntax font-core term/tty-colors
frame minibuffer nadvice seq simple cl-generic indonesian philippine
cham georgian utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao
korean japanese eucjp-ms cp51932 hebrew greek romanian slovak czech
european ethiopic indian cyrillic chinese composite emoji-zwj charscript
charprop case-table epa-hook jka-cmpr-hook help abbrev obarray oclosure
cl-preloaded button loaddefs theme-loaddefs faces cus-face macroexp
files window text-properties overlay sha1 md5 base64 format env
code-pages mule custom widget keymap hashtable-print-readable backquote
threads dbusbind inotify lcms2 dynamic-setting system-font-setting
font-render-setting cairo x-toolkit xinput2 x multi-tty
make-network-process emacs)

Memory information:
((conses 16 854462 334476)
 (symbols 48 35404 26)
 (strings 32 219034 39971)
 (string-bytes 1 6357489)
 (vectors 16 99232)
 (vector-slots 8 2128904 396764)
 (floats 8 1791 2270)
 (intervals 56 37515 32129)
 (buffers 976 138))
<#secure method=3Dpgpmime mode=3Dsign>

--=20
Thierry




Acknowledgement sent to Thierry Volpiatto <thievol@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#66394; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sat, 2 Dec 2023 11:00:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.